/* book-view.c generated by valac 0.38.5, the Vala compiler
 * generated from book-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* FIXME: When scrolling, copy existing render sideways?*/
/* FIXME: Only render pages that change and only the part that changed*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_BOOK_VIEW (book_view_get_type ())
#define BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK_VIEW, BookView))
#define BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK_VIEW, BookViewClass))
#define IS_BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK_VIEW))
#define IS_BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK_VIEW))
#define BOOK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK_VIEW, BookViewClass))

typedef struct _BookView BookView;
typedef struct _BookViewClass BookViewClass;
typedef struct _BookViewPrivate BookViewPrivate;

#define TYPE_BOOK (book_get_type ())
#define BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK, Book))
#define BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK, BookClass))
#define IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK))
#define IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK))
#define BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK, BookClass))

typedef struct _Book Book;
typedef struct _BookClass BookClass;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
enum  {
	BOOK_VIEW_0_PROPERTY,
	BOOK_VIEW_BOOK_PROPERTY,
	BOOK_VIEW_SELECTED_PAGE_PROPERTY,
	BOOK_VIEW_X_OFFSET_PROPERTY,
	BOOK_VIEW_NUM_PROPERTIES
};
static GParamSpec* book_view_properties[BOOK_VIEW_NUM_PROPERTIES];
#define _book_unref0(var) ((var == NULL) ? NULL : (var = (book_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _page_view_unref0(var) ((var == NULL) ? NULL : (var = (page_view_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
#define __g_list_free__page_view_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__page_view_unref0_ (var), NULL)))
enum  {
	BOOK_VIEW_PAGE_SELECTED_SIGNAL,
	BOOK_VIEW_SHOW_PAGE_SIGNAL,
	BOOK_VIEW_SHOW_MENU_SIGNAL,
	BOOK_VIEW_NUM_SIGNALS
};
static guint book_view_signals[BOOK_VIEW_NUM_SIGNALS] = {0};

struct _BookView {
	GtkBox parent_instance;
	BookViewPrivate * priv;
};

struct _BookViewClass {
	GtkBoxClass parent_class;
};

struct _BookViewPrivate {
	Book* _book;
	GHashTable* page_data;
	gboolean need_layout;
	gboolean laying_out;
	gboolean show_selected_page;
	PageView* selected_page_view;
	GtkWidget* drawing_area;
	GtkScrollbar* scroll;
	GtkAdjustment* adjustment;
	GdkCursorType cursor;
};


static gpointer book_view_parent_class = NULL;

GType book_view_get_type (void) G_GNUC_CONST;
gpointer book_ref (gpointer instance);
void book_unref (gpointer instance);
GParamSpec* param_spec_book (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_book (GValue* value, gpointer v_object);
void value_take_book (GValue* value, gpointer v_object);
gpointer value_get_book (const GValue* value);
GType book_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page (GValue* value, gpointer v_object);
void value_take_page (GValue* value, gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
gpointer page_view_ref (gpointer instance);
void page_view_unref (gpointer instance);
GParamSpec* param_spec_page_view (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page_view (GValue* value, gpointer v_object);
void value_take_page_view (GValue* value, gpointer v_object);
gpointer value_get_page_view (const GValue* value);
GType page_view_get_type (void) G_GNUC_CONST;
#define BOOK_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOK_VIEW, BookViewPrivate))
Book* book_view_get_book (BookView* self);
static void book_view_add_cb (BookView* self, Book* book, Page* page);
static void _book_view_add_cb_book_page_added (Book* _sender, Page* page, gpointer self);
static void book_view_remove_cb (BookView* self, Book* book, Page* page);
static void _book_view_remove_cb_book_page_removed (Book* _sender, Page* page, gpointer self);
static void book_view_reorder_cb (BookView* self, Book* book);
static void _book_view_reorder_cb_book_reordered (Book* _sender, gpointer self);
static void book_view_clear_cb (BookView* self, Book* book);
static void _book_view_clear_cb_book_cleared (Book* _sender, gpointer self);
static gboolean book_view_configure_cb (BookView* self, GtkWidget* widget, GdkEventConfigure* event);
static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self);
static gboolean book_view_draw_cb (BookView* self, GtkWidget* widget, cairo_t* context);
static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static gboolean book_view_motion_cb (BookView* self, GtkWidget* widget, GdkEventMotion* event);
static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean book_view_key_cb (BookView* self, GtkWidget* widget, GdkEventKey* event);
static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean book_view_button_cb (BookView* self, GtkWidget* widget, GdkEventButton* event);
static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean book_view_focus_cb (BookView* self, GtkWidget* widget, GdkEventFocus* event);
static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static void book_view_scroll_cb (BookView* self, GtkAdjustment* adjustment);
static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
BookView* book_view_new (Book* book);
BookView* book_view_construct (GType object_type, Book* book);
static void book_view_set_book (BookView* self, Book* value);
guint book_get_n_pages (Book* self);
Page* book_get_page (Book* self, gint page_number);
void book_view_set_selected_page (BookView* self, Page* value);
static void _page_unref0_ (gpointer var);
static void _page_view_unref0_ (gpointer var);
static PageView* book_view_get_nth_page (BookView* self, gint n);
static PageView* book_view_get_next_page (BookView* self, PageView* page);
Page* page_view_get_page (PageView* self);
static PageView* book_view_get_prev_page (BookView* self, PageView* page);
static void book_view_page_view_changed_cb (BookView* self, PageView* page);
void book_view_redraw (BookView* self);
static void book_view_page_view_size_changed_cb (BookView* self, PageView* page);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type, Page* page);
static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender, gpointer self);
static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender, gpointer self);
static void book_view_set_selected_page_view (BookView* self, PageView* page);
void page_view_set_selected (PageView* self, gboolean value);
static void book_view_show_page_view (BookView* self, PageView* page);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_width (PageView* self);
gint book_view_get_x_offset (BookView* self);
void book_view_set_x_offset (BookView* self, gint value);
static void book_view_select_page_view (BookView* self, PageView* page);
Page* book_view_get_selected_page (BookView* self);
static void book_view_layout_into (BookView* self, gint width, gint height, gint* book_width, gint* book_height);
gint page_get_dpi (Page* self);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
void page_view_set_width (PageView* self, gint value);
void page_view_set_height (PageView* self, gint value);
gint page_view_get_height (PageView* self);
void page_view_set_x_offset (PageView* self, gint value);
void page_view_set_y_offset (PageView* self, gint value);
static inline void _g_list_free__page_view_unref0_ (GList* self);
static void book_view_layout (BookView* self);
void page_view_render (PageView* self, cairo_t* context);
gboolean page_view_get_selected (PageView* self);
gint page_view_get_y_offset (PageView* self);
static PageView* book_view_get_page_at (BookView* self, gint x, gint y, gint* x_, gint* y_);
void page_view_button_press (PageView* self, gint x, gint y);
void page_view_button_release (PageView* self, gint x, gint y);
static void book_view_set_cursor (BookView* self, GdkCursorType cursor);
void page_view_motion (PageView* self, gint x, gint y);
GdkCursorType page_view_get_cursor (PageView* self);
void book_view_select_next_page (BookView* self);
void book_view_select_prev_page (BookView* self);
static void g_cclosure_user_marshal_VOID__PAGE (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void book_view_finalize (GObject * obj);
static void _vala_book_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_book_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _book_view_add_cb_book_page_added (Book* _sender, Page* page, gpointer self) {
	book_view_add_cb ((BookView*) self, _sender, page);
}


static void _book_view_remove_cb_book_page_removed (Book* _sender, Page* page, gpointer self) {
	book_view_remove_cb ((BookView*) self, _sender, page);
}


static void _book_view_reorder_cb_book_reordered (Book* _sender, gpointer self) {
	book_view_reorder_cb ((BookView*) self, _sender);
}


static void _book_view_clear_cb_book_cleared (Book* _sender, gpointer self) {
	book_view_clear_cb ((BookView*) self, _sender);
}


static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self) {
	gboolean result;
	result = book_view_configure_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = book_view_draw_cb ((BookView*) self, _sender, cr);
	return result;
}


static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = book_view_motion_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = book_view_key_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
	return result;
}


static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
	return result;
}


static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	book_view_scroll_cb ((BookView*) self, _sender);
}


static void _page_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (page_unref (var), NULL));
}


static void _page_view_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (page_view_unref (var), NULL));
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


BookView* book_view_construct (GType object_type, Book* book) {
	BookView * self = NULL;
	Book* _tmp0_;
	Book* _tmp12_;
	Page* _tmp13_;
	Page* _tmp14_;
	Book* _tmp15_;
	Book* _tmp16_;
	Book* _tmp17_;
	Book* _tmp18_;
	GHashFunc _tmp19_;
	GEqualFunc _tmp20_;
	GHashTable* _tmp21_;
	GtkDrawingArea* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkScrollbar* _tmp27_;
	GtkScrollbar* _tmp28_;
	GtkAdjustment* _tmp29_;
	GtkAdjustment* _tmp30_;
	GtkAdjustment* _tmp31_;
	GtkScrollbar* _tmp32_;
	GtkWidget* _tmp33_;
	GtkWidget* _tmp34_;
	GtkWidget* _tmp35_;
	GtkWidget* _tmp36_;
	GtkWidget* _tmp37_;
	GtkWidget* _tmp38_;
	GtkWidget* _tmp39_;
	GtkWidget* _tmp40_;
	GtkAdjustment* _tmp41_;
	GtkWidget* _tmp42_;
	g_return_val_if_fail (book != NULL, NULL);
	self = (BookView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
	_tmp0_ = book;
	book_view_set_book (self, _tmp0_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				Book* _tmp4_;
				guint _tmp5_;
				guint _tmp6_;
				Page* page = NULL;
				Book* _tmp7_;
				gint _tmp8_;
				Page* _tmp9_;
				Book* _tmp10_;
				Page* _tmp11_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				_tmp4_ = book;
				_tmp5_ = book_get_n_pages (_tmp4_);
				_tmp6_ = _tmp5_;
				if (!(((guint) _tmp3_) < _tmp6_)) {
					break;
				}
				_tmp7_ = book;
				_tmp8_ = i;
				_tmp9_ = book_get_page (_tmp7_, _tmp8_);
				page = _tmp9_;
				_tmp10_ = book;
				_tmp11_ = page;
				book_view_add_cb (self, _tmp10_, _tmp11_);
				_page_unref0 (page);
			}
		}
	}
	_tmp12_ = book;
	_tmp13_ = book_get_page (_tmp12_, 0);
	_tmp14_ = _tmp13_;
	book_view_set_selected_page (self, _tmp14_);
	_page_unref0 (_tmp14_);
	_tmp15_ = book;
	g_signal_connect_object (_tmp15_, "page-added", (GCallback) _book_view_add_cb_book_page_added, self, 0);
	_tmp16_ = book;
	g_signal_connect_object (_tmp16_, "page-removed", (GCallback) _book_view_remove_cb_book_page_removed, self, 0);
	_tmp17_ = book;
	g_signal_connect_object (_tmp17_, "reordered", (GCallback) _book_view_reorder_cb_book_reordered, self, 0);
	_tmp18_ = book;
	g_signal_connect_object (_tmp18_, "cleared", (GCallback) _book_view_clear_cb_book_cleared, self, 0);
	self->priv->need_layout = TRUE;
	_tmp19_ = g_direct_hash;
	_tmp20_ = g_direct_equal;
	_tmp21_ = g_hash_table_new_full (_tmp19_, _tmp20_, _page_unref0_, _page_view_unref0_);
	_g_hash_table_unref0 (self->priv->page_data);
	self->priv->page_data = _tmp21_;
	self->priv->cursor = GDK_ARROW;
	_tmp22_ = (GtkDrawingArea*) gtk_drawing_area_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->drawing_area);
	self->priv->drawing_area = (GtkWidget*) _tmp22_;
	_tmp23_ = self->priv->drawing_area;
	gtk_widget_set_size_request (_tmp23_, 200, 100);
	_tmp24_ = self->priv->drawing_area;
	g_object_set (_tmp24_, "can-focus", TRUE, NULL);
	_tmp25_ = self->priv->drawing_area;
	gtk_widget_set_events (_tmp25_, ((((GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_FOCUS_CHANGE_MASK) | GDK_STRUCTURE_MASK) | GDK_SCROLL_MASK);
	_tmp26_ = self->priv->drawing_area;
	gtk_box_pack_start ((GtkBox*) self, _tmp26_, TRUE, TRUE, (guint) 0);
	_tmp27_ = (GtkScrollbar*) gtk_scrollbar_new (GTK_ORIENTATION_HORIZONTAL, NULL);
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->scroll);
	self->priv->scroll = _tmp27_;
	_tmp28_ = self->priv->scroll;
	_tmp29_ = gtk_range_get_adjustment ((GtkRange*) _tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = _g_object_ref0 (_tmp30_);
	_g_object_unref0 (self->priv->adjustment);
	self->priv->adjustment = _tmp31_;
	_tmp32_ = self->priv->scroll;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp32_, FALSE, TRUE, (guint) 0);
	_tmp33_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp33_, "configure-event", (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self, 0);
	_tmp34_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp34_, "draw", (GCallback) _book_view_draw_cb_gtk_widget_draw, self, 0);
	_tmp35_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp35_, "motion-notify-event", (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self, 0);
	_tmp36_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp36_, "key-press-event", (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self, 0);
	_tmp37_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp37_, "button-press-event", (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self, 0);
	_tmp38_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp38_, "button-release-event", (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self, 0);
	_tmp39_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp39_, "focus-in-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self, G_CONNECT_AFTER);
	_tmp40_ = self->priv->drawing_area;
	g_signal_connect_object (_tmp40_, "focus-out-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self, G_CONNECT_AFTER);
	_tmp41_ = self->priv->adjustment;
	g_signal_connect_object (_tmp41_, "value-changed", (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self, 0);
	_tmp42_ = self->priv->drawing_area;
	gtk_widget_set_visible (_tmp42_, TRUE);
	return self;
}


BookView* book_view_new (Book* book) {
	return book_view_construct (TYPE_BOOK_VIEW, book);
}


static gpointer _page_view_ref0 (gpointer self) {
	return self ? page_view_ref (self) : NULL;
}


static PageView* book_view_get_nth_page (BookView* self, gint n) {
	PageView* result = NULL;
	Page* page = NULL;
	Book* _tmp0_;
	gint _tmp1_;
	Page* _tmp2_;
	GHashTable* _tmp3_;
	gconstpointer _tmp4_;
	PageView* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_book;
	_tmp1_ = n;
	_tmp2_ = book_get_page (_tmp0_, _tmp1_);
	page = _tmp2_;
	_tmp3_ = self->priv->page_data;
	_tmp4_ = g_hash_table_lookup (_tmp3_, page);
	_tmp5_ = _page_view_ref0 ((PageView*) _tmp4_);
	result = _tmp5_;
	_page_unref0 (page);
	return result;
}


static PageView* book_view_get_next_page (BookView* self, PageView* page) {
	PageView* result = NULL;
	PageView* _tmp18_;
	PageView* _tmp19_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (page != NULL, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				Page* p = NULL;
				Book* _tmp2_;
				gint _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				PageView* _tmp7_;
				Page* _tmp8_;
				Page* _tmp9_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_book;
				_tmp3_ = i;
				_tmp4_ = book_get_page (_tmp2_, _tmp3_);
				p = _tmp4_;
				_tmp5_ = p;
				if (_tmp5_ == NULL) {
					_page_unref0 (p);
					break;
				}
				_tmp6_ = p;
				_tmp7_ = page;
				_tmp8_ = page_view_get_page (_tmp7_);
				_tmp9_ = _tmp8_;
				if (_tmp6_ == _tmp9_) {
					Book* _tmp10_;
					gint _tmp11_;
					Page* _tmp12_;
					Page* _tmp13_;
					_tmp10_ = self->priv->_book;
					_tmp11_ = i;
					_tmp12_ = book_get_page (_tmp10_, _tmp11_ + 1);
					_page_unref0 (p);
					p = _tmp12_;
					_tmp13_ = p;
					if (_tmp13_ != NULL) {
						GHashTable* _tmp14_;
						Page* _tmp15_;
						gconstpointer _tmp16_;
						PageView* _tmp17_;
						_tmp14_ = self->priv->page_data;
						_tmp15_ = p;
						_tmp16_ = g_hash_table_lookup (_tmp14_, _tmp15_);
						_tmp17_ = _page_view_ref0 ((PageView*) _tmp16_);
						result = _tmp17_;
						_page_unref0 (p);
						return result;
					}
				}
				_page_unref0 (p);
			}
		}
	}
	_tmp18_ = page;
	_tmp19_ = _page_view_ref0 (_tmp18_);
	result = _tmp19_;
	return result;
}


static PageView* book_view_get_prev_page (BookView* self, PageView* page) {
	PageView* result = NULL;
	PageView* prev_page = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp16_;
	PageView* _tmp17_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (page != NULL, NULL);
	_tmp0_ = page;
	_tmp1_ = _page_view_ref0 (_tmp0_);
	prev_page = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				Page* p = NULL;
				Book* _tmp4_;
				gint _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
				Page* _tmp8_;
				PageView* _tmp9_;
				Page* _tmp10_;
				Page* _tmp11_;
				GHashTable* _tmp12_;
				Page* _tmp13_;
				gconstpointer _tmp14_;
				PageView* _tmp15_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->priv->_book;
				_tmp5_ = i;
				_tmp6_ = book_get_page (_tmp4_, _tmp5_);
				p = _tmp6_;
				_tmp7_ = p;
				if (_tmp7_ == NULL) {
					_page_unref0 (p);
					break;
				}
				_tmp8_ = p;
				_tmp9_ = page;
				_tmp10_ = page_view_get_page (_tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp8_ == _tmp11_) {
					result = prev_page;
					_page_unref0 (p);
					return result;
				}
				_tmp12_ = self->priv->page_data;
				_tmp13_ = p;
				_tmp14_ = g_hash_table_lookup (_tmp12_, _tmp13_);
				_tmp15_ = _page_view_ref0 ((PageView*) _tmp14_);
				_page_view_unref0 (prev_page);
				prev_page = _tmp15_;
				_page_unref0 (p);
			}
		}
	}
	_tmp16_ = page;
	_tmp17_ = _page_view_ref0 (_tmp16_);
	result = _tmp17_;
	_page_view_unref0 (prev_page);
	return result;
}


static void book_view_page_view_changed_cb (BookView* self, PageView* page) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	book_view_redraw (self);
}


static void book_view_page_view_size_changed_cb (BookView* self, PageView* page) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	self->priv->need_layout = TRUE;
	book_view_redraw (self);
}


static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender, gpointer self) {
	book_view_page_view_changed_cb ((BookView*) self, _sender);
}


static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender, gpointer self) {
	book_view_page_view_size_changed_cb ((BookView*) self, _sender);
}


static gpointer _page_ref0 (gpointer self) {
	return self ? page_ref (self) : NULL;
}


static void book_view_add_cb (BookView* self, Book* book, Page* page) {
	PageView* page_view = NULL;
	Page* _tmp0_;
	PageView* _tmp1_;
	GHashTable* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	PageView* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (book != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page;
	_tmp1_ = page_view_new (_tmp0_);
	page_view = _tmp1_;
	g_signal_connect_object (page_view, "changed", (GCallback) _book_view_page_view_changed_cb_page_view_changed, self, 0);
	g_signal_connect_object (page_view, "size-changed", (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self, 0);
	_tmp2_ = self->priv->page_data;
	_tmp3_ = page;
	_tmp4_ = _page_ref0 (_tmp3_);
	_tmp5_ = _page_view_ref0 (page_view);
	g_hash_table_insert (_tmp2_, _tmp4_, _tmp5_);
	self->priv->need_layout = TRUE;
	book_view_redraw (self);
	_page_view_unref0 (page_view);
}


static void book_view_set_selected_page_view (BookView* self, PageView* page) {
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	PageView* _tmp5_;
	PageView* _tmp6_;
	PageView* _tmp7_;
	GtkWidget* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->selected_page_view;
	if (_tmp1_ != NULL) {
		PageView* _tmp2_;
		PageView* _tmp3_;
		_tmp2_ = page;
		_tmp3_ = self->priv->selected_page_view;
		_tmp0_ = _tmp2_ != _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		PageView* _tmp4_;
		_tmp4_ = self->priv->selected_page_view;
		page_view_set_selected (_tmp4_, TRUE);
	}
	_tmp5_ = page;
	_tmp6_ = _page_view_ref0 (_tmp5_);
	_page_view_unref0 (self->priv->selected_page_view);
	self->priv->selected_page_view = _tmp6_;
	_tmp7_ = self->priv->selected_page_view;
	if (_tmp7_ == NULL) {
		return;
	}
	_tmp8_ = self->priv->drawing_area;
	g_object_get (_tmp8_, "has-focus", &_tmp9_, NULL);
	_tmp10_ = _tmp9_;
	if (!_tmp10_) {
		PageView* _tmp11_;
		_tmp11_ = self->priv->selected_page_view;
		page_view_set_selected (_tmp11_, FALSE);
	} else {
		PageView* _tmp12_;
		_tmp12_ = self->priv->selected_page_view;
		page_view_set_selected (_tmp12_, TRUE);
	}
}


static void book_view_show_page_view (BookView* self, PageView* page) {
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp4_;
	GtkAllocation _tmp5_ = {0};
	gint left_edge = 0;
	PageView* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint right_edge = 0;
	PageView* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PageView* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp1_ = page;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GtkScrollbar* _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = self->priv->scroll;
		_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
		_tmp0_ = !_tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = self->priv->drawing_area;
	gtk_widget_get_allocation (_tmp4_, &_tmp5_);
	allocation = _tmp5_;
	_tmp6_ = page;
	_tmp7_ = page_view_get_x_offset (_tmp6_);
	_tmp8_ = _tmp7_;
	left_edge = _tmp8_;
	_tmp9_ = page;
	_tmp10_ = page_view_get_x_offset (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = page;
	_tmp13_ = page_view_get_width (_tmp12_);
	_tmp14_ = _tmp13_;
	right_edge = _tmp11_ + _tmp14_;
	_tmp15_ = left_edge;
	_tmp16_ = book_view_get_x_offset (self);
	_tmp17_ = _tmp16_;
	if ((_tmp15_ - _tmp17_) < 0) {
		gint _tmp18_;
		_tmp18_ = left_edge;
		book_view_set_x_offset (self, _tmp18_);
	} else {
		gint _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		GtkAllocation _tmp22_;
		gint _tmp23_;
		_tmp19_ = right_edge;
		_tmp20_ = book_view_get_x_offset (self);
		_tmp21_ = _tmp20_;
		_tmp22_ = allocation;
		_tmp23_ = _tmp22_.width;
		if ((_tmp19_ - _tmp21_) > _tmp23_) {
			gint _tmp24_;
			GtkAllocation _tmp25_;
			gint _tmp26_;
			_tmp24_ = right_edge;
			_tmp25_ = allocation;
			_tmp26_ = _tmp25_.width;
			book_view_set_x_offset (self, _tmp24_ - _tmp26_);
		}
	}
}


static void book_view_select_page_view (BookView* self, PageView* page) {
	Page* p = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
	gboolean _tmp3_;
	PageView* _tmp5_;
	Page* _tmp10_;
	g_return_if_fail (self != NULL);
	p = NULL;
	_tmp0_ = self->priv->selected_page_view;
	_tmp1_ = page;
	if (_tmp0_ == _tmp1_) {
		_page_unref0 (p);
		return;
	}
	_tmp2_ = page;
	book_view_set_selected_page_view (self, _tmp2_);
	_tmp3_ = self->priv->need_layout;
	if (_tmp3_) {
		self->priv->show_selected_page = TRUE;
	} else {
		PageView* _tmp4_;
		_tmp4_ = page;
		book_view_show_page_view (self, _tmp4_);
	}
	_tmp5_ = page;
	if (_tmp5_ != NULL) {
		PageView* _tmp6_;
		Page* _tmp7_;
		Page* _tmp8_;
		Page* _tmp9_;
		_tmp6_ = page;
		_tmp7_ = page_view_get_page (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _page_ref0 (_tmp8_);
		_page_unref0 (p);
		p = _tmp9_;
	}
	_tmp10_ = p;
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, _tmp10_);
	_page_unref0 (p);
}


static void book_view_remove_cb (BookView* self, Book* book, Page* page) {
	PageView* new_selection = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	PageView* page_view = NULL;
	GHashTable* _tmp11_;
	Page* _tmp12_;
	gconstpointer _tmp13_;
	PageView* _tmp14_;
	guint _tmp15_;
	guint _tmp16_;
	GHashTable* _tmp17_;
	Page* _tmp18_;
	PageView* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (book != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = self->priv->selected_page_view;
	_tmp1_ = _page_view_ref0 (_tmp0_);
	new_selection = _tmp1_;
	_tmp2_ = page;
	_tmp3_ = book_view_get_selected_page (self);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == _tmp4_) {
		PageView* _tmp5_;
		PageView* _tmp6_;
		PageView* _tmp7_;
		PageView* _tmp8_;
		_tmp5_ = self->priv->selected_page_view;
		_tmp6_ = book_view_get_prev_page (self, _tmp5_);
		_page_view_unref0 (new_selection);
		new_selection = _tmp6_;
		_tmp7_ = new_selection;
		_tmp8_ = self->priv->selected_page_view;
		if (_tmp7_ == _tmp8_) {
			PageView* _tmp9_;
			PageView* _tmp10_;
			_tmp9_ = self->priv->selected_page_view;
			_tmp10_ = book_view_get_next_page (self, _tmp9_);
			_page_view_unref0 (new_selection);
			new_selection = _tmp10_;
		}
		_page_view_unref0 (self->priv->selected_page_view);
		self->priv->selected_page_view = NULL;
	}
	_tmp11_ = self->priv->page_data;
	_tmp12_ = page;
	_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
	_tmp14_ = _page_view_ref0 ((PageView*) _tmp13_);
	page_view = _tmp14_;
	g_signal_parse_name ("changed", TYPE_PAGE_VIEW, &_tmp15_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_page_view_changed_cb_page_view_changed, self);
	g_signal_parse_name ("size-changed", TYPE_PAGE_VIEW, &_tmp16_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self);
	_tmp17_ = self->priv->page_data;
	_tmp18_ = page;
	g_hash_table_remove (_tmp17_, _tmp18_);
	_tmp19_ = new_selection;
	book_view_select_page_view (self, _tmp19_);
	self->priv->need_layout = TRUE;
	book_view_redraw (self);
	_page_view_unref0 (page_view);
	_page_view_unref0 (new_selection);
}


static void book_view_reorder_cb (BookView* self, Book* book) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (book != NULL);
	self->priv->need_layout = TRUE;
	book_view_redraw (self);
}


static void book_view_clear_cb (BookView* self, Book* book) {
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (book != NULL);
	_tmp0_ = self->priv->page_data;
	g_hash_table_remove_all (_tmp0_);
	_page_view_unref0 (self->priv->selected_page_view);
	self->priv->selected_page_view = NULL;
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, NULL);
	self->priv->need_layout = TRUE;
	book_view_redraw (self);
}


static gboolean book_view_configure_cb (BookView* self, GtkWidget* widget, GdkEventConfigure* event) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	self->priv->need_layout = TRUE;
	result = FALSE;
	return result;
}


static inline void _g_list_free__page_view_unref0_ (GList* self) {
	g_list_free_full (self, (GDestroyNotify) _page_view_unref0_);
}


static void book_view_layout_into (BookView* self, gint width, gint height, gint* book_width, gint* book_height) {
	gint _vala_book_width = 0;
	gint _vala_book_height = 0;
	GList* pages = NULL;
	gint max_dpi = 0;
	GList* _tmp8_;
	gint max_width = 0;
	gint max_height = 0;
	GList* _tmp21_;
	gdouble aspect = 0.0;
	gint _tmp49_;
	gint _tmp50_;
	gdouble max_aspect = 0.0;
	gint _tmp51_;
	gint _tmp52_;
	gint spacing = 0;
	GList* _tmp53_;
	GList* _tmp94_;
	gint x_offset = 0;
	GList* _tmp97_;
	g_return_if_fail (self != NULL);
	pages = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				Book* _tmp3_;
				guint _tmp4_;
				guint _tmp5_;
				gint _tmp6_;
				PageView* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->_book;
				_tmp4_ = book_get_n_pages (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(((guint) _tmp2_) < _tmp5_)) {
					break;
				}
				_tmp6_ = i;
				_tmp7_ = book_view_get_nth_page (self, _tmp6_);
				pages = g_list_append (pages, _tmp7_);
			}
		}
	}
	max_dpi = 0;
	_tmp8_ = pages;
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
		page_collection = _tmp8_;
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
			PageView* _tmp9_;
			PageView* page = NULL;
			_tmp9_ = _page_view_ref0 ((PageView*) page_it->data);
			page = _tmp9_;
			{
				Page* p = NULL;
				PageView* _tmp10_;
				Page* _tmp11_;
				Page* _tmp12_;
				Page* _tmp13_;
				Page* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				_tmp10_ = page;
				_tmp11_ = page_view_get_page (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = _page_ref0 (_tmp12_);
				p = _tmp13_;
				_tmp14_ = p;
				_tmp15_ = page_get_dpi (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = max_dpi;
				if (_tmp16_ > _tmp17_) {
					Page* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					_tmp18_ = p;
					_tmp19_ = page_get_dpi (_tmp18_);
					_tmp20_ = _tmp19_;
					max_dpi = _tmp20_;
				}
				_page_unref0 (p);
				_page_view_unref0 (page);
			}
		}
	}
	max_width = 0;
	max_height = 0;
	_tmp21_ = pages;
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
		page_collection = _tmp21_;
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
			PageView* _tmp22_;
			PageView* page = NULL;
			_tmp22_ = _page_view_ref0 ((PageView*) page_it->data);
			page = _tmp22_;
			{
				Page* p = NULL;
				PageView* _tmp23_;
				Page* _tmp24_;
				Page* _tmp25_;
				Page* _tmp26_;
				gint w = 0;
				Page* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint h = 0;
				Page* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				Page* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				Page* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp46_;
				gint _tmp47_;
				_tmp23_ = page;
				_tmp24_ = page_view_get_page (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = _page_ref0 (_tmp25_);
				p = _tmp26_;
				_tmp27_ = p;
				_tmp28_ = page_get_width (_tmp27_);
				_tmp29_ = _tmp28_;
				w = _tmp29_;
				_tmp30_ = p;
				_tmp31_ = page_get_height (_tmp30_);
				_tmp32_ = _tmp31_;
				h = _tmp32_;
				_tmp33_ = w;
				_tmp34_ = max_dpi;
				_tmp35_ = p;
				_tmp36_ = page_get_dpi (_tmp35_);
				_tmp37_ = _tmp36_;
				w = (gint) (((((gdouble) _tmp33_) * _tmp34_) / _tmp37_) + 0.5);
				_tmp38_ = h;
				_tmp39_ = max_dpi;
				_tmp40_ = p;
				_tmp41_ = page_get_dpi (_tmp40_);
				_tmp42_ = _tmp41_;
				h = (gint) (((((gdouble) _tmp38_) * _tmp39_) / _tmp42_) + 0.5);
				_tmp43_ = w;
				_tmp44_ = max_width;
				if (_tmp43_ > _tmp44_) {
					gint _tmp45_;
					_tmp45_ = w;
					max_width = _tmp45_;
				}
				_tmp46_ = h;
				_tmp47_ = max_height;
				if (_tmp46_ > _tmp47_) {
					gint _tmp48_;
					_tmp48_ = h;
					max_height = _tmp48_;
				}
				_page_unref0 (p);
				_page_view_unref0 (page);
			}
		}
	}
	_tmp49_ = width;
	_tmp50_ = height;
	aspect = ((gdouble) _tmp49_) / _tmp50_;
	_tmp51_ = max_width;
	_tmp52_ = max_height;
	max_aspect = ((gdouble) _tmp51_) / _tmp52_;
	spacing = 12;
	_vala_book_width = 0;
	_vala_book_height = 0;
	_tmp53_ = pages;
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
		page_collection = _tmp53_;
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
			PageView* _tmp54_;
			PageView* page = NULL;
			_tmp54_ = _page_view_ref0 ((PageView*) page_it->data);
			page = _tmp54_;
			{
				Page* p = NULL;
				PageView* _tmp55_;
				Page* _tmp56_;
				Page* _tmp57_;
				Page* _tmp58_;
				gdouble _tmp59_;
				gdouble _tmp60_;
				gint h = 0;
				PageView* _tmp83_;
				gint _tmp84_;
				gint _tmp85_;
				gint _tmp86_;
				gint _tmp87_;
				gint _tmp89_;
				PageView* _tmp90_;
				gint _tmp91_;
				gint _tmp92_;
				gint _tmp93_;
				_tmp55_ = page;
				_tmp56_ = page_view_get_page (_tmp55_);
				_tmp57_ = _tmp56_;
				_tmp58_ = _page_ref0 (_tmp57_);
				p = _tmp58_;
				_tmp59_ = max_aspect;
				_tmp60_ = aspect;
				if (_tmp59_ > _tmp60_) {
					gint w = 0;
					Page* _tmp61_;
					gint _tmp62_;
					gint _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					Page* _tmp66_;
					gint _tmp67_;
					gint _tmp68_;
					gint _tmp69_;
					PageView* _tmp70_;
					gint _tmp71_;
					_tmp61_ = p;
					_tmp62_ = page_get_width (_tmp61_);
					_tmp63_ = _tmp62_;
					_tmp64_ = max_dpi;
					_tmp65_ = width;
					_tmp66_ = p;
					_tmp67_ = page_get_dpi (_tmp66_);
					_tmp68_ = _tmp67_;
					_tmp69_ = max_width;
					w = (gint) (((((gdouble) _tmp63_) * _tmp64_) * _tmp65_) / (_tmp68_ * _tmp69_));
					_tmp70_ = page;
					_tmp71_ = w;
					page_view_set_width (_tmp70_, _tmp71_);
				} else {
					gint h = 0;
					Page* _tmp72_;
					gint _tmp73_;
					gint _tmp74_;
					gint _tmp75_;
					gint _tmp76_;
					Page* _tmp77_;
					gint _tmp78_;
					gint _tmp79_;
					gint _tmp80_;
					PageView* _tmp81_;
					gint _tmp82_;
					_tmp72_ = p;
					_tmp73_ = page_get_height (_tmp72_);
					_tmp74_ = _tmp73_;
					_tmp75_ = max_dpi;
					_tmp76_ = height;
					_tmp77_ = p;
					_tmp78_ = page_get_dpi (_tmp77_);
					_tmp79_ = _tmp78_;
					_tmp80_ = max_height;
					h = (gint) (((((gdouble) _tmp74_) * _tmp75_) * _tmp76_) / (_tmp79_ * _tmp80_));
					_tmp81_ = page;
					_tmp82_ = h;
					page_view_set_height (_tmp81_, _tmp82_);
				}
				_tmp83_ = page;
				_tmp84_ = page_view_get_height (_tmp83_);
				_tmp85_ = _tmp84_;
				h = _tmp85_;
				_tmp86_ = h;
				_tmp87_ = _vala_book_height;
				if (_tmp86_ > _tmp87_) {
					gint _tmp88_;
					_tmp88_ = h;
					_vala_book_height = _tmp88_;
				}
				_tmp89_ = _vala_book_width;
				_tmp90_ = page;
				_tmp91_ = page_view_get_width (_tmp90_);
				_tmp92_ = _tmp91_;
				_tmp93_ = spacing;
				_vala_book_width = _tmp89_ + (_tmp92_ + _tmp93_);
				_page_unref0 (p);
				_page_view_unref0 (page);
			}
		}
	}
	_tmp94_ = pages;
	if (_tmp94_ != NULL) {
		gint _tmp95_;
		gint _tmp96_;
		_tmp95_ = _vala_book_width;
		_tmp96_ = spacing;
		_vala_book_width = _tmp95_ - _tmp96_;
	}
	x_offset = 0;
	_tmp97_ = pages;
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
		page_collection = _tmp97_;
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
			PageView* _tmp98_;
			PageView* page = NULL;
			_tmp98_ = _page_view_ref0 ((PageView*) page_it->data);
			page = _tmp98_;
			{
				PageView* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
				PageView* _tmp102_;
				gint _tmp103_;
				gint _tmp104_;
				gint _tmp105_;
				PageView* _tmp106_;
				gint _tmp107_;
				PageView* _tmp108_;
				gint _tmp109_;
				gint _tmp110_;
				_tmp99_ = page;
				_tmp100_ = x_offset;
				page_view_set_x_offset (_tmp99_, _tmp100_);
				_tmp101_ = x_offset;
				_tmp102_ = page;
				_tmp103_ = page_view_get_width (_tmp102_);
				_tmp104_ = _tmp103_;
				_tmp105_ = spacing;
				x_offset = _tmp101_ + (_tmp104_ + _tmp105_);
				_tmp106_ = page;
				_tmp107_ = height;
				_tmp108_ = page;
				_tmp109_ = page_view_get_height (_tmp108_);
				_tmp110_ = _tmp109_;
				page_view_set_y_offset (_tmp106_, (_tmp107_ - _tmp110_) / 2);
				_page_view_unref0 (page);
			}
		}
	}
	__g_list_free__page_view_unref0_0 (pages);
	if (book_width) {
		*book_width = _vala_book_width;
	}
	if (book_height) {
		*book_height = _vala_book_height;
	}
}


static void book_view_layout (BookView* self) {
	gboolean _tmp0_;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp1_;
	GtkAllocation _tmp2_ = {0};
	GtkAllocation box_allocation = {0};
	GtkAllocation _tmp3_ = {0};
	gboolean right_aligned = FALSE;
	GtkAdjustment* _tmp4_;
	gdouble _tmp5_;
	GtkAdjustment* _tmp6_;
	gdouble _tmp7_;
	GtkAdjustment* _tmp8_;
	gdouble _tmp9_;
	gint width = 0;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	gint height = 0;
	GtkAllocation _tmp12_;
	gint _tmp13_;
	guint _tmp14_;
	gint book_width = 0;
	gint book_height = 0;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_;
	GtkAllocation _tmp20_;
	gint _tmp21_;
	gboolean _tmp54_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->need_layout;
	if (!_tmp0_) {
		return;
	}
	self->priv->laying_out = TRUE;
	_tmp1_ = self->priv->drawing_area;
	gtk_widget_get_allocation (_tmp1_, &_tmp2_);
	allocation = _tmp2_;
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
	box_allocation = _tmp3_;
	right_aligned = TRUE;
	_tmp4_ = self->priv->adjustment;
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
	_tmp6_ = self->priv->adjustment;
	_tmp7_ = gtk_adjustment_get_upper (_tmp6_);
	_tmp8_ = self->priv->adjustment;
	_tmp9_ = gtk_adjustment_get_page_size (_tmp8_);
	if (_tmp5_ < (_tmp7_ - _tmp9_)) {
		right_aligned = FALSE;
	}
	_tmp10_ = allocation;
	_tmp11_ = _tmp10_.width;
	width = (gint) _tmp11_;
	_tmp12_ = box_allocation;
	_tmp13_ = _tmp12_.height;
	_tmp14_ = gtk_container_get_border_width ((GtkContainer*) self);
	height = (gint) (_tmp13_ - (_tmp14_ * 2));
	_tmp15_ = width;
	_tmp16_ = height;
	book_view_layout_into (self, _tmp15_, _tmp16_, &_tmp17_, &_tmp18_);
	book_width = _tmp17_;
	book_height = _tmp18_;
	_tmp19_ = book_width;
	_tmp20_ = allocation;
	_tmp21_ = _tmp20_.width;
	if (_tmp19_ > _tmp21_) {
		GtkAllocation _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		GtkAdjustment* _tmp28_;
		GtkAdjustment* _tmp29_;
		gint _tmp30_;
		GtkAdjustment* _tmp31_;
		GtkAllocation _tmp32_;
		gint _tmp33_;
		gint max_offset = 0;
		gint _tmp34_;
		GtkAllocation _tmp35_;
		gint _tmp36_;
		gboolean _tmp37_ = FALSE;
		gboolean _tmp38_;
		GtkScrollbar* _tmp43_;
		_tmp22_ = allocation;
		_tmp23_ = _tmp22_.height;
		height = _tmp23_;
		_tmp24_ = width;
		_tmp25_ = height;
		book_view_layout_into (self, _tmp24_, _tmp25_, &_tmp26_, &_tmp27_);
		book_width = _tmp26_;
		book_height = _tmp27_;
		_tmp28_ = self->priv->adjustment;
		gtk_adjustment_set_lower (_tmp28_, (gdouble) 0);
		_tmp29_ = self->priv->adjustment;
		_tmp30_ = book_width;
		gtk_adjustment_set_upper (_tmp29_, (gdouble) _tmp30_);
		_tmp31_ = self->priv->adjustment;
		_tmp32_ = allocation;
		_tmp33_ = _tmp32_.width;
		gtk_adjustment_set_page_size (_tmp31_, (gdouble) _tmp33_);
		_tmp34_ = book_width;
		_tmp35_ = allocation;
		_tmp36_ = _tmp35_.width;
		max_offset = _tmp34_ - _tmp36_;
		_tmp38_ = right_aligned;
		if (_tmp38_) {
			_tmp37_ = TRUE;
		} else {
			gint _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			_tmp39_ = book_view_get_x_offset (self);
			_tmp40_ = _tmp39_;
			_tmp41_ = max_offset;
			_tmp37_ = _tmp40_ > _tmp41_;
		}
		if (_tmp37_) {
			gint _tmp42_;
			_tmp42_ = max_offset;
			book_view_set_x_offset (self, _tmp42_);
		}
		_tmp43_ = self->priv->scroll;
		gtk_widget_set_visible ((GtkWidget*) _tmp43_, TRUE);
	} else {
		GtkScrollbar* _tmp44_;
		gint offset = 0;
		gint _tmp45_;
		GtkAllocation _tmp46_;
		gint _tmp47_;
		GtkAdjustment* _tmp48_;
		gint _tmp49_;
		GtkAdjustment* _tmp50_;
		gint _tmp51_;
		GtkAdjustment* _tmp52_;
		gint _tmp53_;
		_tmp44_ = self->priv->scroll;
		gtk_widget_set_visible ((GtkWidget*) _tmp44_, FALSE);
		_tmp45_ = book_width;
		_tmp46_ = allocation;
		_tmp47_ = _tmp46_.width;
		offset = (_tmp45_ - _tmp47_) / 2;
		_tmp48_ = self->priv->adjustment;
		_tmp49_ = offset;
		gtk_adjustment_set_lower (_tmp48_, (gdouble) _tmp49_);
		_tmp50_ = self->priv->adjustment;
		_tmp51_ = offset;
		gtk_adjustment_set_upper (_tmp50_, (gdouble) _tmp51_);
		_tmp52_ = self->priv->adjustment;
		gtk_adjustment_set_page_size (_tmp52_, (gdouble) 0);
		_tmp53_ = offset;
		book_view_set_x_offset (self, _tmp53_);
	}
	_tmp54_ = self->priv->show_selected_page;
	if (_tmp54_) {
		PageView* _tmp55_;
		_tmp55_ = self->priv->selected_page_view;
		book_view_show_page_view (self, _tmp55_);
	}
	self->priv->need_layout = FALSE;
	self->priv->show_selected_page = FALSE;
	self->priv->laying_out = FALSE;
}


static gboolean book_view_draw_cb (BookView* self, GtkWidget* widget, cairo_t* context) {
	gboolean result = FALSE;
	gdouble left = 0.0;
	gdouble top = 0.0;
	gdouble right = 0.0;
	gdouble bottom = 0.0;
	cairo_t* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	GList* pages = NULL;
	GList* _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	book_view_layout (self);
	_tmp0_ = context;
	cairo_clip_extents (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	left = _tmp1_;
	top = _tmp2_;
	right = _tmp3_;
	bottom = _tmp4_;
	pages = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				Book* _tmp8_;
				guint _tmp9_;
				guint _tmp10_;
				gint _tmp11_;
				PageView* _tmp12_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = self->priv->_book;
				_tmp9_ = book_get_n_pages (_tmp8_);
				_tmp10_ = _tmp9_;
				if (!(((guint) _tmp7_) < _tmp10_)) {
					break;
				}
				_tmp11_ = i;
				_tmp12_ = book_view_get_nth_page (self, _tmp11_);
				pages = g_list_append (pages, _tmp12_);
			}
		}
	}
	_tmp13_ = pages;
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
		page_collection = _tmp13_;
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
			PageView* _tmp14_;
			PageView* page = NULL;
			_tmp14_ = _page_view_ref0 ((PageView*) page_it->data);
			page = _tmp14_;
			{
				gint left_edge = 0;
				PageView* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint right_edge = 0;
				PageView* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				PageView* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				gdouble _tmp30_;
				cairo_t* _tmp33_;
				cairo_t* _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				PageView* _tmp37_;
				cairo_t* _tmp38_;
				cairo_t* _tmp39_;
				PageView* _tmp40_;
				gboolean _tmp41_;
				gboolean _tmp42_;
				_tmp15_ = page;
				_tmp16_ = page_view_get_x_offset (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = book_view_get_x_offset (self);
				_tmp19_ = _tmp18_;
				left_edge = _tmp17_ - _tmp19_;
				_tmp20_ = page;
				_tmp21_ = page_view_get_x_offset (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = page;
				_tmp24_ = page_view_get_width (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = book_view_get_x_offset (self);
				_tmp27_ = _tmp26_;
				right_edge = (_tmp22_ + _tmp25_) - _tmp27_;
				_tmp29_ = right_edge;
				_tmp30_ = left;
				if (((gdouble) _tmp29_) < _tmp30_) {
					_tmp28_ = TRUE;
				} else {
					gint _tmp31_;
					gdouble _tmp32_;
					_tmp31_ = left_edge;
					_tmp32_ = right;
					_tmp28_ = ((gdouble) _tmp31_) > _tmp32_;
				}
				if (_tmp28_) {
					_page_view_unref0 (page);
					continue;
				}
				_tmp33_ = context;
				cairo_save (_tmp33_);
				_tmp34_ = context;
				_tmp35_ = book_view_get_x_offset (self);
				_tmp36_ = _tmp35_;
				cairo_translate (_tmp34_, (gdouble) (-_tmp36_), (gdouble) 0);
				_tmp37_ = page;
				_tmp38_ = context;
				page_view_render (_tmp37_, _tmp38_);
				_tmp39_ = context;
				cairo_restore (_tmp39_);
				_tmp40_ = page;
				_tmp41_ = page_view_get_selected (_tmp40_);
				_tmp42_ = _tmp41_;
				if (_tmp42_) {
					GtkWidget* _tmp43_;
					GtkStyleContext* _tmp44_;
					cairo_t* _tmp45_;
					PageView* _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					gint _tmp50_;
					PageView* _tmp51_;
					gint _tmp52_;
					gint _tmp53_;
					PageView* _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					PageView* _tmp57_;
					gint _tmp58_;
					gint _tmp59_;
					_tmp43_ = self->priv->drawing_area;
					_tmp44_ = gtk_widget_get_style_context (_tmp43_);
					_tmp45_ = context;
					_tmp46_ = page;
					_tmp47_ = page_view_get_x_offset (_tmp46_);
					_tmp48_ = _tmp47_;
					_tmp49_ = book_view_get_x_offset (self);
					_tmp50_ = _tmp49_;
					_tmp51_ = page;
					_tmp52_ = page_view_get_y_offset (_tmp51_);
					_tmp53_ = _tmp52_;
					_tmp54_ = page;
					_tmp55_ = page_view_get_width (_tmp54_);
					_tmp56_ = _tmp55_;
					_tmp57_ = page;
					_tmp58_ = page_view_get_height (_tmp57_);
					_tmp59_ = _tmp58_;
					gtk_render_focus (_tmp44_, _tmp45_, (gdouble) (_tmp48_ - _tmp50_), (gdouble) _tmp53_, (gdouble) _tmp56_, (gdouble) _tmp59_);
				}
				_page_view_unref0 (page);
			}
		}
	}
	result = FALSE;
	__g_list_free__page_view_unref0_0 (pages);
	return result;
}


static PageView* book_view_get_page_at (BookView* self, gint x, gint y, gint* x_, gint* y_) {
	gint _vala_x_ = 0;
	gint _vala_y_ = 0;
	PageView* result = NULL;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_y_ = 0;
	_tmp0_ = _vala_y_;
	_vala_x_ = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				Book* _tmp4_;
				guint _tmp5_;
				guint _tmp6_;
				PageView* page = NULL;
				gint _tmp7_;
				PageView* _tmp8_;
				gint left = 0;
				PageView* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint right = 0;
				gint _tmp12_;
				PageView* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint top = 0;
				PageView* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint bottom = 0;
				gint _tmp19_;
				PageView* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gint _tmp26_;
				gint _tmp27_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				_tmp4_ = self->priv->_book;
				_tmp5_ = book_get_n_pages (_tmp4_);
				_tmp6_ = _tmp5_;
				if (!(((guint) _tmp3_) < _tmp6_)) {
					break;
				}
				_tmp7_ = i;
				_tmp8_ = book_view_get_nth_page (self, _tmp7_);
				page = _tmp8_;
				_tmp9_ = page;
				_tmp10_ = page_view_get_x_offset (_tmp9_);
				_tmp11_ = _tmp10_;
				left = _tmp11_;
				_tmp12_ = left;
				_tmp13_ = page;
				_tmp14_ = page_view_get_width (_tmp13_);
				_tmp15_ = _tmp14_;
				right = _tmp12_ + _tmp15_;
				_tmp16_ = page;
				_tmp17_ = page_view_get_y_offset (_tmp16_);
				_tmp18_ = _tmp17_;
				top = _tmp18_;
				_tmp19_ = top;
				_tmp20_ = page;
				_tmp21_ = page_view_get_height (_tmp20_);
				_tmp22_ = _tmp21_;
				bottom = _tmp19_ + _tmp22_;
				_tmp26_ = x;
				_tmp27_ = left;
				if (_tmp26_ >= _tmp27_) {
					gint _tmp28_;
					gint _tmp29_;
					_tmp28_ = x;
					_tmp29_ = right;
					_tmp25_ = _tmp28_ <= _tmp29_;
				} else {
					_tmp25_ = FALSE;
				}
				if (_tmp25_) {
					gint _tmp30_;
					gint _tmp31_;
					_tmp30_ = y;
					_tmp31_ = top;
					_tmp24_ = _tmp30_ >= _tmp31_;
				} else {
					_tmp24_ = FALSE;
				}
				if (_tmp24_) {
					gint _tmp32_;
					gint _tmp33_;
					_tmp32_ = y;
					_tmp33_ = bottom;
					_tmp23_ = _tmp32_ <= _tmp33_;
				} else {
					_tmp23_ = FALSE;
				}
				if (_tmp23_) {
					gint _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
					gint _tmp37_;
					_tmp34_ = x;
					_tmp35_ = left;
					_vala_x_ = _tmp34_ - _tmp35_;
					_tmp36_ = y;
					_tmp37_ = top;
					_vala_y_ = _tmp36_ - _tmp37_;
					result = page;
					if (x_) {
						*x_ = _vala_x_;
					}
					if (y_) {
						*y_ = _vala_y_;
					}
					return result;
				}
				_page_view_unref0 (page);
			}
		}
	}
	result = NULL;
	if (x_) {
		*x_ = _vala_x_;
	}
	if (y_) {
		*y_ = _vala_y_;
	}
	return result;
}


static gboolean book_view_button_cb (BookView* self, GtkWidget* widget, GdkEventButton* event) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	gint x = 0;
	gint y = 0;
	GdkEventButton* _tmp1_;
	GdkEventType _tmp2_;
	PageView* _tmp13_;
	GdkEventButton* _tmp14_;
	guint _tmp15_;
	GdkEventButton* _tmp30_;
	guint _tmp31_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	book_view_layout (self);
	_tmp0_ = self->priv->drawing_area;
	gtk_widget_grab_focus (_tmp0_);
	x = 0;
	y = 0;
	_tmp1_ = event;
	_tmp2_ = _tmp1_->type;
	if (_tmp2_ == GDK_BUTTON_PRESS) {
		GdkEventButton* _tmp3_;
		gdouble _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkEventButton* _tmp7_;
		gdouble _tmp8_;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		PageView* _tmp11_;
		PageView* _tmp12_;
		_tmp3_ = event;
		_tmp4_ = _tmp3_->x;
		_tmp5_ = book_view_get_x_offset (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = event;
		_tmp8_ = _tmp7_->y;
		_tmp11_ = book_view_get_page_at (self, (gint) (_tmp4_ + _tmp6_), (gint) _tmp8_, &_tmp9_, &_tmp10_);
		x = _tmp9_;
		y = _tmp10_;
		_tmp12_ = _tmp11_;
		book_view_select_page_view (self, _tmp12_);
		_page_view_unref0 (_tmp12_);
	}
	_tmp13_ = self->priv->selected_page_view;
	if (_tmp13_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp14_ = event;
	_tmp15_ = _tmp14_->button;
	if (_tmp15_ == ((guint) 1)) {
		GdkEventButton* _tmp16_;
		GdkEventType _tmp17_;
		_tmp16_ = event;
		_tmp17_ = _tmp16_->type;
		if (_tmp17_ == GDK_BUTTON_PRESS) {
			PageView* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			_tmp18_ = self->priv->selected_page_view;
			_tmp19_ = x;
			_tmp20_ = y;
			page_view_button_press (_tmp18_, _tmp19_, _tmp20_);
		} else {
			GdkEventButton* _tmp21_;
			GdkEventType _tmp22_;
			_tmp21_ = event;
			_tmp22_ = _tmp21_->type;
			if (_tmp22_ == GDK_BUTTON_RELEASE) {
				PageView* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				_tmp23_ = self->priv->selected_page_view;
				_tmp24_ = x;
				_tmp25_ = y;
				page_view_button_release (_tmp23_, _tmp24_, _tmp25_);
			} else {
				GdkEventButton* _tmp26_;
				GdkEventType _tmp27_;
				_tmp26_ = event;
				_tmp27_ = _tmp26_->type;
				if (_tmp27_ == GDK_2BUTTON_PRESS) {
					Page* _tmp28_;
					Page* _tmp29_;
					_tmp28_ = book_view_get_selected_page (self);
					_tmp29_ = _tmp28_;
					g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL], 0, _tmp29_);
				}
			}
		}
	}
	_tmp30_ = event;
	_tmp31_ = _tmp30_->button;
	if (_tmp31_ == ((guint) 3)) {
		g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL], 0);
	}
	result = FALSE;
	return result;
}


static void book_view_set_cursor (BookView* self, GdkCursorType cursor) {
	GdkCursor* c = NULL;
	GdkCursorType _tmp0_;
	GdkCursorType _tmp1_;
	GdkCursorType _tmp2_;
	GdkDisplay* _tmp3_;
	GdkCursorType _tmp4_;
	GdkCursor* _tmp5_;
	GtkWidget* _tmp6_;
	GdkWindow* _tmp7_;
	GdkCursor* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cursor;
	_tmp1_ = cursor;
	if (_tmp0_ == _tmp1_) {
		_g_object_unref0 (c);
		return;
	}
	_tmp2_ = cursor;
	self->priv->cursor = _tmp2_;
	_tmp3_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp4_ = cursor;
	_tmp5_ = gdk_cursor_new_for_display (_tmp3_, _tmp4_);
	_g_object_unref0 (c);
	c = _tmp5_;
	_tmp6_ = self->priv->drawing_area;
	_tmp7_ = gtk_widget_get_window (_tmp6_);
	_tmp8_ = c;
	gdk_window_set_cursor (_tmp7_, _tmp8_);
	_g_object_unref0 (c);
}


static gboolean book_view_motion_cb (BookView* self, GtkWidget* widget, GdkEventMotion* event) {
	gboolean result = FALSE;
	GdkCursorType cursor = 0;
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	GdkCursorType _tmp38_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	cursor = GDK_ARROW;
	_tmp1_ = self->priv->selected_page_view;
	if (_tmp1_ != NULL) {
		GdkEventMotion* _tmp2_;
		GdkModifierType _tmp3_;
		_tmp2_ = event;
		_tmp3_ = _tmp2_->state;
		_tmp0_ = (_tmp3_ & GDK_BUTTON1_MASK) != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint x = 0;
		GdkEventMotion* _tmp4_;
		gdouble _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		PageView* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint y = 0;
		GdkEventMotion* _tmp11_;
		gdouble _tmp12_;
		PageView* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		PageView* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		PageView* _tmp19_;
		GdkCursorType _tmp20_;
		GdkCursorType _tmp21_;
		_tmp4_ = event;
		_tmp5_ = _tmp4_->x;
		_tmp6_ = book_view_get_x_offset (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->selected_page_view;
		_tmp9_ = page_view_get_x_offset (_tmp8_);
		_tmp10_ = _tmp9_;
		x = (gint) ((_tmp5_ + _tmp7_) - _tmp10_);
		_tmp11_ = event;
		_tmp12_ = _tmp11_->y;
		_tmp13_ = self->priv->selected_page_view;
		_tmp14_ = page_view_get_y_offset (_tmp13_);
		_tmp15_ = _tmp14_;
		y = (gint) (_tmp12_ - _tmp15_);
		_tmp16_ = self->priv->selected_page_view;
		_tmp17_ = x;
		_tmp18_ = y;
		page_view_motion (_tmp16_, _tmp17_, _tmp18_);
		_tmp19_ = self->priv->selected_page_view;
		_tmp20_ = page_view_get_cursor (_tmp19_);
		_tmp21_ = _tmp20_;
		cursor = _tmp21_;
	} else {
		gint x = 0;
		gint y = 0;
		PageView* over_page = NULL;
		GdkEventMotion* _tmp22_;
		gdouble _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		GdkEventMotion* _tmp26_;
		gdouble _tmp27_;
		gint _tmp28_ = 0;
		gint _tmp29_ = 0;
		PageView* _tmp30_;
		PageView* _tmp31_;
		_tmp22_ = event;
		_tmp23_ = _tmp22_->x;
		_tmp24_ = book_view_get_x_offset (self);
		_tmp25_ = _tmp24_;
		_tmp26_ = event;
		_tmp27_ = _tmp26_->y;
		_tmp30_ = book_view_get_page_at (self, (gint) (_tmp23_ + _tmp25_), (gint) _tmp27_, &_tmp28_, &_tmp29_);
		x = _tmp28_;
		y = _tmp29_;
		over_page = _tmp30_;
		_tmp31_ = over_page;
		if (_tmp31_ != NULL) {
			PageView* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			PageView* _tmp35_;
			GdkCursorType _tmp36_;
			GdkCursorType _tmp37_;
			_tmp32_ = over_page;
			_tmp33_ = x;
			_tmp34_ = y;
			page_view_motion (_tmp32_, _tmp33_, _tmp34_);
			_tmp35_ = over_page;
			_tmp36_ = page_view_get_cursor (_tmp35_);
			_tmp37_ = _tmp36_;
			cursor = _tmp37_;
		}
		_page_view_unref0 (over_page);
	}
	_tmp38_ = cursor;
	book_view_set_cursor (self, _tmp38_);
	result = FALSE;
	return result;
}


static gboolean book_view_key_cb (BookView* self, GtkWidget* widget, GdkEventKey* event) {
	gboolean result = FALSE;
	GdkEventKey* _tmp0_;
	guint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->keyval;
	switch (_tmp1_) {
		case 0xff50:
		{
			Book* _tmp2_;
			Page* _tmp3_;
			Page* _tmp4_;
			_tmp2_ = self->priv->_book;
			_tmp3_ = book_get_page (_tmp2_, 0);
			_tmp4_ = _tmp3_;
			book_view_set_selected_page (self, _tmp4_);
			_page_unref0 (_tmp4_);
			result = TRUE;
			return result;
		}
		case 0xff51:
		{
			PageView* _tmp5_;
			PageView* _tmp6_;
			PageView* _tmp7_;
			_tmp5_ = self->priv->selected_page_view;
			_tmp6_ = book_view_get_prev_page (self, _tmp5_);
			_tmp7_ = _tmp6_;
			book_view_select_page_view (self, _tmp7_);
			_page_view_unref0 (_tmp7_);
			result = TRUE;
			return result;
		}
		case 0xff53:
		{
			PageView* _tmp8_;
			PageView* _tmp9_;
			PageView* _tmp10_;
			_tmp8_ = self->priv->selected_page_view;
			_tmp9_ = book_view_get_next_page (self, _tmp8_);
			_tmp10_ = _tmp9_;
			book_view_select_page_view (self, _tmp10_);
			_page_view_unref0 (_tmp10_);
			result = TRUE;
			return result;
		}
		case 0xFF57:
		{
			Book* _tmp11_;
			Book* _tmp12_;
			guint _tmp13_;
			guint _tmp14_;
			Page* _tmp15_;
			Page* _tmp16_;
			_tmp11_ = self->priv->_book;
			_tmp12_ = self->priv->_book;
			_tmp13_ = book_get_n_pages (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = book_get_page (_tmp11_, ((gint) _tmp14_) - 1);
			_tmp16_ = _tmp15_;
			book_view_set_selected_page (self, _tmp16_);
			_page_unref0 (_tmp16_);
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}


static gboolean book_view_focus_cb (BookView* self, GtkWidget* widget, GdkEventFocus* event) {
	gboolean result = FALSE;
	PageView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->selected_page_view;
	book_view_set_selected_page_view (self, _tmp0_);
	result = FALSE;
	return result;
}


static void book_view_scroll_cb (BookView* self, GtkAdjustment* adjustment) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (adjustment != NULL);
	_tmp0_ = self->priv->laying_out;
	if (!_tmp0_) {
		book_view_redraw (self);
	}
}


void book_view_redraw (BookView* self) {
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->drawing_area;
	gtk_widget_queue_draw (_tmp0_);
}


void book_view_select_next_page (BookView* self) {
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->selected_page_view;
	_tmp1_ = book_view_get_next_page (self, _tmp0_);
	_tmp2_ = _tmp1_;
	book_view_select_page_view (self, _tmp2_);
	_page_view_unref0 (_tmp2_);
}


void book_view_select_prev_page (BookView* self) {
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->selected_page_view;
	_tmp1_ = book_view_get_prev_page (self, _tmp0_);
	_tmp2_ = _tmp1_;
	book_view_select_page_view (self, _tmp2_);
	_page_view_unref0 (_tmp2_);
}


Book* book_view_get_book (BookView* self) {
	Book* result;
	Book* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_book;
	result = _tmp0_;
	return result;
}


static gpointer _book_ref0 (gpointer self) {
	return self ? book_ref (self) : NULL;
}


static void book_view_set_book (BookView* self, Book* value) {
	g_return_if_fail (self != NULL);
	if (book_view_get_book (self) != value) {
		Book* _tmp0_;
		Book* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _book_ref0 (_tmp0_);
		_book_unref0 (self->priv->_book);
		self->priv->_book = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_BOOK_PROPERTY]);
	}
}


Page* book_view_get_selected_page (BookView* self) {
	Page* result;
	PageView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->selected_page_view;
	if (_tmp0_ != NULL) {
		PageView* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
		_tmp1_ = self->priv->selected_page_view;
		_tmp2_ = page_view_get_page (_tmp1_);
		_tmp3_ = _tmp2_;
		result = _tmp3_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}


void book_view_set_selected_page (BookView* self, Page* value) {
	Page* _tmp0_;
	Page* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = book_view_get_selected_page (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = value;
	if (_tmp1_ == _tmp2_) {
		return;
	}
	_tmp3_ = value;
	if (_tmp3_ != NULL) {
		GHashTable* _tmp4_;
		Page* _tmp5_;
		gconstpointer _tmp6_;
		_tmp4_ = self->priv->page_data;
		_tmp5_ = value;
		_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
		book_view_select_page_view (self, (PageView*) _tmp6_);
	} else {
		book_view_select_page_view (self, NULL);
	}
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY]);
}


gint book_view_get_x_offset (BookView* self) {
	gint result;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	result = (gint) _tmp1_;
	return result;
}


void book_view_set_x_offset (BookView* self, gint value) {
	GtkAdjustment* _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->adjustment;
	_tmp1_ = value;
	gtk_adjustment_set_value (_tmp0_, (gdouble) _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY]);
}


static void g_cclosure_user_marshal_VOID__PAGE (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__PAGE) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__PAGE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__PAGE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_page (param_values + 1), data2);
}


static void book_view_class_init (BookViewClass * klass) {
	book_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BookViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_book_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_book_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = book_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_BOOK_PROPERTY, book_view_properties[BOOK_VIEW_BOOK_PROPERTY] = param_spec_book ("book", "book", "book", TYPE_BOOK, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_SELECTED_PAGE_PROPERTY, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY] = param_spec_page ("selected-page", "selected-page", "selected-page", TYPE_PAGE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_X_OFFSET_PROPERTY, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL] = g_signal_new ("page-selected", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__PAGE, G_TYPE_NONE, 1, TYPE_PAGE);
	book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL] = g_signal_new ("show-page", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__PAGE, G_TYPE_NONE, 1, TYPE_PAGE);
	book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL] = g_signal_new ("show-menu", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void book_view_instance_init (BookView * self) {
	self->priv = BOOK_VIEW_GET_PRIVATE (self);
	self->priv->selected_page_view = NULL;
}


static void book_view_finalize (GObject * obj) {
	BookView * self;
	Book* _tmp0_;
	guint _tmp1_;
	Book* _tmp2_;
	guint _tmp3_;
	Book* _tmp4_;
	guint _tmp5_;
	Book* _tmp6_;
	guint _tmp7_;
	GtkWidget* _tmp8_;
	guint _tmp9_;
	GtkWidget* _tmp10_;
	guint _tmp11_;
	GtkWidget* _tmp12_;
	guint _tmp13_;
	GtkWidget* _tmp14_;
	guint _tmp15_;
	GtkWidget* _tmp16_;
	guint _tmp17_;
	GtkWidget* _tmp18_;
	guint _tmp19_;
	GtkWidget* _tmp20_;
	guint _tmp21_;
	GtkWidget* _tmp22_;
	guint _tmp23_;
	GtkAdjustment* _tmp24_;
	guint _tmp25_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOK_VIEW, BookView);
	_tmp0_ = self->priv->_book;
	g_signal_parse_name ("page-added", TYPE_BOOK, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _book_view_add_cb_book_page_added, self);
	_tmp2_ = self->priv->_book;
	g_signal_parse_name ("page-removed", TYPE_BOOK, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _book_view_remove_cb_book_page_removed, self);
	_tmp4_ = self->priv->_book;
	g_signal_parse_name ("reordered", TYPE_BOOK, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _book_view_reorder_cb_book_reordered, self);
	_tmp6_ = self->priv->_book;
	g_signal_parse_name ("cleared", TYPE_BOOK, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _book_view_clear_cb_book_cleared, self);
	_tmp8_ = self->priv->drawing_area;
	g_signal_parse_name ("configure-event", gtk_widget_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self);
	_tmp10_ = self->priv->drawing_area;
	g_signal_parse_name ("draw", gtk_widget_get_type (), &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _book_view_draw_cb_gtk_widget_draw, self);
	_tmp12_ = self->priv->drawing_area;
	g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp13_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self);
	_tmp14_ = self->priv->drawing_area;
	g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp15_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self);
	_tmp16_ = self->priv->drawing_area;
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp17_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self);
	_tmp18_ = self->priv->drawing_area;
	g_signal_parse_name ("button-release-event", gtk_widget_get_type (), &_tmp19_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self);
	_tmp20_ = self->priv->drawing_area;
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp21_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self);
	_tmp22_ = self->priv->drawing_area;
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp23_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self);
	_tmp24_ = self->priv->adjustment;
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp25_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self);
	_book_unref0 (self->priv->_book);
	_g_hash_table_unref0 (self->priv->page_data);
	_page_view_unref0 (self->priv->selected_page_view);
	_g_object_unref0 (self->priv->drawing_area);
	_g_object_unref0 (self->priv->scroll);
	_g_object_unref0 (self->priv->adjustment);
	G_OBJECT_CLASS (book_view_parent_class)->finalize (obj);
}


GType book_view_get_type (void) {
	static volatile gsize book_view_type_id__volatile = 0;
	if (g_once_init_enter (&book_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) book_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookView), 0, (GInstanceInitFunc) book_view_instance_init, NULL };
		GType book_view_type_id;
		book_view_type_id = g_type_register_static (gtk_box_get_type (), "BookView", &g_define_type_info, 0);
		g_once_init_leave (&book_view_type_id__volatile, book_view_type_id);
	}
	return book_view_type_id__volatile;
}


static void _vala_book_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
	switch (property_id) {
		case BOOK_VIEW_BOOK_PROPERTY:
		value_set_book (value, book_view_get_book (self));
		break;
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
		value_set_page (value, book_view_get_selected_page (self));
		break;
		case BOOK_VIEW_X_OFFSET_PROPERTY:
		g_value_set_int (value, book_view_get_x_offset (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_book_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
	switch (property_id) {
		case BOOK_VIEW_BOOK_PROPERTY:
		book_view_set_book (self, value_get_book (value));
		break;
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
		book_view_set_selected_page (self, value_get_page (value));
		break;
		case BOOK_VIEW_X_OFFSET_PROPERTY:
		book_view_set_x_offset (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



