/* page-view.c generated by valac 0.38.5, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPageView ParamSpecPageView;
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;

struct _PageView {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GTypeClass parent_class;
	void (*finalize) (PageView *self);
};

typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};

struct _ParamSpecPageView {
	GParamSpec parent_instance;
};


static gpointer page_view_parent_class = NULL;

GType crop_location_get_type (void) G_GNUC_CONST;
gpointer page_view_ref (gpointer instance);
void page_view_unref (gpointer instance);
GParamSpec* param_spec_page_view (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page_view (GValue* value, gpointer v_object);
void value_take_page_view (GValue* value, gpointer v_object);
gpointer value_get_page_view (const GValue* value);
GType page_view_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page (GValue* value, gpointer v_object);
void value_take_page (GValue* value, gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
GType scan_direction_get_type (void) G_GNUC_CONST;
#define PAGE_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE_VIEW, PageViewPrivate))
Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self, Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender, gpointer self);
static void page_view_page_size_changed_cb (PageView* self, Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender, gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self, Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender, gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender, gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self, Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender, gpointer self);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type, Page* page);
static void page_view_set_page (PageView* self, Page* value);
static guchar page_view_get_sample (PageView* self, guchar* pixels, int pixels_length1, gint offset, gint x, gint depth, gint sample);
static void page_view_get_pixel (PageView* self, Page* page, gint x, gint y, guchar* pixel, int pixel_length1);
ScanDirection page_get_scan_direction (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_scan_height (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
guchar* page_get_pixels (Page* self, int* result_length1);
gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self, Page* page, gdouble l, gdouble r, gdouble t, gdouble b, guchar* output, int output_length1, gint offset);
static void page_view_update_preview (PageView* self, Page* page, GdkPixbuf* * output_image, gint output_width, gint output_height, ScanDirection scan_direction, gint old_scan_line, gint scan_line);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self, gint x);
static gint page_view_page_to_screen_y (PageView* self, gint y);
static gint page_view_screen_to_page_x (PageView* self, gint x);
static gint page_view_screen_to_page_y (PageView* self, gint y);
static CropLocation page_view_get_crop_location (PageView* self, gint x, gint y);
gboolean page_get_has_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
const gchar* page_get_crop_name (Page* self);
void page_view_button_press (PageView* self, gint x, gint y);
void page_view_motion (PageView* self, gint x, gint y);
static void page_view_set_cursor (PageView* self, GdkCursorType value);
void page_move_crop (Page* self, gint x, gint y);
void page_set_custom_crop (Page* self, gint width, gint height);
void page_view_button_release (PageView* self, gint x, gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
void page_view_render (PageView* self, cairo_t* context);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_y_offset (PageView* self);
gboolean page_view_get_selected (PageView* self);
void page_view_set_selected (PageView* self, gboolean value);
void page_view_set_x_offset (PageView* self, gint value);
void page_view_set_y_offset (PageView* self, gint value);
GdkCursorType page_view_get_cursor (PageView* self);
gint page_view_get_width (PageView* self);
void page_view_set_width (PageView* self, gint value);
gint page_view_get_height (PageView* self);
void page_view_set_height (PageView* self, gint value);
static void page_view_finalize (PageView * obj);


GType crop_location_get_type (void) {
	static volatile gsize crop_location_type_id__volatile = 0;
	if (g_once_init_enter (&crop_location_type_id__volatile)) {
		static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType crop_location_type_id;
		crop_location_type_id = g_enum_register_static ("CropLocation", values);
		g_once_init_leave (&crop_location_type_id__volatile, crop_location_type_id);
	}
	return crop_location_type_id__volatile;
}


static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender, gpointer self) {
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
}


static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender, gpointer self) {
	page_view_page_size_changed_cb ((PageView*) self, _sender);
}


static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender, gpointer self) {
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender, gpointer self) {
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
}


static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender, gpointer self) {
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
}


PageView* page_view_construct (GType object_type, Page* page) {
	PageView* self = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	Page* _tmp5_;
	g_return_val_if_fail (page != NULL, NULL);
	self = (PageView*) g_type_create_instance (object_type);
	_tmp0_ = page;
	page_view_set_page (self, _tmp0_);
	_tmp1_ = page;
	g_signal_connect (_tmp1_, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
	_tmp2_ = page;
	g_signal_connect (_tmp2_, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
	_tmp3_ = page;
	g_signal_connect (_tmp3_, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
	_tmp4_ = page;
	g_signal_connect (_tmp4_, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
	_tmp5_ = page;
	g_signal_connect (_tmp5_, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
	return self;
}


PageView* page_view_new (Page* page) {
	return page_view_construct (TYPE_PAGE_VIEW, page);
}


static guchar page_view_get_sample (PageView* self, guchar* pixels, int pixels_length1, gint offset, gint x, gint depth, gint sample) {
	guchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = (guchar) 0xFF;
	return result;
}


static void page_view_get_pixel (PageView* self, Page* page, gint x, gint y, guchar* pixel, int pixel_length1) {
	Page* _tmp0_;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
	gint depth = 0;
	Page* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint n_channels = 0;
	Page* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	guchar* pixels = NULL;
	Page* _tmp29_;
	gint _tmp30_;
	guchar* _tmp31_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	Page* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_ = FALSE;
	gint _tmp37_;
	guchar* _tmp105_;
	gint _tmp105__length1;
	guchar* _tmp106_;
	gint _tmp106__length1;
	gint _tmp107_;
	gint _tmp108_;
	gint _tmp109_;
	gint _tmp110_;
	gint _tmp111_;
	guchar _tmp112_;
	guchar _tmp113_;
	guchar* _tmp114_;
	gint _tmp114__length1;
	guchar* _tmp115_;
	gint _tmp115__length1;
	gint _tmp116_;
	gint _tmp117_;
	gint _tmp118_;
	gint _tmp119_;
	gint _tmp120_;
	guchar _tmp121_;
	guchar _tmp122_;
	guchar* _tmp123_;
	gint _tmp123__length1;
	guchar* _tmp124_;
	gint _tmp124__length1;
	gint _tmp125_;
	gint _tmp126_;
	gint _tmp127_;
	gint _tmp128_;
	gint _tmp129_;
	guchar _tmp130_;
	guchar _tmp131_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page;
	_tmp1_ = page_get_scan_direction (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			Page* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			Page* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			_tmp3_ = page;
			_tmp4_ = page_get_scan_width (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp6_ = x;
			x = (_tmp5_ - _tmp6_) - 1;
			_tmp7_ = page;
			_tmp8_ = page_get_scan_height (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = y;
			y = (_tmp9_ - _tmp10_) - 1;
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			gint t = 0;
			gint _tmp11_;
			Page* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp11_ = x;
			t = _tmp11_;
			_tmp12_ = page;
			_tmp13_ = page_get_scan_width (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = y;
			x = (_tmp14_ - _tmp15_) - 1;
			_tmp16_ = t;
			y = _tmp16_;
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			gint t = 0;
			gint _tmp17_;
			gint _tmp18_;
			Page* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			_tmp17_ = x;
			t = _tmp17_;
			_tmp18_ = y;
			x = _tmp18_;
			_tmp19_ = page;
			_tmp20_ = page_get_scan_height (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = t;
			y = (_tmp21_ - _tmp22_) - 1;
			break;
		}
		default:
		break;
	}
	_tmp23_ = page;
	_tmp24_ = page_get_depth (_tmp23_);
	_tmp25_ = _tmp24_;
	depth = _tmp25_;
	_tmp26_ = page;
	_tmp27_ = page_get_n_channels (_tmp26_);
	_tmp28_ = _tmp27_;
	n_channels = _tmp28_;
	_tmp29_ = page;
	_tmp31_ = page_get_pixels (_tmp29_, &_tmp30_);
	pixels = _tmp31_;
	pixels_length1 = _tmp30_;
	_pixels_size_ = pixels_length1;
	_tmp32_ = page;
	_tmp33_ = page_get_rowstride (_tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = y;
	offset = _tmp34_ * _tmp35_;
	_tmp37_ = depth;
	if (_tmp37_ == 8) {
		gint _tmp38_;
		_tmp38_ = n_channels;
		_tmp36_ = _tmp38_ == 3;
	} else {
		_tmp36_ = FALSE;
	}
	if (_tmp36_) {
		gint o = 0;
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		guchar* _tmp42_;
		gint _tmp42__length1;
		guchar* _tmp43_;
		gint _tmp43__length1;
		gint _tmp44_;
		guchar _tmp45_;
		guchar _tmp46_;
		guchar* _tmp47_;
		gint _tmp47__length1;
		guchar* _tmp48_;
		gint _tmp48__length1;
		gint _tmp49_;
		guchar _tmp50_;
		guchar _tmp51_;
		guchar* _tmp52_;
		gint _tmp52__length1;
		guchar* _tmp53_;
		gint _tmp53__length1;
		gint _tmp54_;
		guchar _tmp55_;
		guchar _tmp56_;
		_tmp39_ = offset;
		_tmp40_ = x;
		_tmp41_ = n_channels;
		o = _tmp39_ + (_tmp40_ * _tmp41_);
		_tmp42_ = pixel;
		_tmp42__length1 = pixel_length1;
		_tmp43_ = pixels;
		_tmp43__length1 = pixels_length1;
		_tmp44_ = o;
		_tmp45_ = _tmp43_[_tmp44_];
		_tmp42_[0] = _tmp45_;
		_tmp46_ = _tmp42_[0];
		_tmp47_ = pixel;
		_tmp47__length1 = pixel_length1;
		_tmp48_ = pixels;
		_tmp48__length1 = pixels_length1;
		_tmp49_ = o;
		_tmp50_ = _tmp48_[_tmp49_ + 1];
		_tmp47_[1] = _tmp50_;
		_tmp51_ = _tmp47_[1];
		_tmp52_ = pixel;
		_tmp52__length1 = pixel_length1;
		_tmp53_ = pixels;
		_tmp53__length1 = pixels_length1;
		_tmp54_ = o;
		_tmp55_ = _tmp53_[_tmp54_ + 2];
		_tmp52_[2] = _tmp55_;
		_tmp56_ = _tmp52_[2];
		return;
	} else {
		gboolean _tmp57_ = FALSE;
		gint _tmp58_;
		_tmp58_ = depth;
		if (_tmp58_ == 8) {
			gint _tmp59_;
			_tmp59_ = n_channels;
			_tmp57_ = _tmp59_ == 1;
		} else {
			_tmp57_ = FALSE;
		}
		if (_tmp57_) {
			guchar* _tmp60_;
			gint _tmp60__length1;
			guchar* _tmp61_;
			gint _tmp61__length1;
			guchar* _tmp62_;
			gint _tmp62__length1;
			guchar* _tmp63_;
			gint _tmp63__length1;
			gint _tmp64_;
			gint _tmp65_;
			guchar _tmp66_;
			guchar _tmp67_;
			guchar _tmp68_;
			guchar _tmp69_;
			_tmp60_ = pixel;
			_tmp60__length1 = pixel_length1;
			_tmp61_ = pixel;
			_tmp61__length1 = pixel_length1;
			_tmp62_ = pixel;
			_tmp62__length1 = pixel_length1;
			_tmp63_ = pixels;
			_tmp63__length1 = pixels_length1;
			_tmp64_ = offset;
			_tmp65_ = x;
			_tmp66_ = _tmp63_[_tmp64_ + _tmp65_];
			_tmp62_[2] = _tmp66_;
			_tmp67_ = _tmp62_[2];
			_tmp61_[1] = _tmp67_;
			_tmp68_ = _tmp61_[1];
			_tmp60_[0] = _tmp68_;
			_tmp69_ = _tmp60_[0];
			return;
		} else {
			gboolean _tmp70_ = FALSE;
			gint _tmp71_;
			_tmp71_ = depth;
			if (_tmp71_ == 1) {
				gint _tmp72_;
				_tmp72_ = n_channels;
				_tmp70_ = _tmp72_ == 1;
			} else {
				_tmp70_ = FALSE;
			}
			if (_tmp70_) {
				gint o = 0;
				gint _tmp73_;
				gint _tmp74_;
				gint _tmp75_ = 0;
				guchar* _tmp76_;
				gint _tmp76__length1;
				gint _tmp77_;
				guchar _tmp78_;
				gint _tmp79_;
				guchar* _tmp80_;
				gint _tmp80__length1;
				guchar* _tmp81_;
				gint _tmp81__length1;
				guchar* _tmp82_;
				gint _tmp82__length1;
				guchar _tmp83_;
				guchar _tmp84_;
				guchar _tmp85_;
				_tmp73_ = offset;
				_tmp74_ = x;
				o = _tmp73_ + (_tmp74_ / 8);
				_tmp76_ = pixels;
				_tmp76__length1 = pixels_length1;
				_tmp77_ = o;
				_tmp78_ = _tmp76_[_tmp77_];
				_tmp79_ = x;
				if (((gint) (_tmp78_ & (0x80 >> (_tmp79_ % 8)))) != 0) {
					_tmp75_ = 0x00;
				} else {
					_tmp75_ = 0xFF;
				}
				_tmp80_ = pixel;
				_tmp80__length1 = pixel_length1;
				_tmp81_ = pixel;
				_tmp81__length1 = pixel_length1;
				_tmp82_ = pixel;
				_tmp82__length1 = pixel_length1;
				_tmp82_[2] = (guchar) _tmp75_;
				_tmp83_ = _tmp82_[2];
				_tmp81_[1] = _tmp83_;
				_tmp84_ = _tmp81_[1];
				_tmp80_[0] = _tmp84_;
				_tmp85_ = _tmp80_[0];
				return;
			} else {
				gboolean _tmp86_ = FALSE;
				gint _tmp87_;
				_tmp87_ = depth;
				if (_tmp87_ == 2) {
					gint _tmp88_;
					_tmp88_ = n_channels;
					_tmp86_ = _tmp88_ == 1;
				} else {
					_tmp86_ = FALSE;
				}
				if (_tmp86_) {
					gint block_shift[4] = {0};
					gint _tmp89_[4] = {0};
					gint o = 0;
					gint _tmp90_;
					gint _tmp91_;
					gint sample = 0;
					guchar* _tmp92_;
					gint _tmp92__length1;
					gint _tmp93_;
					guchar _tmp94_;
					gint _tmp95_;
					gint _tmp96_;
					gint _tmp97_;
					guchar* _tmp98_;
					gint _tmp98__length1;
					guchar* _tmp99_;
					gint _tmp99__length1;
					guchar* _tmp100_;
					gint _tmp100__length1;
					gint _tmp101_;
					guchar _tmp102_;
					guchar _tmp103_;
					guchar _tmp104_;
					_tmp89_[0] = 6;
					_tmp89_[1] = 4;
					_tmp89_[2] = 2;
					_tmp89_[3] = 0;
					memcpy (block_shift, _tmp89_, 4 * sizeof (gint));
					_tmp90_ = offset;
					_tmp91_ = x;
					o = _tmp90_ + (_tmp91_ / 4);
					_tmp92_ = pixels;
					_tmp92__length1 = pixels_length1;
					_tmp93_ = o;
					_tmp94_ = _tmp92_[_tmp93_];
					_tmp95_ = x;
					_tmp96_ = block_shift[_tmp95_ % 4];
					sample = (_tmp94_ >> _tmp96_) & 0x3;
					_tmp97_ = sample;
					sample = (_tmp97_ * 255) / 3;
					_tmp98_ = pixel;
					_tmp98__length1 = pixel_length1;
					_tmp99_ = pixel;
					_tmp99__length1 = pixel_length1;
					_tmp100_ = pixel;
					_tmp100__length1 = pixel_length1;
					_tmp101_ = sample;
					_tmp100_[2] = (guchar) _tmp101_;
					_tmp102_ = _tmp100_[2];
					_tmp99_[1] = _tmp102_;
					_tmp103_ = _tmp99_[1];
					_tmp98_[0] = _tmp103_;
					_tmp104_ = _tmp98_[0];
					return;
				}
			}
		}
	}
	_tmp105_ = pixel;
	_tmp105__length1 = pixel_length1;
	_tmp106_ = pixels;
	_tmp106__length1 = pixels_length1;
	_tmp107_ = offset;
	_tmp108_ = x;
	_tmp109_ = depth;
	_tmp110_ = x;
	_tmp111_ = n_channels;
	_tmp112_ = page_view_get_sample (self, _tmp106_, _tmp106__length1, _tmp107_, _tmp108_, _tmp109_, _tmp110_ * _tmp111_);
	_tmp105_[0] = _tmp112_;
	_tmp113_ = _tmp105_[0];
	_tmp114_ = pixel;
	_tmp114__length1 = pixel_length1;
	_tmp115_ = pixels;
	_tmp115__length1 = pixels_length1;
	_tmp116_ = offset;
	_tmp117_ = x;
	_tmp118_ = depth;
	_tmp119_ = x;
	_tmp120_ = n_channels;
	_tmp121_ = page_view_get_sample (self, _tmp115_, _tmp115__length1, _tmp116_, _tmp117_, _tmp118_, (_tmp119_ * _tmp120_) + 1);
	_tmp114_[1] = _tmp121_;
	_tmp122_ = _tmp114_[1];
	_tmp123_ = pixel;
	_tmp123__length1 = pixel_length1;
	_tmp124_ = pixels;
	_tmp124__length1 = pixels_length1;
	_tmp125_ = offset;
	_tmp126_ = x;
	_tmp127_ = depth;
	_tmp128_ = x;
	_tmp129_ = n_channels;
	_tmp130_ = page_view_get_sample (self, _tmp124_, _tmp124__length1, _tmp125_, _tmp126_, _tmp127_, (_tmp128_ * _tmp129_) + 2);
	_tmp123_[2] = _tmp130_;
	_tmp131_ = _tmp123_[2];
}


static void page_view_set_pixel (PageView* self, Page* page, gdouble l, gdouble r, gdouble t, gdouble b, guchar* output, int output_length1, gint offset) {
	gint L = 0;
	gdouble _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gint R = 0;
	gdouble _tmp4_;
	gint T = 0;
	gdouble _tmp5_;
	gint _tmp6_;
	gdouble _tmp7_;
	gint B = 0;
	gdouble _tmp9_;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gboolean _tmp283_ = FALSE;
	gdouble _tmp284_;
	gint _tmp285_;
	gboolean _tmp309_ = FALSE;
	gdouble _tmp310_;
	gint _tmp311_;
	gboolean _tmp335_ = FALSE;
	gdouble _tmp336_;
	gint _tmp337_;
	gboolean _tmp361_ = FALSE;
	gdouble _tmp362_;
	gint _tmp363_;
	gdouble scale = 0.0;
	gdouble _tmp387_;
	gdouble _tmp388_;
	gdouble _tmp389_;
	gdouble _tmp390_;
	guchar* _tmp391_;
	gint _tmp391__length1;
	gint _tmp392_;
	gdouble _tmp393_;
	gdouble _tmp394_;
	guchar _tmp395_;
	guchar* _tmp396_;
	gint _tmp396__length1;
	gint _tmp397_;
	gdouble _tmp398_;
	gdouble _tmp399_;
	guchar _tmp400_;
	guchar* _tmp401_;
	gint _tmp401__length1;
	gint _tmp402_;
	gdouble _tmp403_;
	gdouble _tmp404_;
	guchar _tmp405_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = l;
	L = (gint) _tmp0_;
	_tmp1_ = L;
	_tmp2_ = l;
	if (((gdouble) _tmp1_) != _tmp2_) {
		gint _tmp3_;
		_tmp3_ = L;
		L = _tmp3_ + 1;
	}
	_tmp4_ = r;
	R = (gint) _tmp4_;
	_tmp5_ = t;
	T = (gint) _tmp5_;
	_tmp6_ = T;
	_tmp7_ = t;
	if (((gdouble) _tmp6_) != _tmp7_) {
		gint _tmp8_;
		_tmp8_ = T;
		T = _tmp8_ + 1;
	}
	_tmp9_ = b;
	B = (gint) _tmp9_;
	red = 0.0;
	green = 0.0;
	blue = 0.0;
	_tmp12_ = r;
	_tmp13_ = l;
	if ((_tmp12_ - _tmp13_) <= 1.0) {
		gdouble _tmp14_;
		gdouble _tmp15_;
		_tmp14_ = r;
		_tmp15_ = l;
		_tmp11_ = ((gint) _tmp14_) == ((gint) _tmp15_);
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		gboolean _tmp16_ = FALSE;
		gdouble _tmp17_;
		gdouble _tmp18_;
		_tmp17_ = b;
		_tmp18_ = t;
		if ((_tmp17_ - _tmp18_) <= 1.0) {
			gdouble _tmp19_;
			gdouble _tmp20_;
			_tmp19_ = b;
			_tmp20_ = t;
			_tmp16_ = ((gint) _tmp19_) == ((gint) _tmp20_);
		} else {
			_tmp16_ = FALSE;
		}
		_tmp10_ = _tmp16_;
	}
	if (_tmp10_) {
		gboolean _tmp21_ = FALSE;
		gdouble _tmp22_;
		gdouble _tmp23_;
		gint _tmp41_;
		gint _tmp42_;
		gdouble scale = 0.0;
		gdouble _tmp167_;
		gdouble _tmp168_;
		gdouble _tmp169_;
		gdouble _tmp170_;
		guchar* _tmp171_;
		gint _tmp171__length1;
		gint _tmp172_;
		gdouble _tmp173_;
		gdouble _tmp174_;
		guchar _tmp175_;
		guchar* _tmp176_;
		gint _tmp176__length1;
		gint _tmp177_;
		gdouble _tmp178_;
		gdouble _tmp179_;
		guchar _tmp180_;
		guchar* _tmp181_;
		gint _tmp181__length1;
		gint _tmp182_;
		gdouble _tmp183_;
		gdouble _tmp184_;
		guchar _tmp185_;
		_tmp22_ = l;
		_tmp23_ = r;
		if (((gint) _tmp22_) == ((gint) _tmp23_)) {
			_tmp21_ = TRUE;
		} else {
			gdouble _tmp24_;
			gdouble _tmp25_;
			_tmp24_ = t;
			_tmp25_ = b;
			_tmp21_ = ((gint) _tmp24_) == ((gint) _tmp25_);
		}
		if (_tmp21_) {
			guchar p[3] = {0};
			Page* _tmp26_;
			gdouble _tmp27_;
			gdouble _tmp28_;
			guchar* _tmp29_;
			gint _tmp29__length1;
			gint _tmp30_;
			guchar _tmp31_;
			guchar _tmp32_;
			guchar* _tmp33_;
			gint _tmp33__length1;
			gint _tmp34_;
			guchar _tmp35_;
			guchar _tmp36_;
			guchar* _tmp37_;
			gint _tmp37__length1;
			gint _tmp38_;
			guchar _tmp39_;
			guchar _tmp40_;
			_tmp26_ = page;
			_tmp27_ = l;
			_tmp28_ = t;
			page_view_get_pixel (self, _tmp26_, (gint) _tmp27_, (gint) _tmp28_, p, 3);
			_tmp29_ = output;
			_tmp29__length1 = output_length1;
			_tmp30_ = offset;
			_tmp31_ = p[0];
			_tmp29_[_tmp30_] = _tmp31_;
			_tmp32_ = _tmp29_[_tmp30_];
			_tmp33_ = output;
			_tmp33__length1 = output_length1;
			_tmp34_ = offset;
			_tmp35_ = p[1];
			_tmp33_[_tmp34_ + 1] = _tmp35_;
			_tmp36_ = _tmp33_[_tmp34_ + 1];
			_tmp37_ = output;
			_tmp37__length1 = output_length1;
			_tmp38_ = offset;
			_tmp39_ = p[2];
			_tmp37_[_tmp38_ + 2] = _tmp39_;
			_tmp40_ = _tmp37_[_tmp38_ + 2];
			return;
		}
		_tmp41_ = L;
		_tmp42_ = R;
		if (_tmp41_ > _tmp42_) {
			guchar p[3] = {0};
			Page* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			gdouble _tmp46_;
			guchar _tmp47_;
			gdouble _tmp48_;
			gdouble _tmp49_;
			gint _tmp50_;
			gdouble _tmp51_;
			gdouble _tmp52_;
			guchar _tmp53_;
			gdouble _tmp54_;
			gdouble _tmp55_;
			gint _tmp56_;
			gdouble _tmp57_;
			gdouble _tmp58_;
			guchar _tmp59_;
			gdouble _tmp60_;
			gdouble _tmp61_;
			gint _tmp62_;
			gdouble _tmp63_;
			Page* _tmp84_;
			gint _tmp85_;
			gint _tmp86_;
			gdouble _tmp87_;
			guchar _tmp88_;
			gdouble _tmp89_;
			gdouble _tmp90_;
			gdouble _tmp91_;
			gint _tmp92_;
			gdouble _tmp93_;
			guchar _tmp94_;
			gdouble _tmp95_;
			gdouble _tmp96_;
			gdouble _tmp97_;
			gint _tmp98_;
			gdouble _tmp99_;
			guchar _tmp100_;
			gdouble _tmp101_;
			gdouble _tmp102_;
			gdouble _tmp103_;
			gint _tmp104_;
			_tmp43_ = page;
			_tmp44_ = R;
			_tmp45_ = T;
			page_view_get_pixel (self, _tmp43_, _tmp44_, _tmp45_ - 1, p, 3);
			_tmp46_ = red;
			_tmp47_ = p[0];
			_tmp48_ = r;
			_tmp49_ = l;
			_tmp50_ = T;
			_tmp51_ = t;
			red = _tmp46_ + ((_tmp47_ * (_tmp48_ - _tmp49_)) * (_tmp50_ - _tmp51_));
			_tmp52_ = green;
			_tmp53_ = p[1];
			_tmp54_ = r;
			_tmp55_ = l;
			_tmp56_ = T;
			_tmp57_ = t;
			green = _tmp52_ + ((_tmp53_ * (_tmp54_ - _tmp55_)) * (_tmp56_ - _tmp57_));
			_tmp58_ = blue;
			_tmp59_ = p[2];
			_tmp60_ = r;
			_tmp61_ = l;
			_tmp62_ = T;
			_tmp63_ = t;
			blue = _tmp58_ + ((_tmp59_ * (_tmp60_ - _tmp61_)) * (_tmp62_ - _tmp63_));
			{
				gint y = 0;
				gint _tmp64_;
				_tmp64_ = T;
				y = _tmp64_;
				{
					gboolean _tmp65_ = FALSE;
					_tmp65_ = TRUE;
					while (TRUE) {
						gint _tmp67_;
						gint _tmp68_;
						Page* _tmp69_;
						gint _tmp70_;
						gint _tmp71_;
						gdouble _tmp72_;
						guchar _tmp73_;
						gdouble _tmp74_;
						gdouble _tmp75_;
						gdouble _tmp76_;
						guchar _tmp77_;
						gdouble _tmp78_;
						gdouble _tmp79_;
						gdouble _tmp80_;
						guchar _tmp81_;
						gdouble _tmp82_;
						gdouble _tmp83_;
						if (!_tmp65_) {
							gint _tmp66_;
							_tmp66_ = y;
							y = _tmp66_ + 1;
						}
						_tmp65_ = FALSE;
						_tmp67_ = y;
						_tmp68_ = B;
						if (!(_tmp67_ < _tmp68_)) {
							break;
						}
						_tmp69_ = page;
						_tmp70_ = R;
						_tmp71_ = y;
						page_view_get_pixel (self, _tmp69_, _tmp70_, _tmp71_, p, 3);
						_tmp72_ = red;
						_tmp73_ = p[0];
						_tmp74_ = r;
						_tmp75_ = l;
						red = _tmp72_ + (_tmp73_ * (_tmp74_ - _tmp75_));
						_tmp76_ = green;
						_tmp77_ = p[1];
						_tmp78_ = r;
						_tmp79_ = l;
						green = _tmp76_ + (_tmp77_ * (_tmp78_ - _tmp79_));
						_tmp80_ = blue;
						_tmp81_ = p[2];
						_tmp82_ = r;
						_tmp83_ = l;
						blue = _tmp80_ + (_tmp81_ * (_tmp82_ - _tmp83_));
					}
				}
			}
			_tmp84_ = page;
			_tmp85_ = R;
			_tmp86_ = B;
			page_view_get_pixel (self, _tmp84_, _tmp85_, _tmp86_, p, 3);
			_tmp87_ = red;
			_tmp88_ = p[0];
			_tmp89_ = r;
			_tmp90_ = l;
			_tmp91_ = b;
			_tmp92_ = B;
			red = _tmp87_ + ((_tmp88_ * (_tmp89_ - _tmp90_)) * (_tmp91_ - _tmp92_));
			_tmp93_ = green;
			_tmp94_ = p[1];
			_tmp95_ = r;
			_tmp96_ = l;
			_tmp97_ = b;
			_tmp98_ = B;
			green = _tmp93_ + ((_tmp94_ * (_tmp95_ - _tmp96_)) * (_tmp97_ - _tmp98_));
			_tmp99_ = blue;
			_tmp100_ = p[2];
			_tmp101_ = r;
			_tmp102_ = l;
			_tmp103_ = b;
			_tmp104_ = B;
			blue = _tmp99_ + ((_tmp100_ * (_tmp101_ - _tmp102_)) * (_tmp103_ - _tmp104_));
		} else {
			guchar p[3] = {0};
			Page* _tmp105_;
			gint _tmp106_;
			gint _tmp107_;
			gdouble _tmp108_;
			guchar _tmp109_;
			gdouble _tmp110_;
			gdouble _tmp111_;
			gint _tmp112_;
			gdouble _tmp113_;
			gdouble _tmp114_;
			guchar _tmp115_;
			gdouble _tmp116_;
			gdouble _tmp117_;
			gint _tmp118_;
			gdouble _tmp119_;
			gdouble _tmp120_;
			guchar _tmp121_;
			gdouble _tmp122_;
			gdouble _tmp123_;
			gint _tmp124_;
			gdouble _tmp125_;
			Page* _tmp146_;
			gint _tmp147_;
			gint _tmp148_;
			gdouble _tmp149_;
			guchar _tmp150_;
			gdouble _tmp151_;
			gdouble _tmp152_;
			gdouble _tmp153_;
			gint _tmp154_;
			gdouble _tmp155_;
			guchar _tmp156_;
			gdouble _tmp157_;
			gdouble _tmp158_;
			gdouble _tmp159_;
			gint _tmp160_;
			gdouble _tmp161_;
			guchar _tmp162_;
			gdouble _tmp163_;
			gdouble _tmp164_;
			gdouble _tmp165_;
			gint _tmp166_;
			_tmp105_ = page;
			_tmp106_ = L;
			_tmp107_ = B;
			page_view_get_pixel (self, _tmp105_, _tmp106_ - 1, _tmp107_, p, 3);
			_tmp108_ = red;
			_tmp109_ = p[0];
			_tmp110_ = b;
			_tmp111_ = t;
			_tmp112_ = L;
			_tmp113_ = l;
			red = _tmp108_ + ((_tmp109_ * (_tmp110_ - _tmp111_)) * (_tmp112_ - _tmp113_));
			_tmp114_ = green;
			_tmp115_ = p[1];
			_tmp116_ = b;
			_tmp117_ = t;
			_tmp118_ = L;
			_tmp119_ = l;
			green = _tmp114_ + ((_tmp115_ * (_tmp116_ - _tmp117_)) * (_tmp118_ - _tmp119_));
			_tmp120_ = blue;
			_tmp121_ = p[2];
			_tmp122_ = b;
			_tmp123_ = t;
			_tmp124_ = L;
			_tmp125_ = l;
			blue = _tmp120_ + ((_tmp121_ * (_tmp122_ - _tmp123_)) * (_tmp124_ - _tmp125_));
			{
				gint x = 0;
				gint _tmp126_;
				_tmp126_ = L;
				x = _tmp126_;
				{
					gboolean _tmp127_ = FALSE;
					_tmp127_ = TRUE;
					while (TRUE) {
						gint _tmp129_;
						gint _tmp130_;
						Page* _tmp131_;
						gint _tmp132_;
						gint _tmp133_;
						gdouble _tmp134_;
						guchar _tmp135_;
						gdouble _tmp136_;
						gdouble _tmp137_;
						gdouble _tmp138_;
						guchar _tmp139_;
						gdouble _tmp140_;
						gdouble _tmp141_;
						gdouble _tmp142_;
						guchar _tmp143_;
						gdouble _tmp144_;
						gdouble _tmp145_;
						if (!_tmp127_) {
							gint _tmp128_;
							_tmp128_ = x;
							x = _tmp128_ + 1;
						}
						_tmp127_ = FALSE;
						_tmp129_ = x;
						_tmp130_ = R;
						if (!(_tmp129_ < _tmp130_)) {
							break;
						}
						_tmp131_ = page;
						_tmp132_ = x;
						_tmp133_ = B;
						page_view_get_pixel (self, _tmp131_, _tmp132_, _tmp133_, p, 3);
						_tmp134_ = red;
						_tmp135_ = p[0];
						_tmp136_ = b;
						_tmp137_ = t;
						red = _tmp134_ + (_tmp135_ * (_tmp136_ - _tmp137_));
						_tmp138_ = green;
						_tmp139_ = p[1];
						_tmp140_ = b;
						_tmp141_ = t;
						green = _tmp138_ + (_tmp139_ * (_tmp140_ - _tmp141_));
						_tmp142_ = blue;
						_tmp143_ = p[2];
						_tmp144_ = b;
						_tmp145_ = t;
						blue = _tmp142_ + (_tmp143_ * (_tmp144_ - _tmp145_));
					}
				}
			}
			_tmp146_ = page;
			_tmp147_ = R;
			_tmp148_ = B;
			page_view_get_pixel (self, _tmp146_, _tmp147_, _tmp148_, p, 3);
			_tmp149_ = red;
			_tmp150_ = p[0];
			_tmp151_ = b;
			_tmp152_ = t;
			_tmp153_ = r;
			_tmp154_ = R;
			red = _tmp149_ + ((_tmp150_ * (_tmp151_ - _tmp152_)) * (_tmp153_ - _tmp154_));
			_tmp155_ = green;
			_tmp156_ = p[1];
			_tmp157_ = b;
			_tmp158_ = t;
			_tmp159_ = r;
			_tmp160_ = R;
			green = _tmp155_ + ((_tmp156_ * (_tmp157_ - _tmp158_)) * (_tmp159_ - _tmp160_));
			_tmp161_ = blue;
			_tmp162_ = p[2];
			_tmp163_ = b;
			_tmp164_ = t;
			_tmp165_ = r;
			_tmp166_ = R;
			blue = _tmp161_ + ((_tmp162_ * (_tmp163_ - _tmp164_)) * (_tmp165_ - _tmp166_));
		}
		_tmp167_ = r;
		_tmp168_ = l;
		_tmp169_ = b;
		_tmp170_ = t;
		scale = 1.0 / ((_tmp167_ - _tmp168_) * (_tmp169_ - _tmp170_));
		_tmp171_ = output;
		_tmp171__length1 = output_length1;
		_tmp172_ = offset;
		_tmp173_ = red;
		_tmp174_ = scale;
		_tmp171_[_tmp172_] = (guchar) ((_tmp173_ * _tmp174_) + 0.5);
		_tmp175_ = _tmp171_[_tmp172_];
		_tmp176_ = output;
		_tmp176__length1 = output_length1;
		_tmp177_ = offset;
		_tmp178_ = green;
		_tmp179_ = scale;
		_tmp176_[_tmp177_ + 1] = (guchar) ((_tmp178_ * _tmp179_) + 0.5);
		_tmp180_ = _tmp176_[_tmp177_ + 1];
		_tmp181_ = output;
		_tmp181__length1 = output_length1;
		_tmp182_ = offset;
		_tmp183_ = blue;
		_tmp184_ = scale;
		_tmp181_[_tmp182_ + 2] = (guchar) ((_tmp183_ * _tmp184_) + 0.5);
		_tmp185_ = _tmp181_[_tmp182_ + 2];
		return;
	}
	{
		gint x = 0;
		gint _tmp186_;
		_tmp186_ = L;
		x = _tmp186_;
		{
			gboolean _tmp187_ = FALSE;
			_tmp187_ = TRUE;
			while (TRUE) {
				gint _tmp189_;
				gint _tmp190_;
				if (!_tmp187_) {
					gint _tmp188_;
					_tmp188_ = x;
					x = _tmp188_ + 1;
				}
				_tmp187_ = FALSE;
				_tmp189_ = x;
				_tmp190_ = R;
				if (!(_tmp189_ < _tmp190_)) {
					break;
				}
				{
					gint y = 0;
					gint _tmp191_;
					_tmp191_ = T;
					y = _tmp191_;
					{
						gboolean _tmp192_ = FALSE;
						_tmp192_ = TRUE;
						while (TRUE) {
							gint _tmp194_;
							gint _tmp195_;
							guchar p[3] = {0};
							Page* _tmp196_;
							gint _tmp197_;
							gint _tmp198_;
							gdouble _tmp199_;
							guchar _tmp200_;
							gdouble _tmp201_;
							guchar _tmp202_;
							gdouble _tmp203_;
							guchar _tmp204_;
							if (!_tmp192_) {
								gint _tmp193_;
								_tmp193_ = y;
								y = _tmp193_ + 1;
							}
							_tmp192_ = FALSE;
							_tmp194_ = y;
							_tmp195_ = B;
							if (!(_tmp194_ < _tmp195_)) {
								break;
							}
							_tmp196_ = page;
							_tmp197_ = x;
							_tmp198_ = y;
							page_view_get_pixel (self, _tmp196_, _tmp197_, _tmp198_, p, 3);
							_tmp199_ = red;
							_tmp200_ = p[0];
							red = _tmp199_ + _tmp200_;
							_tmp201_ = green;
							_tmp202_ = p[1];
							green = _tmp201_ + _tmp202_;
							_tmp203_ = blue;
							_tmp204_ = p[2];
							blue = _tmp203_ + _tmp204_;
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		gint _tmp205_;
		_tmp205_ = L;
		x = _tmp205_;
		{
			gboolean _tmp206_ = FALSE;
			_tmp206_ = TRUE;
			while (TRUE) {
				gint _tmp208_;
				gint _tmp209_;
				gdouble _tmp210_;
				gint _tmp211_;
				gdouble _tmp227_;
				gint _tmp228_;
				if (!_tmp206_) {
					gint _tmp207_;
					_tmp207_ = x;
					x = _tmp207_ + 1;
				}
				_tmp206_ = FALSE;
				_tmp208_ = x;
				_tmp209_ = R;
				if (!(_tmp208_ < _tmp209_)) {
					break;
				}
				_tmp210_ = t;
				_tmp211_ = T;
				if (_tmp210_ != ((gdouble) _tmp211_)) {
					guchar p[3] = {0};
					Page* _tmp212_;
					gint _tmp213_;
					gint _tmp214_;
					gdouble _tmp215_;
					guchar _tmp216_;
					gint _tmp217_;
					gdouble _tmp218_;
					gdouble _tmp219_;
					guchar _tmp220_;
					gint _tmp221_;
					gdouble _tmp222_;
					gdouble _tmp223_;
					guchar _tmp224_;
					gint _tmp225_;
					gdouble _tmp226_;
					_tmp212_ = page;
					_tmp213_ = x;
					_tmp214_ = T;
					page_view_get_pixel (self, _tmp212_, _tmp213_, _tmp214_ - 1, p, 3);
					_tmp215_ = red;
					_tmp216_ = p[0];
					_tmp217_ = T;
					_tmp218_ = t;
					red = _tmp215_ + (_tmp216_ * (_tmp217_ - _tmp218_));
					_tmp219_ = green;
					_tmp220_ = p[1];
					_tmp221_ = T;
					_tmp222_ = t;
					green = _tmp219_ + (_tmp220_ * (_tmp221_ - _tmp222_));
					_tmp223_ = blue;
					_tmp224_ = p[2];
					_tmp225_ = T;
					_tmp226_ = t;
					blue = _tmp223_ + (_tmp224_ * (_tmp225_ - _tmp226_));
				}
				_tmp227_ = b;
				_tmp228_ = B;
				if (_tmp227_ != ((gdouble) _tmp228_)) {
					guchar p[3] = {0};
					Page* _tmp229_;
					gint _tmp230_;
					gint _tmp231_;
					gdouble _tmp232_;
					guchar _tmp233_;
					gdouble _tmp234_;
					gint _tmp235_;
					gdouble _tmp236_;
					guchar _tmp237_;
					gdouble _tmp238_;
					gint _tmp239_;
					gdouble _tmp240_;
					guchar _tmp241_;
					gdouble _tmp242_;
					gint _tmp243_;
					_tmp229_ = page;
					_tmp230_ = x;
					_tmp231_ = B;
					page_view_get_pixel (self, _tmp229_, _tmp230_, _tmp231_, p, 3);
					_tmp232_ = red;
					_tmp233_ = p[0];
					_tmp234_ = b;
					_tmp235_ = B;
					red = _tmp232_ + (_tmp233_ * (_tmp234_ - _tmp235_));
					_tmp236_ = green;
					_tmp237_ = p[1];
					_tmp238_ = b;
					_tmp239_ = B;
					green = _tmp236_ + (_tmp237_ * (_tmp238_ - _tmp239_));
					_tmp240_ = blue;
					_tmp241_ = p[2];
					_tmp242_ = b;
					_tmp243_ = B;
					blue = _tmp240_ + (_tmp241_ * (_tmp242_ - _tmp243_));
				}
			}
		}
	}
	{
		gint y = 0;
		gint _tmp244_;
		_tmp244_ = T;
		y = _tmp244_;
		{
			gboolean _tmp245_ = FALSE;
			_tmp245_ = TRUE;
			while (TRUE) {
				gint _tmp247_;
				gint _tmp248_;
				gdouble _tmp249_;
				gint _tmp250_;
				gdouble _tmp266_;
				gint _tmp267_;
				if (!_tmp245_) {
					gint _tmp246_;
					_tmp246_ = y;
					y = _tmp246_ + 1;
				}
				_tmp245_ = FALSE;
				_tmp247_ = y;
				_tmp248_ = B;
				if (!(_tmp247_ < _tmp248_)) {
					break;
				}
				_tmp249_ = l;
				_tmp250_ = L;
				if (_tmp249_ != ((gdouble) _tmp250_)) {
					guchar p[3] = {0};
					Page* _tmp251_;
					gint _tmp252_;
					gint _tmp253_;
					gdouble _tmp254_;
					guchar _tmp255_;
					gint _tmp256_;
					gdouble _tmp257_;
					gdouble _tmp258_;
					guchar _tmp259_;
					gint _tmp260_;
					gdouble _tmp261_;
					gdouble _tmp262_;
					guchar _tmp263_;
					gint _tmp264_;
					gdouble _tmp265_;
					_tmp251_ = page;
					_tmp252_ = L;
					_tmp253_ = y;
					page_view_get_pixel (self, _tmp251_, _tmp252_ - 1, _tmp253_, p, 3);
					_tmp254_ = red;
					_tmp255_ = p[0];
					_tmp256_ = L;
					_tmp257_ = l;
					red = _tmp254_ + (_tmp255_ * (_tmp256_ - _tmp257_));
					_tmp258_ = green;
					_tmp259_ = p[1];
					_tmp260_ = L;
					_tmp261_ = l;
					green = _tmp258_ + (_tmp259_ * (_tmp260_ - _tmp261_));
					_tmp262_ = blue;
					_tmp263_ = p[2];
					_tmp264_ = L;
					_tmp265_ = l;
					blue = _tmp262_ + (_tmp263_ * (_tmp264_ - _tmp265_));
				}
				_tmp266_ = r;
				_tmp267_ = R;
				if (_tmp266_ != ((gdouble) _tmp267_)) {
					guchar p[3] = {0};
					Page* _tmp268_;
					gint _tmp269_;
					gint _tmp270_;
					gdouble _tmp271_;
					guchar _tmp272_;
					gdouble _tmp273_;
					gint _tmp274_;
					gdouble _tmp275_;
					guchar _tmp276_;
					gdouble _tmp277_;
					gint _tmp278_;
					gdouble _tmp279_;
					guchar _tmp280_;
					gdouble _tmp281_;
					gint _tmp282_;
					_tmp268_ = page;
					_tmp269_ = R;
					_tmp270_ = y;
					page_view_get_pixel (self, _tmp268_, _tmp269_, _tmp270_, p, 3);
					_tmp271_ = red;
					_tmp272_ = p[0];
					_tmp273_ = r;
					_tmp274_ = R;
					red = _tmp271_ + (_tmp272_ * (_tmp273_ - _tmp274_));
					_tmp275_ = green;
					_tmp276_ = p[1];
					_tmp277_ = r;
					_tmp278_ = R;
					green = _tmp275_ + (_tmp276_ * (_tmp277_ - _tmp278_));
					_tmp279_ = blue;
					_tmp280_ = p[2];
					_tmp281_ = r;
					_tmp282_ = R;
					blue = _tmp279_ + (_tmp280_ * (_tmp281_ - _tmp282_));
				}
			}
		}
	}
	_tmp284_ = l;
	_tmp285_ = L;
	if (_tmp284_ != ((gdouble) _tmp285_)) {
		gdouble _tmp286_;
		gint _tmp287_;
		_tmp286_ = t;
		_tmp287_ = T;
		_tmp283_ = _tmp286_ != ((gdouble) _tmp287_);
	} else {
		_tmp283_ = FALSE;
	}
	if (_tmp283_) {
		guchar p[3] = {0};
		Page* _tmp288_;
		gint _tmp289_;
		gint _tmp290_;
		gdouble _tmp291_;
		guchar _tmp292_;
		gint _tmp293_;
		gdouble _tmp294_;
		gint _tmp295_;
		gdouble _tmp296_;
		gdouble _tmp297_;
		guchar _tmp298_;
		gint _tmp299_;
		gdouble _tmp300_;
		gint _tmp301_;
		gdouble _tmp302_;
		gdouble _tmp303_;
		guchar _tmp304_;
		gint _tmp305_;
		gdouble _tmp306_;
		gint _tmp307_;
		gdouble _tmp308_;
		_tmp288_ = page;
		_tmp289_ = L;
		_tmp290_ = T;
		page_view_get_pixel (self, _tmp288_, _tmp289_ - 1, _tmp290_ - 1, p, 3);
		_tmp291_ = red;
		_tmp292_ = p[0];
		_tmp293_ = L;
		_tmp294_ = l;
		_tmp295_ = T;
		_tmp296_ = t;
		red = _tmp291_ + ((_tmp292_ * (_tmp293_ - _tmp294_)) * (_tmp295_ - _tmp296_));
		_tmp297_ = green;
		_tmp298_ = p[1];
		_tmp299_ = L;
		_tmp300_ = l;
		_tmp301_ = T;
		_tmp302_ = t;
		green = _tmp297_ + ((_tmp298_ * (_tmp299_ - _tmp300_)) * (_tmp301_ - _tmp302_));
		_tmp303_ = blue;
		_tmp304_ = p[2];
		_tmp305_ = L;
		_tmp306_ = l;
		_tmp307_ = T;
		_tmp308_ = t;
		blue = _tmp303_ + ((_tmp304_ * (_tmp305_ - _tmp306_)) * (_tmp307_ - _tmp308_));
	}
	_tmp310_ = r;
	_tmp311_ = R;
	if (_tmp310_ != ((gdouble) _tmp311_)) {
		gdouble _tmp312_;
		gint _tmp313_;
		_tmp312_ = t;
		_tmp313_ = T;
		_tmp309_ = _tmp312_ != ((gdouble) _tmp313_);
	} else {
		_tmp309_ = FALSE;
	}
	if (_tmp309_) {
		guchar p[3] = {0};
		Page* _tmp314_;
		gint _tmp315_;
		gint _tmp316_;
		gdouble _tmp317_;
		guchar _tmp318_;
		gdouble _tmp319_;
		gint _tmp320_;
		gint _tmp321_;
		gdouble _tmp322_;
		gdouble _tmp323_;
		guchar _tmp324_;
		gdouble _tmp325_;
		gint _tmp326_;
		gint _tmp327_;
		gdouble _tmp328_;
		gdouble _tmp329_;
		guchar _tmp330_;
		gdouble _tmp331_;
		gint _tmp332_;
		gint _tmp333_;
		gdouble _tmp334_;
		_tmp314_ = page;
		_tmp315_ = R;
		_tmp316_ = T;
		page_view_get_pixel (self, _tmp314_, _tmp315_, _tmp316_ - 1, p, 3);
		_tmp317_ = red;
		_tmp318_ = p[0];
		_tmp319_ = r;
		_tmp320_ = R;
		_tmp321_ = T;
		_tmp322_ = t;
		red = _tmp317_ + ((_tmp318_ * (_tmp319_ - _tmp320_)) * (_tmp321_ - _tmp322_));
		_tmp323_ = green;
		_tmp324_ = p[1];
		_tmp325_ = r;
		_tmp326_ = R;
		_tmp327_ = T;
		_tmp328_ = t;
		green = _tmp323_ + ((_tmp324_ * (_tmp325_ - _tmp326_)) * (_tmp327_ - _tmp328_));
		_tmp329_ = blue;
		_tmp330_ = p[2];
		_tmp331_ = r;
		_tmp332_ = R;
		_tmp333_ = T;
		_tmp334_ = t;
		blue = _tmp329_ + ((_tmp330_ * (_tmp331_ - _tmp332_)) * (_tmp333_ - _tmp334_));
	}
	_tmp336_ = r;
	_tmp337_ = R;
	if (_tmp336_ != ((gdouble) _tmp337_)) {
		gdouble _tmp338_;
		gint _tmp339_;
		_tmp338_ = b;
		_tmp339_ = B;
		_tmp335_ = _tmp338_ != ((gdouble) _tmp339_);
	} else {
		_tmp335_ = FALSE;
	}
	if (_tmp335_) {
		guchar p[3] = {0};
		Page* _tmp340_;
		gint _tmp341_;
		gint _tmp342_;
		gdouble _tmp343_;
		guchar _tmp344_;
		gdouble _tmp345_;
		gint _tmp346_;
		gdouble _tmp347_;
		gint _tmp348_;
		gdouble _tmp349_;
		guchar _tmp350_;
		gdouble _tmp351_;
		gint _tmp352_;
		gdouble _tmp353_;
		gint _tmp354_;
		gdouble _tmp355_;
		guchar _tmp356_;
		gdouble _tmp357_;
		gint _tmp358_;
		gdouble _tmp359_;
		gint _tmp360_;
		_tmp340_ = page;
		_tmp341_ = R;
		_tmp342_ = B;
		page_view_get_pixel (self, _tmp340_, _tmp341_, _tmp342_, p, 3);
		_tmp343_ = red;
		_tmp344_ = p[0];
		_tmp345_ = r;
		_tmp346_ = R;
		_tmp347_ = b;
		_tmp348_ = B;
		red = _tmp343_ + ((_tmp344_ * (_tmp345_ - _tmp346_)) * (_tmp347_ - _tmp348_));
		_tmp349_ = green;
		_tmp350_ = p[1];
		_tmp351_ = r;
		_tmp352_ = R;
		_tmp353_ = b;
		_tmp354_ = B;
		green = _tmp349_ + ((_tmp350_ * (_tmp351_ - _tmp352_)) * (_tmp353_ - _tmp354_));
		_tmp355_ = blue;
		_tmp356_ = p[2];
		_tmp357_ = r;
		_tmp358_ = R;
		_tmp359_ = b;
		_tmp360_ = B;
		blue = _tmp355_ + ((_tmp356_ * (_tmp357_ - _tmp358_)) * (_tmp359_ - _tmp360_));
	}
	_tmp362_ = l;
	_tmp363_ = L;
	if (_tmp362_ != ((gdouble) _tmp363_)) {
		gdouble _tmp364_;
		gint _tmp365_;
		_tmp364_ = b;
		_tmp365_ = B;
		_tmp361_ = _tmp364_ != ((gdouble) _tmp365_);
	} else {
		_tmp361_ = FALSE;
	}
	if (_tmp361_) {
		guchar p[3] = {0};
		Page* _tmp366_;
		gint _tmp367_;
		gint _tmp368_;
		gdouble _tmp369_;
		guchar _tmp370_;
		gint _tmp371_;
		gdouble _tmp372_;
		gdouble _tmp373_;
		gint _tmp374_;
		gdouble _tmp375_;
		guchar _tmp376_;
		gint _tmp377_;
		gdouble _tmp378_;
		gdouble _tmp379_;
		gint _tmp380_;
		gdouble _tmp381_;
		guchar _tmp382_;
		gint _tmp383_;
		gdouble _tmp384_;
		gdouble _tmp385_;
		gint _tmp386_;
		_tmp366_ = page;
		_tmp367_ = L;
		_tmp368_ = B;
		page_view_get_pixel (self, _tmp366_, _tmp367_ - 1, _tmp368_, p, 3);
		_tmp369_ = red;
		_tmp370_ = p[0];
		_tmp371_ = L;
		_tmp372_ = l;
		_tmp373_ = b;
		_tmp374_ = B;
		red = _tmp369_ + ((_tmp370_ * (_tmp371_ - _tmp372_)) * (_tmp373_ - _tmp374_));
		_tmp375_ = green;
		_tmp376_ = p[1];
		_tmp377_ = L;
		_tmp378_ = l;
		_tmp379_ = b;
		_tmp380_ = B;
		green = _tmp375_ + ((_tmp376_ * (_tmp377_ - _tmp378_)) * (_tmp379_ - _tmp380_));
		_tmp381_ = blue;
		_tmp382_ = p[2];
		_tmp383_ = L;
		_tmp384_ = l;
		_tmp385_ = b;
		_tmp386_ = B;
		blue = _tmp381_ + ((_tmp382_ * (_tmp383_ - _tmp384_)) * (_tmp385_ - _tmp386_));
	}
	_tmp387_ = r;
	_tmp388_ = l;
	_tmp389_ = b;
	_tmp390_ = t;
	scale = 1.0 / ((_tmp387_ - _tmp388_) * (_tmp389_ - _tmp390_));
	_tmp391_ = output;
	_tmp391__length1 = output_length1;
	_tmp392_ = offset;
	_tmp393_ = red;
	_tmp394_ = scale;
	_tmp391_[_tmp392_] = (guchar) ((_tmp393_ * _tmp394_) + 0.5);
	_tmp395_ = _tmp391_[_tmp392_];
	_tmp396_ = output;
	_tmp396__length1 = output_length1;
	_tmp397_ = offset;
	_tmp398_ = green;
	_tmp399_ = scale;
	_tmp396_[_tmp397_ + 1] = (guchar) ((_tmp398_ * _tmp399_) + 0.5);
	_tmp400_ = _tmp396_[_tmp397_ + 1];
	_tmp401_ = output;
	_tmp401__length1 = output_length1;
	_tmp402_ = offset;
	_tmp403_ = blue;
	_tmp404_ = scale;
	_tmp401_[_tmp402_ + 2] = (guchar) ((_tmp403_ * _tmp404_) + 0.5);
	_tmp405_ = _tmp401_[_tmp402_ + 2];
}


static void page_view_update_preview (PageView* self, Page* page, GdkPixbuf* * output_image, gint output_width, gint output_height, ScanDirection scan_direction, gint old_scan_line, gint scan_line) {
	gint input_width = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint input_height = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GdkPixbuf* _tmp8_;
	gint _tmp58_;
	gint _tmp59_;
	gint _tmp61_;
	gint _tmp62_;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	GdkPixbuf* _tmp70_;
	guchar* output = NULL;
	GdkPixbuf* _tmp71_;
	guint8* _tmp72_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	GdkPixbuf* _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint output_n_channels = 0;
	GdkPixbuf* _tmp76_;
	gint _tmp77_;
	gint _tmp78_;
	Page* _tmp79_;
	gboolean _tmp80_;
	gboolean _tmp81_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = page;
	_tmp1_ = page_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	input_width = _tmp2_;
	_tmp3_ = page;
	_tmp4_ = page_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	input_height = _tmp5_;
	_tmp8_ = *output_image;
	if (_tmp8_ == NULL) {
		_tmp7_ = TRUE;
	} else {
		GdkPixbuf* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp9_ = *output_image;
		_tmp10_ = gdk_pixbuf_get_width (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = output_width;
		_tmp7_ = _tmp11_ != _tmp12_;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		_tmp13_ = *output_image;
		_tmp14_ = gdk_pixbuf_get_height (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = output_height;
		_tmp6_ = _tmp15_ != _tmp16_;
	}
	if (_tmp6_) {
		gint _tmp17_;
		gint _tmp18_;
		GdkPixbuf* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp17_ = output_width;
		_tmp18_ = output_height;
		_tmp19_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, _tmp17_, _tmp18_);
		_g_object_unref0 (*output_image);
		*output_image = _tmp19_;
		L = 0;
		_tmp20_ = output_width;
		R = _tmp20_ - 1;
		T = 0;
		_tmp21_ = output_height;
		B = _tmp21_ - 1;
	} else {
		ScanDirection _tmp22_;
		_tmp22_ = scan_direction;
		switch (_tmp22_) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				L = 0;
				_tmp23_ = output_width;
				R = _tmp23_ - 1;
				_tmp24_ = old_scan_line;
				_tmp25_ = output_height;
				_tmp26_ = input_height;
				T = (gint) ((((gdouble) _tmp24_) * _tmp25_) / _tmp26_);
				_tmp27_ = scan_line;
				_tmp28_ = output_height;
				_tmp29_ = input_height;
				B = (gint) (((((gdouble) _tmp27_) * _tmp28_) / _tmp29_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				_tmp30_ = old_scan_line;
				_tmp31_ = output_width;
				_tmp32_ = input_width;
				L = (gint) ((((gdouble) _tmp30_) * _tmp31_) / _tmp32_);
				_tmp33_ = scan_line;
				_tmp34_ = output_width;
				_tmp35_ = input_width;
				R = (gint) (((((gdouble) _tmp33_) * _tmp34_) / _tmp35_) + 0.5);
				T = 0;
				_tmp36_ = output_height;
				B = _tmp36_ - 1;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				L = 0;
				_tmp37_ = output_width;
				R = _tmp37_ - 1;
				_tmp38_ = input_height;
				_tmp39_ = scan_line;
				_tmp40_ = output_height;
				_tmp41_ = input_height;
				T = (gint) ((((gdouble) (_tmp38_ - _tmp39_)) * _tmp40_) / _tmp41_);
				_tmp42_ = input_height;
				_tmp43_ = old_scan_line;
				_tmp44_ = output_height;
				_tmp45_ = input_height;
				B = (gint) (((((gdouble) (_tmp42_ - _tmp43_)) * _tmp44_) / _tmp45_) + 0.5);
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				gint _tmp54_;
				_tmp46_ = input_width;
				_tmp47_ = scan_line;
				_tmp48_ = output_width;
				_tmp49_ = input_width;
				L = (gint) ((((gdouble) (_tmp46_ - _tmp47_)) * _tmp48_) / _tmp49_);
				_tmp50_ = input_width;
				_tmp51_ = old_scan_line;
				_tmp52_ = output_width;
				_tmp53_ = input_width;
				R = (gint) (((((gdouble) (_tmp50_ - _tmp51_)) * _tmp52_) / _tmp53_) + 0.5);
				T = 0;
				_tmp54_ = output_height;
				B = _tmp54_ - 1;
				break;
			}
			default:
			{
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp57_;
				T = 0;
				_tmp55_ = T;
				B = _tmp55_;
				_tmp56_ = B;
				R = _tmp56_;
				_tmp57_ = R;
				L = _tmp57_;
				break;
			}
		}
	}
	_tmp58_ = R;
	_tmp59_ = output_width;
	if (_tmp58_ >= _tmp59_) {
		gint _tmp60_;
		_tmp60_ = output_width;
		R = _tmp60_ - 1;
	}
	_tmp61_ = B;
	_tmp62_ = output_height;
	if (_tmp61_ >= _tmp62_) {
		gint _tmp63_;
		_tmp63_ = output_height;
		B = _tmp63_ - 1;
	}
	_tmp64_ = L;
	g_return_if_fail (_tmp64_ >= 0);
	_tmp65_ = R;
	_tmp66_ = output_width;
	g_return_if_fail (_tmp65_ < _tmp66_);
	_tmp67_ = T;
	g_return_if_fail (_tmp67_ >= 0);
	_tmp68_ = B;
	_tmp69_ = output_height;
	g_return_if_fail (_tmp68_ < _tmp69_);
	_tmp70_ = *output_image;
	g_return_if_fail (_tmp70_ != NULL);
	_tmp71_ = *output_image;
	_tmp72_ = gdk_pixbuf_get_pixels (_tmp71_);
	output = _tmp72_;
	output_length1 = -1;
	_output_size_ = output_length1;
	_tmp73_ = *output_image;
	_tmp74_ = gdk_pixbuf_get_rowstride (_tmp73_);
	_tmp75_ = _tmp74_;
	output_rowstride = _tmp75_;
	_tmp76_ = *output_image;
	_tmp77_ = gdk_pixbuf_get_n_channels (_tmp76_);
	_tmp78_ = _tmp77_;
	output_n_channels = _tmp78_;
	_tmp79_ = page;
	_tmp80_ = page_get_has_data (_tmp79_);
	_tmp81_ = _tmp80_;
	if (!_tmp81_) {
		{
			gint x = 0;
			gint _tmp82_;
			_tmp82_ = L;
			x = _tmp82_;
			{
				gboolean _tmp83_ = FALSE;
				_tmp83_ = TRUE;
				while (TRUE) {
					gint _tmp85_;
					gint _tmp86_;
					if (!_tmp83_) {
						gint _tmp84_;
						_tmp84_ = x;
						x = _tmp84_ + 1;
					}
					_tmp83_ = FALSE;
					_tmp85_ = x;
					_tmp86_ = R;
					if (!(_tmp85_ <= _tmp86_)) {
						break;
					}
					{
						gint y = 0;
						gint _tmp87_;
						_tmp87_ = T;
						y = _tmp87_;
						{
							gboolean _tmp88_ = FALSE;
							_tmp88_ = TRUE;
							while (TRUE) {
								gint _tmp90_;
								gint _tmp91_;
								gint o = 0;
								gint _tmp92_;
								gint _tmp93_;
								gint _tmp94_;
								gint _tmp95_;
								guchar* _tmp96_;
								gint _tmp96__length1;
								gint _tmp97_;
								guchar* _tmp98_;
								gint _tmp98__length1;
								gint _tmp99_;
								guchar* _tmp100_;
								gint _tmp100__length1;
								gint _tmp101_;
								guchar _tmp102_;
								guchar _tmp103_;
								guchar _tmp104_;
								if (!_tmp88_) {
									gint _tmp89_;
									_tmp89_ = y;
									y = _tmp89_ + 1;
								}
								_tmp88_ = FALSE;
								_tmp90_ = y;
								_tmp91_ = B;
								if (!(_tmp90_ <= _tmp91_)) {
									break;
								}
								_tmp92_ = output_rowstride;
								_tmp93_ = y;
								_tmp94_ = x;
								_tmp95_ = output_n_channels;
								o = (_tmp92_ * _tmp93_) + (_tmp94_ * _tmp95_);
								_tmp96_ = output;
								_tmp96__length1 = output_length1;
								_tmp97_ = o;
								_tmp98_ = output;
								_tmp98__length1 = output_length1;
								_tmp99_ = o;
								_tmp100_ = output;
								_tmp100__length1 = output_length1;
								_tmp101_ = o;
								_tmp100_[_tmp101_ + 2] = (guchar) 0xFF;
								_tmp102_ = _tmp100_[_tmp101_ + 2];
								_tmp98_[_tmp99_ + 1] = _tmp102_;
								_tmp103_ = _tmp98_[_tmp99_ + 1];
								_tmp96_[_tmp97_] = _tmp103_;
								_tmp104_ = _tmp96_[_tmp97_];
							}
						}
					}
				}
			}
		}
		return;
	}
	{
		gint x = 0;
		gint _tmp105_;
		_tmp105_ = L;
		x = _tmp105_;
		{
			gboolean _tmp106_ = FALSE;
			_tmp106_ = TRUE;
			while (TRUE) {
				gint _tmp108_;
				gint _tmp109_;
				gdouble l = 0.0;
				gint _tmp110_;
				gint _tmp111_;
				gint _tmp112_;
				gdouble r = 0.0;
				gint _tmp113_;
				gint _tmp114_;
				gint _tmp115_;
				if (!_tmp106_) {
					gint _tmp107_;
					_tmp107_ = x;
					x = _tmp107_ + 1;
				}
				_tmp106_ = FALSE;
				_tmp108_ = x;
				_tmp109_ = R;
				if (!(_tmp108_ <= _tmp109_)) {
					break;
				}
				_tmp110_ = x;
				_tmp111_ = input_width;
				_tmp112_ = output_width;
				l = (((gdouble) _tmp110_) * _tmp111_) / _tmp112_;
				_tmp113_ = x;
				_tmp114_ = input_width;
				_tmp115_ = output_width;
				r = (((gdouble) (_tmp113_ + 1)) * _tmp114_) / _tmp115_;
				{
					gint y = 0;
					gint _tmp116_;
					_tmp116_ = T;
					y = _tmp116_;
					{
						gboolean _tmp117_ = FALSE;
						_tmp117_ = TRUE;
						while (TRUE) {
							gint _tmp119_;
							gint _tmp120_;
							gdouble t = 0.0;
							gint _tmp121_;
							gint _tmp122_;
							gint _tmp123_;
							gdouble b = 0.0;
							gint _tmp124_;
							gint _tmp125_;
							gint _tmp126_;
							Page* _tmp127_;
							gdouble _tmp128_;
							gdouble _tmp129_;
							gdouble _tmp130_;
							gdouble _tmp131_;
							guchar* _tmp132_;
							gint _tmp132__length1;
							gint _tmp133_;
							gint _tmp134_;
							gint _tmp135_;
							gint _tmp136_;
							if (!_tmp117_) {
								gint _tmp118_;
								_tmp118_ = y;
								y = _tmp118_ + 1;
							}
							_tmp117_ = FALSE;
							_tmp119_ = y;
							_tmp120_ = B;
							if (!(_tmp119_ <= _tmp120_)) {
								break;
							}
							_tmp121_ = y;
							_tmp122_ = input_height;
							_tmp123_ = output_height;
							t = (((gdouble) _tmp121_) * _tmp122_) / _tmp123_;
							_tmp124_ = y;
							_tmp125_ = input_height;
							_tmp126_ = output_height;
							b = (((gdouble) (_tmp124_ + 1)) * _tmp125_) / _tmp126_;
							_tmp127_ = page;
							_tmp128_ = l;
							_tmp129_ = r;
							_tmp130_ = t;
							_tmp131_ = b;
							_tmp132_ = output;
							_tmp132__length1 = output_length1;
							_tmp133_ = output_rowstride;
							_tmp134_ = y;
							_tmp135_ = x;
							_tmp136_ = output_n_channels;
							page_view_set_pixel (self, _tmp127_, _tmp128_, _tmp129_, _tmp130_, _tmp131_, _tmp132_, _tmp132__length1, (_tmp133_ * _tmp134_) + (_tmp135_ * _tmp136_));
						}
					}
				}
			}
		}
	}
}


static gint page_view_get_preview_width (PageView* self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	_tmp1_ = self->priv->border_width;
	result = _tmp0_ - (_tmp1_ * 2);
	return result;
}


static gint page_view_get_preview_height (PageView* self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	_tmp1_ = self->priv->border_width;
	result = _tmp0_ - (_tmp1_ * 2);
	return result;
}


static void page_view_update_page_view (PageView* self) {
	gboolean _tmp0_;
	gint old_scan_line = 0;
	gint _tmp1_;
	gint scan_line = 0;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ScanDirection left_steps = 0;
	ScanDirection _tmp5_;
	Page* _tmp6_;
	ScanDirection _tmp7_;
	ScanDirection _tmp8_;
	gboolean _tmp9_ = FALSE;
	ScanDirection _tmp10_;
	Page* _tmp12_;
	ScanDirection _tmp13_;
	ScanDirection _tmp14_;
	Page* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	Page* _tmp18_;
	ScanDirection _tmp19_;
	ScanDirection _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_image;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->scan_line;
	old_scan_line = _tmp1_;
	_tmp2_ = self->priv->_page;
	_tmp3_ = page_get_scan_line (_tmp2_);
	_tmp4_ = _tmp3_;
	scan_line = _tmp4_;
	_tmp5_ = self->priv->scan_direction;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_scan_direction (_tmp6_);
	_tmp8_ = _tmp7_;
	left_steps = _tmp5_ - _tmp8_;
	_tmp10_ = left_steps;
	if (_tmp10_ != 0) {
		GdkPixbuf* _tmp11_;
		_tmp11_ = self->priv->image;
		_tmp9_ = _tmp11_ != NULL;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_g_object_unref0 (self->priv->image);
		self->priv->image = NULL;
	}
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_scan_direction (_tmp12_);
	_tmp14_ = _tmp13_;
	self->priv->scan_direction = _tmp14_;
	_tmp15_ = self->priv->_page;
	_tmp16_ = page_view_get_preview_width (self);
	_tmp17_ = page_view_get_preview_height (self);
	_tmp18_ = self->priv->_page;
	_tmp19_ = page_get_scan_direction (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = old_scan_line;
	_tmp22_ = scan_line;
	page_view_update_preview (self, _tmp15_, &self->priv->image, _tmp16_, _tmp17_, _tmp20_, _tmp21_, _tmp22_);
	self->priv->update_image = FALSE;
	_tmp23_ = scan_line;
	self->priv->scan_line = _tmp23_;
}


static gint page_view_page_to_screen_x (PageView* self, gint x) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = x;
	_tmp1_ = page_view_get_preview_width (self);
	_tmp2_ = self->priv->_page;
	_tmp3_ = page_get_width (_tmp2_);
	_tmp4_ = _tmp3_;
	result = (gint) (((((gdouble) _tmp0_) * _tmp1_) / _tmp4_) + 0.5);
	return result;
}


static gint page_view_page_to_screen_y (PageView* self, gint y) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = y;
	_tmp1_ = page_view_get_preview_height (self);
	_tmp2_ = self->priv->_page;
	_tmp3_ = page_get_height (_tmp2_);
	_tmp4_ = _tmp3_;
	result = (gint) (((((gdouble) _tmp0_) * _tmp1_) / _tmp4_) + 0.5);
	return result;
}


static gint page_view_screen_to_page_x (PageView* self, gint x) {
	gint result = 0;
	gint _tmp0_;
	Page* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = x;
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = page_view_get_preview_width (self);
	result = (gint) (((((gdouble) _tmp0_) * _tmp3_) / _tmp4_) + 0.5);
	return result;
}


static gint page_view_screen_to_page_y (PageView* self, gint y) {
	gint result = 0;
	gint _tmp0_;
	Page* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = y;
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_height (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = page_view_get_preview_height (self);
	result = (gint) (((((gdouble) _tmp0_) * _tmp3_) / _tmp4_) + 0.5);
	return result;
}


static CropLocation page_view_get_crop_location (PageView* self, gint x, gint y) {
	CropLocation result = 0;
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint _tmp15_;
	gint _tmp16_;
	gint dy = 0;
	gint _tmp17_;
	gint _tmp18_;
	gint dw = 0;
	gint _tmp19_;
	gint _tmp20_;
	gint dh = 0;
	gint _tmp21_;
	gint _tmp22_;
	gint ix = 0;
	gint _tmp23_;
	gint _tmp24_;
	gint iy = 0;
	gint _tmp25_;
	gint _tmp26_;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gint _tmp30_;
	gchar* name = NULL;
	Page* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	const gchar* _tmp40_;
	gint crop_border = 0;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp44_;
	gint _tmp45_;
	gboolean _tmp47_ = FALSE;
	gint _tmp48_;
	gint _tmp49_;
	gboolean _tmp52_ = FALSE;
	gint _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gboolean _tmp58_ = FALSE;
	gint _tmp59_;
	gint _tmp60_;
	gboolean _tmp64_ = FALSE;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	gint _tmp80_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_page;
	_tmp1_ = page_get_has_crop (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		result = 0;
		return result;
	}
	_tmp3_ = self->priv->_page;
	_tmp4_ = page_get_crop_x (_tmp3_);
	_tmp5_ = _tmp4_;
	cx = _tmp5_;
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_crop_y (_tmp6_);
	_tmp8_ = _tmp7_;
	cy = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_crop_width (_tmp9_);
	_tmp11_ = _tmp10_;
	cw = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_height (_tmp12_);
	_tmp14_ = _tmp13_;
	ch = _tmp14_;
	_tmp15_ = cx;
	_tmp16_ = page_view_page_to_screen_x (self, _tmp15_);
	dx = _tmp16_;
	_tmp17_ = cy;
	_tmp18_ = page_view_page_to_screen_y (self, _tmp17_);
	dy = _tmp18_;
	_tmp19_ = cw;
	_tmp20_ = page_view_page_to_screen_x (self, _tmp19_);
	dw = _tmp20_;
	_tmp21_ = ch;
	_tmp22_ = page_view_page_to_screen_y (self, _tmp21_);
	dh = _tmp22_;
	_tmp23_ = x;
	_tmp24_ = dx;
	ix = _tmp23_ - _tmp24_;
	_tmp25_ = y;
	_tmp26_ = dy;
	iy = _tmp25_ - _tmp26_;
	_tmp30_ = ix;
	if (_tmp30_ < 0) {
		_tmp29_ = TRUE;
	} else {
		gint _tmp31_;
		gint _tmp32_;
		_tmp31_ = ix;
		_tmp32_ = dw;
		_tmp29_ = _tmp31_ > _tmp32_;
	}
	if (_tmp29_) {
		_tmp28_ = TRUE;
	} else {
		gint _tmp33_;
		_tmp33_ = iy;
		_tmp28_ = _tmp33_ < 0;
	}
	if (_tmp28_) {
		_tmp27_ = TRUE;
	} else {
		gint _tmp34_;
		gint _tmp35_;
		_tmp34_ = iy;
		_tmp35_ = dh;
		_tmp27_ = _tmp34_ > _tmp35_;
	}
	if (_tmp27_) {
		result = CROP_LOCATION_NONE;
		return result;
	}
	_tmp36_ = self->priv->_page;
	_tmp37_ = page_get_crop_name (_tmp36_);
	_tmp38_ = _tmp37_;
	_tmp39_ = g_strdup (_tmp38_);
	name = _tmp39_;
	_tmp40_ = name;
	if (_tmp40_ != NULL) {
		result = CROP_LOCATION_MIDDLE;
		_g_free0 (name);
		return result;
	}
	crop_border = 20;
	_tmp41_ = dw;
	_tmp42_ = crop_border;
	if (_tmp41_ < (_tmp42_ * 3)) {
		gint _tmp43_;
		_tmp43_ = dw;
		crop_border = _tmp43_ / 3;
	}
	_tmp44_ = dh;
	_tmp45_ = crop_border;
	if (_tmp44_ < (_tmp45_ * 3)) {
		gint _tmp46_;
		_tmp46_ = dh;
		crop_border = _tmp46_ / 3;
	}
	_tmp48_ = ix;
	_tmp49_ = crop_border;
	if (_tmp48_ < _tmp49_) {
		gint _tmp50_;
		gint _tmp51_;
		_tmp50_ = iy;
		_tmp51_ = crop_border;
		_tmp47_ = _tmp50_ < _tmp51_;
	} else {
		_tmp47_ = FALSE;
	}
	if (_tmp47_) {
		result = CROP_LOCATION_TOP_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp53_ = ix;
	_tmp54_ = dw;
	_tmp55_ = crop_border;
	if (_tmp53_ > (_tmp54_ - _tmp55_)) {
		gint _tmp56_;
		gint _tmp57_;
		_tmp56_ = iy;
		_tmp57_ = crop_border;
		_tmp52_ = _tmp56_ < _tmp57_;
	} else {
		_tmp52_ = FALSE;
	}
	if (_tmp52_) {
		result = CROP_LOCATION_TOP_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp59_ = ix;
	_tmp60_ = crop_border;
	if (_tmp59_ < _tmp60_) {
		gint _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
		_tmp61_ = iy;
		_tmp62_ = dh;
		_tmp63_ = crop_border;
		_tmp58_ = _tmp61_ > (_tmp62_ - _tmp63_);
	} else {
		_tmp58_ = FALSE;
	}
	if (_tmp58_) {
		result = CROP_LOCATION_BOTTOM_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp65_ = ix;
	_tmp66_ = dw;
	_tmp67_ = crop_border;
	if (_tmp65_ > (_tmp66_ - _tmp67_)) {
		gint _tmp68_;
		gint _tmp69_;
		gint _tmp70_;
		_tmp68_ = iy;
		_tmp69_ = dh;
		_tmp70_ = crop_border;
		_tmp64_ = _tmp68_ > (_tmp69_ - _tmp70_);
	} else {
		_tmp64_ = FALSE;
	}
	if (_tmp64_) {
		result = CROP_LOCATION_BOTTOM_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp71_ = ix;
	_tmp72_ = crop_border;
	if (_tmp71_ < _tmp72_) {
		result = CROP_LOCATION_LEFT;
		_g_free0 (name);
		return result;
	}
	_tmp73_ = ix;
	_tmp74_ = dw;
	_tmp75_ = crop_border;
	if (_tmp73_ > (_tmp74_ - _tmp75_)) {
		result = CROP_LOCATION_RIGHT;
		_g_free0 (name);
		return result;
	}
	_tmp76_ = iy;
	_tmp77_ = crop_border;
	if (_tmp76_ < _tmp77_) {
		result = CROP_LOCATION_TOP;
		_g_free0 (name);
		return result;
	}
	_tmp78_ = iy;
	_tmp79_ = dh;
	_tmp80_ = crop_border;
	if (_tmp78_ > (_tmp79_ - _tmp80_)) {
		result = CROP_LOCATION_BOTTOM;
		_g_free0 (name);
		return result;
	}
	result = CROP_LOCATION_MIDDLE;
	_g_free0 (name);
	return result;
}


void page_view_button_press (PageView* self, gint x, gint y) {
	CropLocation location = 0;
	gint _tmp0_;
	gint _tmp1_;
	CropLocation _tmp2_;
	CropLocation _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = x;
	_tmp1_ = y;
	_tmp2_ = page_view_get_crop_location (self, _tmp0_, _tmp1_);
	location = _tmp2_;
	_tmp3_ = location;
	if (_tmp3_ != CROP_LOCATION_NONE) {
		CropLocation _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		Page* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		Page* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		Page* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		Page* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		_tmp4_ = location;
		self->priv->crop_location = _tmp4_;
		_tmp5_ = x;
		self->priv->selected_crop_px = (gdouble) _tmp5_;
		_tmp6_ = y;
		self->priv->selected_crop_py = (gdouble) _tmp6_;
		_tmp7_ = self->priv->_page;
		_tmp8_ = page_get_crop_x (_tmp7_);
		_tmp9_ = _tmp8_;
		self->priv->selected_crop_x = _tmp9_;
		_tmp10_ = self->priv->_page;
		_tmp11_ = page_get_crop_y (_tmp10_);
		_tmp12_ = _tmp11_;
		self->priv->selected_crop_y = _tmp12_;
		_tmp13_ = self->priv->_page;
		_tmp14_ = page_get_crop_width (_tmp13_);
		_tmp15_ = _tmp14_;
		self->priv->selected_crop_w = _tmp15_;
		_tmp16_ = self->priv->_page;
		_tmp17_ = page_get_crop_height (_tmp16_);
		_tmp18_ = _tmp17_;
		self->priv->selected_crop_h = _tmp18_;
	}
}


void page_view_motion (PageView* self, gint x, gint y) {
	CropLocation location = 0;
	gint _tmp0_;
	gint _tmp1_;
	CropLocation _tmp2_;
	GdkCursorType cursor = 0;
	CropLocation _tmp3_;
	CropLocation _tmp4_;
	gint pw = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint ph = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint cw = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint ch = 0;
	Page* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint dx = 0;
	gint _tmp18_;
	gdouble _tmp19_;
	gint _tmp20_;
	gint dy = 0;
	gint _tmp21_;
	gdouble _tmp22_;
	gint _tmp23_;
	gint new_x = 0;
	gint _tmp24_;
	gint new_y = 0;
	gint _tmp25_;
	gint new_w = 0;
	gint _tmp26_;
	gint new_h = 0;
	gint _tmp27_;
	gint min_size = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	CropLocation _tmp31_;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	CropLocation _tmp44_;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	CropLocation _tmp57_;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_ = FALSE;
	CropLocation _tmp74_;
	CropLocation _tmp89_;
	CropLocation _tmp110_;
	gboolean _tmp115_ = FALSE;
	gboolean _tmp116_ = FALSE;
	CropLocation _tmp117_;
	gboolean _tmp124_ = FALSE;
	gboolean _tmp125_ = FALSE;
	CropLocation _tmp126_;
	gboolean _tmp133_ = FALSE;
	gboolean _tmp134_ = FALSE;
	CropLocation _tmp135_;
	gboolean _tmp140_ = FALSE;
	gboolean _tmp141_ = FALSE;
	CropLocation _tmp142_;
	Page* _tmp147_;
	gint _tmp148_;
	gint _tmp149_;
	gboolean _tmp150_ = FALSE;
	gint _tmp151_;
	gint _tmp152_;
	g_return_if_fail (self != NULL);
	_tmp0_ = x;
	_tmp1_ = y;
	_tmp2_ = page_view_get_crop_location (self, _tmp0_, _tmp1_);
	location = _tmp2_;
	_tmp3_ = location;
	switch (_tmp3_) {
		case CROP_LOCATION_MIDDLE:
		{
			cursor = GDK_HAND1;
			break;
		}
		case CROP_LOCATION_TOP:
		{
			cursor = GDK_TOP_SIDE;
			break;
		}
		case CROP_LOCATION_BOTTOM:
		{
			cursor = GDK_BOTTOM_SIDE;
			break;
		}
		case CROP_LOCATION_LEFT:
		{
			cursor = GDK_LEFT_SIDE;
			break;
		}
		case CROP_LOCATION_RIGHT:
		{
			cursor = GDK_RIGHT_SIDE;
			break;
		}
		case CROP_LOCATION_TOP_LEFT:
		{
			cursor = GDK_TOP_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_TOP_RIGHT:
		{
			cursor = GDK_TOP_RIGHT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_LEFT:
		{
			cursor = GDK_BOTTOM_LEFT_CORNER;
			break;
		}
		case CROP_LOCATION_BOTTOM_RIGHT:
		{
			cursor = GDK_BOTTOM_RIGHT_CORNER;
			break;
		}
		default:
		{
			cursor = GDK_ARROW;
			break;
		}
	}
	_tmp4_ = self->priv->crop_location;
	if (_tmp4_ == CROP_LOCATION_NONE) {
		GdkCursorType _tmp5_;
		_tmp5_ = cursor;
		page_view_set_cursor (self, _tmp5_);
		return;
	}
	_tmp6_ = self->priv->_page;
	_tmp7_ = page_get_width (_tmp6_);
	_tmp8_ = _tmp7_;
	pw = _tmp8_;
	_tmp9_ = self->priv->_page;
	_tmp10_ = page_get_height (_tmp9_);
	_tmp11_ = _tmp10_;
	ph = _tmp11_;
	_tmp12_ = self->priv->_page;
	_tmp13_ = page_get_crop_width (_tmp12_);
	_tmp14_ = _tmp13_;
	cw = _tmp14_;
	_tmp15_ = self->priv->_page;
	_tmp16_ = page_get_crop_height (_tmp15_);
	_tmp17_ = _tmp16_;
	ch = _tmp17_;
	_tmp18_ = x;
	_tmp19_ = self->priv->selected_crop_px;
	_tmp20_ = page_view_screen_to_page_x (self, _tmp18_ - ((gint) _tmp19_));
	dx = _tmp20_;
	_tmp21_ = y;
	_tmp22_ = self->priv->selected_crop_py;
	_tmp23_ = page_view_screen_to_page_y (self, _tmp21_ - ((gint) _tmp22_));
	dy = _tmp23_;
	_tmp24_ = self->priv->selected_crop_x;
	new_x = _tmp24_;
	_tmp25_ = self->priv->selected_crop_y;
	new_y = _tmp25_;
	_tmp26_ = self->priv->selected_crop_w;
	new_w = _tmp26_;
	_tmp27_ = self->priv->selected_crop_h;
	new_h = _tmp27_;
	_tmp28_ = page_view_screen_to_page_x (self, 15);
	min_size = _tmp28_;
	_tmp31_ = self->priv->crop_location;
	if (_tmp31_ == CROP_LOCATION_TOP_LEFT) {
		_tmp30_ = TRUE;
	} else {
		CropLocation _tmp32_;
		_tmp32_ = self->priv->crop_location;
		_tmp30_ = _tmp32_ == CROP_LOCATION_LEFT;
	}
	if (_tmp30_) {
		_tmp29_ = TRUE;
	} else {
		CropLocation _tmp33_;
		_tmp33_ = self->priv->crop_location;
		_tmp29_ = _tmp33_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp29_) {
		gint _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _tmp39_;
		gint _tmp40_;
		_tmp34_ = dx;
		_tmp35_ = new_w;
		_tmp36_ = min_size;
		if (_tmp34_ > (_tmp35_ - _tmp36_)) {
			gint _tmp37_;
			gint _tmp38_;
			_tmp37_ = new_w;
			_tmp38_ = min_size;
			dx = _tmp37_ - _tmp38_;
		}
		_tmp39_ = new_x;
		_tmp40_ = dx;
		if ((_tmp39_ + _tmp40_) < 0) {
			gint _tmp41_;
			_tmp41_ = new_x;
			dx = -_tmp41_;
		}
	}
	_tmp44_ = self->priv->crop_location;
	if (_tmp44_ == CROP_LOCATION_TOP_LEFT) {
		_tmp43_ = TRUE;
	} else {
		CropLocation _tmp45_;
		_tmp45_ = self->priv->crop_location;
		_tmp43_ = _tmp45_ == CROP_LOCATION_TOP;
	}
	if (_tmp43_) {
		_tmp42_ = TRUE;
	} else {
		CropLocation _tmp46_;
		_tmp46_ = self->priv->crop_location;
		_tmp42_ = _tmp46_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp42_) {
		gint _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		gint _tmp52_;
		gint _tmp53_;
		_tmp47_ = dy;
		_tmp48_ = new_h;
		_tmp49_ = min_size;
		if (_tmp47_ > (_tmp48_ - _tmp49_)) {
			gint _tmp50_;
			gint _tmp51_;
			_tmp50_ = new_h;
			_tmp51_ = min_size;
			dy = _tmp50_ - _tmp51_;
		}
		_tmp52_ = new_y;
		_tmp53_ = dy;
		if ((_tmp52_ + _tmp53_) < 0) {
			gint _tmp54_;
			_tmp54_ = new_y;
			dy = -_tmp54_;
		}
	}
	_tmp57_ = self->priv->crop_location;
	if (_tmp57_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp56_ = TRUE;
	} else {
		CropLocation _tmp58_;
		_tmp58_ = self->priv->crop_location;
		_tmp56_ = _tmp58_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp56_) {
		_tmp55_ = TRUE;
	} else {
		CropLocation _tmp59_;
		_tmp59_ = self->priv->crop_location;
		_tmp55_ = _tmp59_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp55_) {
		gint _tmp60_;
		gint _tmp61_;
		gint _tmp62_;
		gint _tmp65_;
		gint _tmp66_;
		gint _tmp67_;
		gint _tmp68_;
		_tmp60_ = dx;
		_tmp61_ = min_size;
		_tmp62_ = new_w;
		if (_tmp60_ < (_tmp61_ - _tmp62_)) {
			gint _tmp63_;
			gint _tmp64_;
			_tmp63_ = min_size;
			_tmp64_ = new_w;
			dx = _tmp63_ - _tmp64_;
		}
		_tmp65_ = new_x;
		_tmp66_ = new_w;
		_tmp67_ = dx;
		_tmp68_ = pw;
		if (((_tmp65_ + _tmp66_) + _tmp67_) > _tmp68_) {
			gint _tmp69_;
			gint _tmp70_;
			gint _tmp71_;
			_tmp69_ = pw;
			_tmp70_ = new_x;
			_tmp71_ = new_w;
			dx = (_tmp69_ - _tmp70_) - _tmp71_;
		}
	}
	_tmp74_ = self->priv->crop_location;
	if (_tmp74_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp73_ = TRUE;
	} else {
		CropLocation _tmp75_;
		_tmp75_ = self->priv->crop_location;
		_tmp73_ = _tmp75_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp73_) {
		_tmp72_ = TRUE;
	} else {
		CropLocation _tmp76_;
		_tmp76_ = self->priv->crop_location;
		_tmp72_ = _tmp76_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp72_) {
		gint _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		gint _tmp82_;
		gint _tmp83_;
		gint _tmp84_;
		gint _tmp85_;
		_tmp77_ = dy;
		_tmp78_ = min_size;
		_tmp79_ = new_h;
		if (_tmp77_ < (_tmp78_ - _tmp79_)) {
			gint _tmp80_;
			gint _tmp81_;
			_tmp80_ = min_size;
			_tmp81_ = new_h;
			dy = _tmp80_ - _tmp81_;
		}
		_tmp82_ = new_y;
		_tmp83_ = new_h;
		_tmp84_ = dy;
		_tmp85_ = ph;
		if (((_tmp82_ + _tmp83_) + _tmp84_) > _tmp85_) {
			gint _tmp86_;
			gint _tmp87_;
			gint _tmp88_;
			_tmp86_ = ph;
			_tmp87_ = new_y;
			_tmp88_ = new_h;
			dy = (_tmp86_ - _tmp87_) - _tmp88_;
		}
	}
	_tmp89_ = self->priv->crop_location;
	if (_tmp89_ == CROP_LOCATION_MIDDLE) {
		gint _tmp90_;
		gint _tmp91_;
		gint _tmp92_;
		gint _tmp93_;
		gint _tmp97_;
		gint _tmp98_;
		gint _tmp100_;
		gint _tmp101_;
		gint _tmp102_;
		gint _tmp103_;
		gint _tmp107_;
		gint _tmp108_;
		_tmp90_ = new_x;
		_tmp91_ = dx;
		_tmp92_ = new_w;
		_tmp93_ = pw;
		if (((_tmp90_ + _tmp91_) + _tmp92_) > _tmp93_) {
			gint _tmp94_;
			gint _tmp95_;
			gint _tmp96_;
			_tmp94_ = pw;
			_tmp95_ = new_x;
			_tmp96_ = new_w;
			dx = (_tmp94_ - _tmp95_) - _tmp96_;
		}
		_tmp97_ = new_x;
		_tmp98_ = dx;
		if ((_tmp97_ + _tmp98_) < 0) {
			gint _tmp99_;
			_tmp99_ = new_x;
			dx = -_tmp99_;
		}
		_tmp100_ = new_y;
		_tmp101_ = dy;
		_tmp102_ = new_h;
		_tmp103_ = ph;
		if (((_tmp100_ + _tmp101_) + _tmp102_) > _tmp103_) {
			gint _tmp104_;
			gint _tmp105_;
			gint _tmp106_;
			_tmp104_ = ph;
			_tmp105_ = new_y;
			_tmp106_ = new_h;
			dy = (_tmp104_ - _tmp105_) - _tmp106_;
		}
		_tmp107_ = new_y;
		_tmp108_ = dy;
		if ((_tmp107_ + _tmp108_) < 0) {
			gint _tmp109_;
			_tmp109_ = new_y;
			dy = -_tmp109_;
		}
	}
	_tmp110_ = self->priv->crop_location;
	if (_tmp110_ == CROP_LOCATION_MIDDLE) {
		gint _tmp111_;
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		_tmp111_ = new_x;
		_tmp112_ = dx;
		new_x = _tmp111_ + _tmp112_;
		_tmp113_ = new_y;
		_tmp114_ = dy;
		new_y = _tmp113_ + _tmp114_;
	}
	_tmp117_ = self->priv->crop_location;
	if (_tmp117_ == CROP_LOCATION_TOP_LEFT) {
		_tmp116_ = TRUE;
	} else {
		CropLocation _tmp118_;
		_tmp118_ = self->priv->crop_location;
		_tmp116_ = _tmp118_ == CROP_LOCATION_LEFT;
	}
	if (_tmp116_) {
		_tmp115_ = TRUE;
	} else {
		CropLocation _tmp119_;
		_tmp119_ = self->priv->crop_location;
		_tmp115_ = _tmp119_ == CROP_LOCATION_BOTTOM_LEFT;
	}
	if (_tmp115_) {
		gint _tmp120_;
		gint _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		_tmp120_ = new_x;
		_tmp121_ = dx;
		new_x = _tmp120_ + _tmp121_;
		_tmp122_ = new_w;
		_tmp123_ = dx;
		new_w = _tmp122_ - _tmp123_;
	}
	_tmp126_ = self->priv->crop_location;
	if (_tmp126_ == CROP_LOCATION_TOP_LEFT) {
		_tmp125_ = TRUE;
	} else {
		CropLocation _tmp127_;
		_tmp127_ = self->priv->crop_location;
		_tmp125_ = _tmp127_ == CROP_LOCATION_TOP;
	}
	if (_tmp125_) {
		_tmp124_ = TRUE;
	} else {
		CropLocation _tmp128_;
		_tmp128_ = self->priv->crop_location;
		_tmp124_ = _tmp128_ == CROP_LOCATION_TOP_RIGHT;
	}
	if (_tmp124_) {
		gint _tmp129_;
		gint _tmp130_;
		gint _tmp131_;
		gint _tmp132_;
		_tmp129_ = new_y;
		_tmp130_ = dy;
		new_y = _tmp129_ + _tmp130_;
		_tmp131_ = new_h;
		_tmp132_ = dy;
		new_h = _tmp131_ - _tmp132_;
	}
	_tmp135_ = self->priv->crop_location;
	if (_tmp135_ == CROP_LOCATION_TOP_RIGHT) {
		_tmp134_ = TRUE;
	} else {
		CropLocation _tmp136_;
		_tmp136_ = self->priv->crop_location;
		_tmp134_ = _tmp136_ == CROP_LOCATION_RIGHT;
	}
	if (_tmp134_) {
		_tmp133_ = TRUE;
	} else {
		CropLocation _tmp137_;
		_tmp137_ = self->priv->crop_location;
		_tmp133_ = _tmp137_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp133_) {
		gint _tmp138_;
		gint _tmp139_;
		_tmp138_ = new_w;
		_tmp139_ = dx;
		new_w = _tmp138_ + _tmp139_;
	}
	_tmp142_ = self->priv->crop_location;
	if (_tmp142_ == CROP_LOCATION_BOTTOM_LEFT) {
		_tmp141_ = TRUE;
	} else {
		CropLocation _tmp143_;
		_tmp143_ = self->priv->crop_location;
		_tmp141_ = _tmp143_ == CROP_LOCATION_BOTTOM;
	}
	if (_tmp141_) {
		_tmp140_ = TRUE;
	} else {
		CropLocation _tmp144_;
		_tmp144_ = self->priv->crop_location;
		_tmp140_ = _tmp144_ == CROP_LOCATION_BOTTOM_RIGHT;
	}
	if (_tmp140_) {
		gint _tmp145_;
		gint _tmp146_;
		_tmp145_ = new_h;
		_tmp146_ = dy;
		new_h = _tmp145_ + _tmp146_;
	}
	_tmp147_ = self->priv->_page;
	_tmp148_ = new_x;
	_tmp149_ = new_y;
	page_move_crop (_tmp147_, _tmp148_, _tmp149_);
	_tmp151_ = new_w;
	_tmp152_ = cw;
	if (_tmp151_ != _tmp152_) {
		_tmp150_ = TRUE;
	} else {
		gint _tmp153_;
		gint _tmp154_;
		_tmp153_ = new_h;
		_tmp154_ = ch;
		_tmp150_ = _tmp153_ != _tmp154_;
	}
	if (_tmp150_) {
		Page* _tmp155_;
		gint _tmp156_;
		gint _tmp157_;
		_tmp155_ = self->priv->_page;
		_tmp156_ = new_w;
		_tmp157_ = new_h;
		page_set_custom_crop (_tmp155_, _tmp156_, _tmp157_);
	}
}


void page_view_button_release (PageView* self, gint x, gint y) {
	g_return_if_fail (self != NULL);
	self->priv->crop_location = CROP_LOCATION_NONE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static gboolean page_view_animation_cb (PageView* self) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->animate_segment;
	_tmp1_ = self->priv->animate_n_segments;
	self->priv->animate_segment = (_tmp0_ + 1) % _tmp1_;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
	result = TRUE;
	return result;
}


static gboolean _page_view_animation_cb_gsource_func (gpointer self) {
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
	return result;
}


static void page_view_update_animation (PageView* self) {
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_is_scanning (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->_page;
		_tmp5_ = page_get_has_data (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	animate = _tmp0_;
	_tmp7_ = self->priv->animate_timeout;
	is_animating = _tmp7_ != ((guint) 0);
	_tmp8_ = animate;
	_tmp9_ = is_animating;
	if (_tmp8_ == _tmp9_) {
		return;
	}
	_tmp10_ = animate;
	if (_tmp10_) {
		guint _tmp11_;
		self->priv->animate_segment = 0;
		_tmp11_ = self->priv->animate_timeout;
		if (_tmp11_ == ((guint) 0)) {
			guint _tmp12_;
			_tmp12_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, page_view_ref (self), page_view_unref);
			self->priv->animate_timeout = _tmp12_;
		}
	} else {
		guint _tmp13_;
		_tmp13_ = self->priv->animate_timeout;
		if (_tmp13_ != ((guint) 0)) {
			guint _tmp14_;
			_tmp14_ = self->priv->animate_timeout;
			g_source_remove (_tmp14_);
		}
		self->priv->animate_timeout = (guint) 0;
	}
}


void page_view_render (PageView* self, cairo_t* context) {
	gint w = 0;
	gint _tmp0_;
	gint h = 0;
	gint _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	gint _tmp8_;
	cairo_t* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	cairo_t* _tmp20_;
	GdkPixbuf* _tmp21_;
	cairo_t* _tmp22_;
	gboolean _tmp23_ = FALSE;
	Page* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp70_ = FALSE;
	Page* _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	Page* _tmp118_;
	gboolean _tmp119_;
	gboolean _tmp120_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	page_view_update_animation (self);
	page_view_update_page_view (self);
	_tmp0_ = page_view_get_preview_width (self);
	w = _tmp0_;
	_tmp1_ = page_view_get_preview_height (self);
	h = _tmp1_;
	_tmp2_ = context;
	cairo_set_line_width (_tmp2_, (gdouble) 1);
	_tmp3_ = context;
	_tmp4_ = self->priv->_x_offset;
	_tmp5_ = self->priv->_y_offset;
	cairo_translate (_tmp3_, (gdouble) _tmp4_, (gdouble) _tmp5_);
	_tmp6_ = context;
	cairo_set_source_rgb (_tmp6_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	_tmp7_ = context;
	_tmp8_ = self->priv->border_width;
	cairo_set_line_width (_tmp7_, (gdouble) _tmp8_);
	_tmp9_ = context;
	_tmp10_ = self->priv->border_width;
	_tmp11_ = self->priv->border_width;
	_tmp12_ = self->priv->width_;
	_tmp13_ = self->priv->border_width;
	_tmp14_ = self->priv->height_;
	_tmp15_ = self->priv->border_width;
	cairo_rectangle (_tmp9_, ((gdouble) _tmp10_) / 2, ((gdouble) _tmp11_) / 2, (gdouble) (_tmp12_ - _tmp13_), (gdouble) (_tmp14_ - _tmp15_));
	_tmp16_ = context;
	cairo_stroke (_tmp16_);
	_tmp17_ = context;
	_tmp18_ = self->priv->border_width;
	_tmp19_ = self->priv->border_width;
	cairo_translate (_tmp17_, (gdouble) _tmp18_, (gdouble) _tmp19_);
	_tmp20_ = context;
	_tmp21_ = self->priv->image;
	gdk_cairo_set_source_pixbuf (_tmp20_, _tmp21_, (gdouble) 0, (gdouble) 0);
	_tmp22_ = context;
	cairo_paint (_tmp22_);
	_tmp24_ = self->priv->_page;
	_tmp25_ = page_get_is_scanning (_tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_) {
		Page* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
		_tmp27_ = self->priv->_page;
		_tmp28_ = page_get_has_data (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp23_ = !_tmp29_;
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		gdouble outer_radius = 0.0;
		gint _tmp30_;
		gint _tmp31_;
		gdouble arc = 0.0;
		gint _tmp34_;
		gdouble x = 0.0;
		gdouble _tmp35_;
		gdouble _tmp36_;
		gdouble _tmp37_;
		gdouble y = 0.0;
		gdouble _tmp38_;
		gdouble _tmp39_;
		gdouble _tmp40_;
		gdouble inner_radius = 0.0;
		gdouble _tmp41_;
		gdouble _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		gdouble _tmp45_;
		gdouble offset = 0.0;
		_tmp30_ = w;
		_tmp31_ = h;
		if (_tmp30_ > _tmp31_) {
			gint _tmp32_;
			_tmp32_ = w;
			outer_radius = 0.15 * _tmp32_;
		} else {
			gint _tmp33_;
			_tmp33_ = h;
			outer_radius = 0.15 * _tmp33_;
		}
		_tmp34_ = self->priv->animate_n_segments;
		arc = G_PI / _tmp34_;
		_tmp35_ = outer_radius;
		_tmp36_ = arc;
		_tmp37_ = sin (_tmp36_);
		x = _tmp35_ * _tmp37_;
		_tmp38_ = outer_radius;
		_tmp39_ = arc;
		_tmp40_ = cos (_tmp39_);
		y = _tmp38_ * (_tmp40_ - 1.0);
		_tmp41_ = x;
		_tmp42_ = x;
		_tmp43_ = y;
		_tmp44_ = y;
		_tmp45_ = sqrt ((_tmp41_ * _tmp42_) + (_tmp43_ * _tmp44_));
		inner_radius = 0.6 * _tmp45_;
		offset = 0.0;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp46_ = FALSE;
				_tmp46_ = TRUE;
				while (TRUE) {
					gint _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
					gdouble _tmp53_;
					gdouble _tmp54_;
					gdouble _tmp55_;
					gint _tmp56_;
					gdouble _tmp57_;
					gdouble _tmp58_;
					gdouble _tmp59_;
					cairo_t* _tmp60_;
					gdouble _tmp61_;
					gdouble _tmp62_;
					gdouble _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					cairo_t* _tmp68_;
					cairo_t* _tmp69_;
					if (!_tmp46_) {
						gint _tmp47_;
						gdouble _tmp48_;
						gdouble _tmp49_;
						_tmp47_ = i;
						i = _tmp47_ + 1;
						_tmp48_ = offset;
						_tmp49_ = arc;
						offset = _tmp48_ + (_tmp49_ * 2);
					}
					_tmp46_ = FALSE;
					_tmp50_ = i;
					_tmp51_ = self->priv->animate_n_segments;
					if (!(_tmp50_ < _tmp51_)) {
						break;
					}
					_tmp52_ = w;
					_tmp53_ = outer_radius;
					_tmp54_ = offset;
					_tmp55_ = sin (_tmp54_);
					x = (_tmp52_ / 2) + (_tmp53_ * _tmp55_);
					_tmp56_ = h;
					_tmp57_ = outer_radius;
					_tmp58_ = offset;
					_tmp59_ = cos (_tmp58_);
					y = (_tmp56_ / 2) - (_tmp57_ * _tmp59_);
					_tmp60_ = context;
					_tmp61_ = x;
					_tmp62_ = y;
					_tmp63_ = inner_radius;
					cairo_arc (_tmp60_, _tmp61_, _tmp62_, _tmp63_, (gdouble) 0, 2 * G_PI);
					_tmp64_ = i;
					_tmp65_ = self->priv->animate_segment;
					if (_tmp64_ == _tmp65_) {
						cairo_t* _tmp66_;
						cairo_t* _tmp67_;
						_tmp66_ = context;
						cairo_set_source_rgb (_tmp66_, 0.75, 0.75, 0.75);
						_tmp67_ = context;
						cairo_fill_preserve (_tmp67_);
					}
					_tmp68_ = context;
					cairo_set_source_rgb (_tmp68_, 0.5, 0.5, 0.5);
					_tmp69_ = context;
					cairo_stroke (_tmp69_);
				}
			}
		}
	}
	_tmp71_ = self->priv->_page;
	_tmp72_ = page_get_is_scanning (_tmp71_);
	_tmp73_ = _tmp72_;
	if (_tmp73_) {
		Page* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		_tmp74_ = self->priv->_page;
		_tmp75_ = page_get_scan_line (_tmp74_);
		_tmp76_ = _tmp75_;
		_tmp70_ = _tmp76_ > 0;
	} else {
		_tmp70_ = FALSE;
	}
	if (_tmp70_) {
		gint scan_line = 0;
		Page* _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp80_;
		ScanDirection _tmp81_;
		ScanDirection _tmp82_;
		cairo_t* _tmp110_;
		gdouble _tmp111_;
		gdouble _tmp112_;
		cairo_t* _tmp113_;
		gdouble _tmp114_;
		gdouble _tmp115_;
		cairo_t* _tmp116_;
		cairo_t* _tmp117_;
		_tmp77_ = self->priv->_page;
		_tmp78_ = page_get_scan_line (_tmp77_);
		_tmp79_ = _tmp78_;
		scan_line = _tmp79_;
		_tmp80_ = self->priv->_page;
		_tmp81_ = page_get_scan_direction (_tmp80_);
		_tmp82_ = _tmp81_;
		switch (_tmp82_) {
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
			{
				gint _tmp83_;
				gint _tmp84_;
				gdouble _tmp85_;
				gint _tmp86_;
				gdouble _tmp87_;
				_tmp83_ = scan_line;
				_tmp84_ = page_view_page_to_screen_y (self, _tmp83_);
				s = (gdouble) _tmp84_;
				x1 = (gdouble) 0;
				_tmp85_ = s;
				y1 = _tmp85_ + 0.5;
				_tmp86_ = w;
				x2 = (gdouble) _tmp86_;
				_tmp87_ = s;
				y2 = _tmp87_ + 0.5;
				break;
			}
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
			{
				gint _tmp88_;
				gint _tmp89_;
				gint _tmp90_;
				gdouble _tmp91_;
				gint _tmp92_;
				gint _tmp93_;
				gdouble _tmp94_;
				_tmp88_ = scan_line;
				_tmp89_ = page_view_page_to_screen_y (self, _tmp88_);
				s = (gdouble) _tmp89_;
				x1 = (gdouble) 0;
				_tmp90_ = h;
				_tmp91_ = s;
				y1 = (_tmp90_ - _tmp91_) + 0.5;
				_tmp92_ = w;
				x2 = (gdouble) _tmp92_;
				_tmp93_ = h;
				_tmp94_ = s;
				y2 = (_tmp93_ - _tmp94_) + 0.5;
				break;
			}
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
			{
				gint _tmp95_;
				gint _tmp96_;
				gdouble _tmp97_;
				gdouble _tmp98_;
				gint _tmp99_;
				_tmp95_ = scan_line;
				_tmp96_ = page_view_page_to_screen_x (self, _tmp95_);
				s = (gdouble) _tmp96_;
				_tmp97_ = s;
				x1 = _tmp97_ + 0.5;
				y1 = (gdouble) 0;
				_tmp98_ = s;
				x2 = _tmp98_ + 0.5;
				_tmp99_ = h;
				y2 = (gdouble) _tmp99_;
				break;
			}
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
			{
				gint _tmp100_;
				gint _tmp101_;
				gint _tmp102_;
				gdouble _tmp103_;
				gint _tmp104_;
				gdouble _tmp105_;
				gint _tmp106_;
				_tmp100_ = scan_line;
				_tmp101_ = page_view_page_to_screen_x (self, _tmp100_);
				s = (gdouble) _tmp101_;
				_tmp102_ = w;
				_tmp103_ = s;
				x1 = (_tmp102_ - _tmp103_) + 0.5;
				y1 = (gdouble) 0;
				_tmp104_ = w;
				_tmp105_ = s;
				x2 = (_tmp104_ - _tmp105_) + 0.5;
				_tmp106_ = h;
				y2 = (gdouble) _tmp106_;
				break;
			}
			default:
			{
				gdouble _tmp107_;
				gdouble _tmp108_;
				gdouble _tmp109_;
				y2 = (gdouble) 0;
				_tmp107_ = y2;
				x2 = _tmp107_;
				_tmp108_ = x2;
				y1 = _tmp108_;
				_tmp109_ = y1;
				x1 = _tmp109_;
				break;
			}
		}
		_tmp110_ = context;
		_tmp111_ = x1;
		_tmp112_ = y1;
		cairo_move_to (_tmp110_, _tmp111_, _tmp112_);
		_tmp113_ = context;
		_tmp114_ = x2;
		_tmp115_ = y2;
		cairo_line_to (_tmp113_, _tmp114_, _tmp115_);
		_tmp116_ = context;
		cairo_set_source_rgb (_tmp116_, 1.0, 0.0, 0.0);
		_tmp117_ = context;
		cairo_stroke (_tmp117_);
	}
	_tmp118_ = self->priv->_page;
	_tmp119_ = page_get_has_crop (_tmp118_);
	_tmp120_ = _tmp119_;
	if (_tmp120_) {
		gint x = 0;
		Page* _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint y = 0;
		Page* _tmp124_;
		gint _tmp125_;
		gint _tmp126_;
		gint crop_width = 0;
		Page* _tmp127_;
		gint _tmp128_;
		gint _tmp129_;
		gint crop_height = 0;
		Page* _tmp130_;
		gint _tmp131_;
		gint _tmp132_;
		gint dx = 0;
		gint _tmp133_;
		gint _tmp134_;
		gint dy = 0;
		gint _tmp135_;
		gint _tmp136_;
		gint dw = 0;
		gint _tmp137_;
		gint _tmp138_;
		gint dh = 0;
		gint _tmp139_;
		gint _tmp140_;
		cairo_t* _tmp141_;
		gint _tmp142_;
		gint _tmp143_;
		cairo_t* _tmp144_;
		cairo_t* _tmp145_;
		gint _tmp146_;
		gint _tmp147_;
		gint _tmp148_;
		gint _tmp149_;
		cairo_t* _tmp150_;
		cairo_t* _tmp151_;
		cairo_t* _tmp152_;
		cairo_t* _tmp153_;
		gint _tmp154_;
		gint _tmp155_;
		gint _tmp156_;
		gint _tmp157_;
		cairo_t* _tmp158_;
		cairo_t* _tmp159_;
		cairo_t* _tmp160_;
		gint _tmp161_;
		gint _tmp162_;
		gint _tmp163_;
		gint _tmp164_;
		cairo_t* _tmp165_;
		cairo_t* _tmp166_;
		_tmp121_ = self->priv->_page;
		_tmp122_ = page_get_crop_x (_tmp121_);
		_tmp123_ = _tmp122_;
		x = _tmp123_;
		_tmp124_ = self->priv->_page;
		_tmp125_ = page_get_crop_y (_tmp124_);
		_tmp126_ = _tmp125_;
		y = _tmp126_;
		_tmp127_ = self->priv->_page;
		_tmp128_ = page_get_crop_width (_tmp127_);
		_tmp129_ = _tmp128_;
		crop_width = _tmp129_;
		_tmp130_ = self->priv->_page;
		_tmp131_ = page_get_crop_height (_tmp130_);
		_tmp132_ = _tmp131_;
		crop_height = _tmp132_;
		_tmp133_ = x;
		_tmp134_ = page_view_page_to_screen_x (self, _tmp133_);
		dx = _tmp134_;
		_tmp135_ = y;
		_tmp136_ = page_view_page_to_screen_y (self, _tmp135_);
		dy = _tmp136_;
		_tmp137_ = crop_width;
		_tmp138_ = page_view_page_to_screen_x (self, _tmp137_);
		dw = _tmp138_;
		_tmp139_ = crop_height;
		_tmp140_ = page_view_page_to_screen_y (self, _tmp139_);
		dh = _tmp140_;
		_tmp141_ = context;
		_tmp142_ = w;
		_tmp143_ = h;
		cairo_rectangle (_tmp141_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp142_, (gdouble) _tmp143_);
		_tmp144_ = context;
		cairo_new_sub_path (_tmp144_);
		_tmp145_ = context;
		_tmp146_ = dx;
		_tmp147_ = dy;
		_tmp148_ = dw;
		_tmp149_ = dh;
		cairo_rectangle (_tmp145_, (gdouble) _tmp146_, (gdouble) _tmp147_, (gdouble) _tmp148_, (gdouble) _tmp149_);
		_tmp150_ = context;
		cairo_set_fill_rule (_tmp150_, CAIRO_FILL_RULE_EVEN_ODD);
		_tmp151_ = context;
		cairo_set_source_rgba (_tmp151_, 0.25, 0.25, 0.25, 0.2);
		_tmp152_ = context;
		cairo_fill (_tmp152_);
		_tmp153_ = context;
		_tmp154_ = dx;
		_tmp155_ = dy;
		_tmp156_ = dw;
		_tmp157_ = dh;
		cairo_rectangle (_tmp153_, _tmp154_ - 1.5, _tmp155_ - 1.5, (gdouble) (_tmp156_ + 3), (gdouble) (_tmp157_ + 3));
		_tmp158_ = context;
		cairo_set_source_rgb (_tmp158_, 1.0, 1.0, 1.0);
		_tmp159_ = context;
		cairo_stroke (_tmp159_);
		_tmp160_ = context;
		_tmp161_ = dx;
		_tmp162_ = dy;
		_tmp163_ = dw;
		_tmp164_ = dh;
		cairo_rectangle (_tmp160_, _tmp161_ - 0.5, _tmp162_ - 0.5, (gdouble) (_tmp163_ + 1), (gdouble) (_tmp164_ + 1));
		_tmp165_ = context;
		cairo_set_source_rgb (_tmp165_, 0.0, 0.0, 0.0);
		_tmp166_ = context;
		cairo_stroke (_tmp166_);
	}
}


static void page_view_page_pixels_changed_cb (PageView* self, Page* p) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void page_view_page_size_changed_cb (PageView* self, Page* p) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void page_view_page_overlay_changed_cb (PageView* self, Page* p) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void page_view_scan_direction_changed_cb (PageView* self, Page* p) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


Page* page_view_get_page (PageView* self) {
	Page* result;
	Page* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}


static gpointer _page_ref0 (gpointer self) {
	return self ? page_ref (self) : NULL;
}


static void page_view_set_page (PageView* self, Page* value) {
	Page* _tmp0_;
	Page* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _page_ref0 (_tmp0_);
	_page_unref0 (self->priv->_page);
	self->priv->_page = _tmp1_;
}


gboolean page_view_get_selected (PageView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->selected_;
	result = _tmp0_;
	return result;
}


void page_view_set_selected (PageView* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp2_ = page_view_get_selected (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = page_view_get_selected (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = page_view_get_selected (self);
		_tmp8_ = _tmp7_;
		if (!_tmp8_) {
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp9_ = page_view_get_selected (self);
			_tmp10_ = _tmp9_;
			_tmp6_ = !_tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp11_ = page_view_get_selected (self);
	_tmp12_ = _tmp11_;
	page_view_set_selected (self, _tmp12_);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


gint page_view_get_x_offset (PageView* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_x_offset;
	result = _tmp0_;
	return result;
}


void page_view_set_x_offset (PageView* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_x_offset = _tmp0_;
}


gint page_view_get_y_offset (PageView* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_y_offset;
	result = _tmp0_;
	return result;
}


void page_view_set_y_offset (PageView* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_y_offset = _tmp0_;
}


GdkCursorType page_view_get_cursor (PageView* self) {
	GdkCursorType result;
	GdkCursorType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_cursor;
	result = _tmp0_;
	return result;
}


static void page_view_set_cursor (PageView* self, GdkCursorType value) {
	GdkCursorType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_cursor = _tmp0_;
}


gint page_view_get_width (PageView* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->width_;
	result = _tmp0_;
	return result;
}


void page_view_set_width (PageView* self, gint value) {
	gint h = 0;
	gint _tmp0_;
	Page* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Page* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_ = FALSE;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_height (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_page;
	_tmp5_ = page_get_width (_tmp4_);
	_tmp6_ = _tmp5_;
	h = (gint) ((((gdouble) _tmp0_) * _tmp3_) / _tmp6_);
	_tmp8_ = self->priv->width_;
	_tmp9_ = value;
	if (_tmp8_ == _tmp9_) {
		gint _tmp10_;
		gint _tmp11_;
		_tmp10_ = self->priv->height_;
		_tmp11_ = h;
		_tmp7_ = _tmp10_ == _tmp11_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		return;
	}
	_tmp12_ = value;
	self->priv->width_ = _tmp12_;
	_tmp13_ = h;
	self->priv->height_ = _tmp13_;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


gint page_view_get_height (PageView* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->height_;
	result = _tmp0_;
	return result;
}


void page_view_set_height (PageView* self, gint value) {
	gint w = 0;
	gint _tmp0_;
	Page* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Page* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_ = FALSE;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->_page;
	_tmp2_ = page_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_page;
	_tmp5_ = page_get_height (_tmp4_);
	_tmp6_ = _tmp5_;
	w = (gint) ((((gdouble) _tmp0_) * _tmp3_) / _tmp6_);
	_tmp8_ = self->priv->width_;
	_tmp9_ = w;
	if (_tmp8_ == _tmp9_) {
		gint _tmp10_;
		gint _tmp11_;
		_tmp10_ = self->priv->height_;
		_tmp11_ = value;
		_tmp7_ = _tmp10_ == _tmp11_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		return;
	}
	_tmp12_ = w;
	self->priv->width_ = _tmp12_;
	_tmp13_ = value;
	self->priv->height_ = _tmp13_;
	self->priv->update_image = TRUE;
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
}


static void value_page_view_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_page_view_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		page_view_unref (value->data[0].v_pointer);
	}
}


static void value_page_view_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = page_view_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_page_view_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_page_view_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PageView * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = page_view_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_page_view_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PageView ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = page_view_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_page_view (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPageView* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PAGE_VIEW), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_page_view (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW), NULL);
	return value->data[0].v_pointer;
}


void value_set_page_view (GValue* value, gpointer v_object) {
	PageView * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE_VIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		page_view_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_view_unref (old);
	}
}


void value_take_page_view (GValue* value, gpointer v_object) {
	PageView * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE_VIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE_VIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_view_unref (old);
	}
}


static void page_view_class_init (PageViewClass * klass) {
	page_view_parent_class = g_type_class_peek_parent (klass);
	((PageViewClass *) klass)->finalize = page_view_finalize;
	g_type_class_add_private (klass, sizeof (PageViewPrivate));
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void page_view_instance_init (PageView * self) {
	self->priv = PAGE_VIEW_GET_PRIVATE (self);
	self->priv->image = NULL;
	self->priv->selected_ = FALSE;
	self->priv->border_width = 1;
	self->priv->update_image = TRUE;
	self->priv->_cursor = GDK_ARROW;
	self->priv->animate_n_segments = 7;
	self->ref_count = 1;
}


static void page_view_finalize (PageView * obj) {
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->_page;
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
	_tmp2_ = self->priv->_page;
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
	_tmp4_ = self->priv->_page;
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
	_tmp6_ = self->priv->_page;
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
	_tmp8_ = self->priv->_page;
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
	_page_unref0 (self->priv->_page);
	_g_object_unref0 (self->priv->image);
}


GType page_view_get_type (void) {
	static volatile gsize page_view_type_id__volatile = 0;
	if (g_once_init_enter (&page_view_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_page_view_init, value_page_view_free_value, value_page_view_copy_value, value_page_view_peek_pointer, "p", value_page_view_collect_value, "p", value_page_view_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType page_view_type_id;
		page_view_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PageView", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&page_view_type_id__volatile, page_view_type_id);
	}
	return page_view_type_id__volatile;
}


gpointer page_view_ref (gpointer instance) {
	PageView * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void page_view_unref (gpointer instance) {
	PageView * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PAGE_VIEW_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



