/* page.c generated by valac 0.38.5, the Vala compiler
 * generated from page.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef struct _PagePrivate PagePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_PAGE_INFO (scan_page_info_get_type ())
#define SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfo))
#define SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))
#define IS_SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_PAGE_INFO))
#define IS_SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_PAGE_INFO))
#define SCAN_PAGE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))

typedef struct _ScanPageInfo ScanPageInfo;
typedef struct _ScanPageInfoClass ScanPageInfoClass;
typedef struct _ScanPageInfoPrivate ScanPageInfoPrivate;

#define TYPE_SCAN_LINE (scan_line_get_type ())
#define SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_LINE, ScanLine))
#define SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_LINE, ScanLineClass))
#define IS_SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_LINE))
#define IS_SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_LINE))
#define SCAN_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_LINE, ScanLineClass))

typedef struct _ScanLine ScanLine;
typedef struct _ScanLineClass ScanLineClass;
typedef struct _ScanLinePrivate ScanLinePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
typedef struct _ParamSpecPage ParamSpecPage;
enum  {
	PAGE_PIXELS_CHANGED_SIGNAL,
	PAGE_SIZE_CHANGED_SIGNAL,
	PAGE_SCAN_LINE_CHANGED_SIGNAL,
	PAGE_SCAN_DIRECTION_CHANGED_SIGNAL,
	PAGE_CROP_CHANGED_SIGNAL,
	PAGE_SCAN_FINISHED_SIGNAL,
	PAGE_NUM_SIGNALS
};
static guint page_signals[PAGE_NUM_SIGNALS] = {0};

typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

struct _Page {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PagePrivate * priv;
};

struct _PageClass {
	GTypeClass parent_class;
	void (*finalize) (Page *self);
};

struct _PagePrivate {
	gint _dpi;
	gint expected_rows;
	gint _depth;
	gchar* _color_profile;
	gint _scan_width;
	gint _scan_height;
	gint _rowstride;
	gint _n_channels;
	guchar* pixels;
	gint pixels_length1;
	gint _pixels_size_;
	gboolean _is_scanning;
	gboolean _has_data;
	gint _scan_line;
	ScanDirection scan_direction_;
	gboolean _has_crop;
	gchar* _crop_name;
	gint _crop_x;
	gint _crop_y;
	gint _crop_width;
	gint _crop_height;
};

struct _ScanPageInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanPageInfoPrivate * priv;
	gint width;
	gint height;
	gint depth;
	gint n_channels;
	gdouble dpi;
	gchar* device;
};

struct _ScanPageInfoClass {
	GTypeClass parent_class;
	void (*finalize) (ScanPageInfo *self);
};

struct _ScanLine {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanLinePrivate * priv;
	gint number;
	gint n_lines;
	gint width;
	gint depth;
	gint channel;
	guchar* data;
	gint data_length1;
	gint data_length;
};

struct _ScanLineClass {
	GTypeClass parent_class;
	void (*finalize) (ScanLine *self);
};

struct _Block6Data {
	int _ref_count_;
	Page* self;
	GFileOutputStream* stream;
};

struct _ParamSpecPage {
	GParamSpec parent_instance;
};


static gpointer page_parent_class = NULL;

GType scan_direction_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page (GValue* value, gpointer v_object);
void value_take_page (GValue* value, gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
#define PAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE, PagePrivate))
Page* page_new (gint width, gint height, gint dpi, ScanDirection scan_direction);
Page* page_construct (GType object_type, gint width, gint height, gint dpi, ScanDirection scan_direction);
static void page_set_scan_width (Page* self, gint value);
static void page_set_scan_height (Page* self, gint value);
static void page_set_dpi (Page* self, gint value);
void page_set_scan_direction (Page* self, ScanDirection value);
Page* page_new_from_data (gint scan_width, gint scan_height, gint rowstride, gint n_channels, gint depth, gint dpi, ScanDirection scan_direction, const gchar* color_profile, guchar* pixels, int pixels_length1, gboolean has_crop, const gchar* crop_name, gint crop_x, gint crop_y, gint crop_width, gint crop_height);
Page* page_construct_from_data (GType object_type, gint scan_width, gint scan_height, gint rowstride, gint n_channels, gint depth, gint dpi, ScanDirection scan_direction, const gchar* color_profile, guchar* pixels, int pixels_length1, gboolean has_crop, const gchar* crop_name, gint crop_x, gint crop_y, gint crop_width, gint crop_height);
static void page_set_rowstride (Page* self, gint value);
static void page_set_n_channels (Page* self, gint value);
static void page_set_depth (Page* self, gint value);
void page_set_color_profile (Page* self, const gchar* value);
static guchar* _vala_array_dup5 (guchar* self, int length);
static void page_set_has_data (Page* self, gboolean value);
static void page_set_has_crop (Page* self, gboolean value);
static void page_set_crop_name (Page* self, const gchar* value);
static void page_set_crop_x (Page* self, gint value);
static void page_set_crop_y (Page* self, gint value);
static void page_set_crop_width (Page* self, gint value);
static void page_set_crop_height (Page* self, gint value);
gpointer scan_page_info_ref (gpointer instance);
void scan_page_info_unref (gpointer instance);
GParamSpec* param_spec_scan_page_info (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_scan_page_info (GValue* value, gpointer v_object);
void value_take_scan_page_info (GValue* value, gpointer v_object);
gpointer value_get_scan_page_info (const GValue* value);
GType scan_page_info_get_type (void) G_GNUC_CONST;
void page_set_page_info (Page* self, ScanPageInfo* info);
gint page_get_scan_height (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
gint page_get_rowstride (Page* self);
void page_start (Page* self);
static void page_set_is_scanning (Page* self, gboolean value);
gpointer scan_line_ref (gpointer instance);
void scan_line_unref (gpointer instance);
GParamSpec* param_spec_scan_line (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_scan_line (GValue* value, gpointer v_object);
void value_take_scan_line (GValue* value, gpointer v_object);
gpointer value_get_scan_line (const GValue* value);
GType scan_line_get_type (void) G_GNUC_CONST;
static void page_parse_line (Page* self, ScanLine* line, gint n, gboolean* size_changed);
static void page_set_scan_line (Page* self, gint value);
void page_parse_scan_line (Page* self, ScanLine* line);
void page_finish (Page* self);
gint page_get_scan_line (Page* self);
void page_rotate_left (Page* self);
ScanDirection page_get_scan_direction (Page* self);
void page_rotate_right (Page* self);
void page_set_no_crop (Page* self);
gboolean page_get_has_crop (Page* self);
void page_set_custom_crop (Page* self, gint width, gint height);
const gchar* page_get_crop_name (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
void page_set_named_crop (Page* self, const gchar* name);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gint page_get_dpi (Page* self);
void page_move_crop (Page* self, gint x, gint y);
void page_rotate_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
guchar* page_get_pixels (Page* self, int* result_length1);
static guchar page_get_sample (Page* self, guchar* pixels, int pixels_length1, gint offset, gint x, gint depth, gint n_channels, gint channel);
static void page_get_pixel (Page* self, gint x, gint y, guchar* pixel, int pixel_length1, gint offset);
GdkPixbuf* page_get_image (Page* self, gboolean apply_crop);
gchar* page_get_icc_data_encoded (Page* self);
const gchar* page_get_color_profile (Page* self);
void page_copy_to_clipboard (Page* self, GtkWindow* window);
void page_save_png (Page* self, GFile* file, GError** error);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda17_ (Block6Data* _data6_, guint8* buf, int buf_length1, GError** error);
static gboolean ___lambda17__gdk_pixbuf_save_func (guint8* buf, gsize buf_length1, GError** error, gpointer self);
gboolean page_get_is_landscape (Page* self);
gboolean page_get_is_scanning (Page* self);
gboolean page_get_has_data (Page* self);
gboolean page_get_is_color (Page* self);
static void page_finalize (Page * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType scan_direction_get_type (void) {
	static volatile gsize scan_direction_type_id__volatile = 0;
	if (g_once_init_enter (&scan_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{SCAN_DIRECTION_TOP_TO_BOTTOM, "SCAN_DIRECTION_TOP_TO_BOTTOM", "top-to-bottom"}, {SCAN_DIRECTION_LEFT_TO_RIGHT, "SCAN_DIRECTION_LEFT_TO_RIGHT", "left-to-right"}, {SCAN_DIRECTION_BOTTOM_TO_TOP, "SCAN_DIRECTION_BOTTOM_TO_TOP", "bottom-to-top"}, {SCAN_DIRECTION_RIGHT_TO_LEFT, "SCAN_DIRECTION_RIGHT_TO_LEFT", "right-to-left"}, {0, NULL, NULL}};
		GType scan_direction_type_id;
		scan_direction_type_id = g_enum_register_static ("ScanDirection", values);
		g_once_init_leave (&scan_direction_type_id__volatile, scan_direction_type_id);
	}
	return scan_direction_type_id__volatile;
}


Page* page_construct (GType object_type, gint width, gint height, gint dpi, ScanDirection scan_direction) {
	Page* self = NULL;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	gint _tmp7_;
	ScanDirection _tmp8_;
	self = (Page*) g_type_create_instance (object_type);
	_tmp1_ = scan_direction;
	if (_tmp1_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		ScanDirection _tmp2_;
		_tmp2_ = scan_direction;
		_tmp0_ = _tmp2_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		gint _tmp3_;
		gint _tmp4_;
		_tmp3_ = width;
		page_set_scan_width (self, _tmp3_);
		_tmp4_ = height;
		page_set_scan_height (self, _tmp4_);
	} else {
		gint _tmp5_;
		gint _tmp6_;
		_tmp5_ = height;
		page_set_scan_width (self, _tmp5_);
		_tmp6_ = width;
		page_set_scan_height (self, _tmp6_);
	}
	_tmp7_ = dpi;
	page_set_dpi (self, _tmp7_);
	_tmp8_ = scan_direction;
	page_set_scan_direction (self, _tmp8_);
	return self;
}


Page* page_new (gint width, gint height, gint dpi, ScanDirection scan_direction) {
	return page_construct (TYPE_PAGE, width, height, dpi, scan_direction);
}


static guchar* _vala_array_dup5 (guchar* self, int length) {
	return g_memdup (self, length * sizeof (guchar));
}


Page* page_construct_from_data (GType object_type, gint scan_width, gint scan_height, gint rowstride, gint n_channels, gint depth, gint dpi, ScanDirection scan_direction, const gchar* color_profile, guchar* pixels, int pixels_length1, gboolean has_crop, const gchar* crop_name, gint crop_x, gint crop_y, gint crop_width, gint crop_height) {
	Page* self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	ScanDirection _tmp7_;
	const gchar* _tmp8_;
	guchar* _tmp9_;
	gint _tmp9__length1;
	guchar* _tmp10_;
	gint _tmp10__length1;
	guchar* _tmp11_;
	gint _tmp11__length1;
	gboolean _tmp12_;
	const gchar* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	self = (Page*) g_type_create_instance (object_type);
	_tmp0_ = scan_width;
	page_set_scan_width (self, _tmp0_);
	_tmp1_ = scan_height;
	page_set_scan_height (self, _tmp1_);
	_tmp2_ = scan_height;
	self->priv->expected_rows = _tmp2_;
	_tmp3_ = rowstride;
	page_set_rowstride (self, _tmp3_);
	_tmp4_ = n_channels;
	page_set_n_channels (self, _tmp4_);
	_tmp5_ = depth;
	page_set_depth (self, _tmp5_);
	_tmp6_ = dpi;
	page_set_dpi (self, _tmp6_);
	_tmp7_ = scan_direction;
	page_set_scan_direction (self, _tmp7_);
	_tmp8_ = color_profile;
	page_set_color_profile (self, _tmp8_);
	_tmp9_ = pixels;
	_tmp9__length1 = pixels_length1;
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup5 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
	_tmp10__length1 = _tmp9__length1;
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
	self->priv->pixels = _tmp10_;
	self->priv->pixels_length1 = _tmp10__length1;
	self->priv->_pixels_size_ = self->priv->pixels_length1;
	_tmp11_ = pixels;
	_tmp11__length1 = pixels_length1;
	page_set_has_data (self, _tmp11_ != NULL);
	_tmp12_ = has_crop;
	page_set_has_crop (self, _tmp12_);
	_tmp13_ = crop_name;
	page_set_crop_name (self, _tmp13_);
	_tmp14_ = crop_x;
	page_set_crop_x (self, _tmp14_);
	_tmp15_ = crop_y;
	page_set_crop_y (self, _tmp15_);
	_tmp16_ = crop_width;
	page_set_crop_width (self, _tmp16_);
	_tmp17_ = crop_height;
	page_set_crop_height (self, _tmp17_);
	return self;
}


Page* page_new_from_data (gint scan_width, gint scan_height, gint rowstride, gint n_channels, gint depth, gint dpi, ScanDirection scan_direction, const gchar* color_profile, guchar* pixels, int pixels_length1, gboolean has_crop, const gchar* crop_name, gint crop_x, gint crop_y, gint crop_width, gint crop_height) {
	return page_construct_from_data (TYPE_PAGE, scan_width, scan_height, rowstride, n_channels, depth, dpi, scan_direction, color_profile, pixels, pixels_length1, has_crop, crop_name, crop_x, crop_y, crop_width, crop_height);
}


void page_set_page_info (Page* self, ScanPageInfo* info) {
	ScanPageInfo* _tmp0_;
	gint _tmp1_;
	ScanPageInfo* _tmp2_;
	gdouble _tmp3_;
	ScanPageInfo* _tmp4_;
	gint _tmp5_;
	ScanPageInfo* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ScanPageInfo* _tmp10_;
	gint _tmp11_;
	ScanPageInfo* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	guchar* _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = info;
	_tmp1_ = _tmp0_->height;
	self->priv->expected_rows = _tmp1_;
	_tmp2_ = info;
	_tmp3_ = _tmp2_->dpi;
	page_set_dpi (self, (gint) _tmp3_);
	_tmp4_ = info;
	_tmp5_ = _tmp4_->width;
	page_set_scan_width (self, _tmp5_);
	_tmp6_ = info;
	_tmp7_ = _tmp6_->height;
	page_set_scan_height (self, _tmp7_);
	_tmp8_ = self->priv->_scan_height;
	if (_tmp8_ < 0) {
		gint _tmp9_;
		_tmp9_ = self->priv->_scan_width;
		page_set_scan_height (self, _tmp9_ / 2);
	}
	_tmp10_ = info;
	_tmp11_ = _tmp10_->depth;
	page_set_depth (self, _tmp11_);
	_tmp12_ = info;
	_tmp13_ = _tmp12_->n_channels;
	page_set_n_channels (self, _tmp13_);
	_tmp14_ = self->priv->_scan_width;
	_tmp15_ = self->priv->_depth;
	_tmp16_ = self->priv->_n_channels;
	page_set_rowstride (self, (((_tmp14_ * _tmp15_) * _tmp16_) + 7) / 8);
	_tmp17_ = self->priv->_scan_height;
	_tmp18_ = self->priv->_rowstride;
	_tmp19_ = _tmp17_ * _tmp18_;
	self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp17_ * _tmp18_);
	(_tmp19_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp19_ - self->priv->pixels_length1)) : NULL;
	self->priv->pixels_length1 = _tmp19_;
	self->priv->_pixels_size_ = _tmp19_;
	_tmp20_ = self->priv->pixels;
	_tmp20__length1 = self->priv->pixels_length1;
	g_return_if_fail (_tmp20_ != NULL);
	_tmp21_ = self->priv->_depth;
	if (_tmp21_ == 1) {
		guchar* _tmp22_;
		gint _tmp22__length1;
		gint _tmp23_;
		gint _tmp24_;
		_tmp22_ = self->priv->pixels;
		_tmp22__length1 = self->priv->pixels_length1;
		_tmp23_ = self->priv->_scan_height;
		_tmp24_ = self->priv->_rowstride;
		memset (_tmp22_, 0x00, (gsize) (_tmp23_ * _tmp24_));
	} else {
		guchar* _tmp25_;
		gint _tmp25__length1;
		gint _tmp26_;
		gint _tmp27_;
		_tmp25_ = self->priv->pixels;
		_tmp25__length1 = self->priv->pixels_length1;
		_tmp26_ = self->priv->_scan_height;
		_tmp27_ = self->priv->_rowstride;
		memset (_tmp25_, 0xFF, (gsize) (_tmp26_ * _tmp27_));
	}
	g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
}


void page_start (Page* self) {
	g_return_if_fail (self != NULL);
	page_set_is_scanning (self, TRUE);
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
}


static void page_parse_line (Page* self, ScanLine* line, gint n, gboolean* size_changed) {
	gboolean _vala_size_changed = FALSE;
	gint line_number = 0;
	ScanLine* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint offset = 0;
	gint _tmp13_;
	gint _tmp14_;
	gint line_offset = 0;
	gint _tmp15_;
	ScanLine* _tmp16_;
	gint _tmp17_;
	gint _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	_tmp0_ = line;
	_tmp1_ = _tmp0_->number;
	_tmp2_ = n;
	line_number = _tmp1_ + _tmp2_;
	_vala_size_changed = FALSE;
	while (TRUE) {
		gint _tmp3_;
		gint _tmp4_;
		gint rows = 0;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp3_ = line_number;
		_tmp4_ = self->priv->_scan_height;
		if (!(_tmp3_ >= _tmp4_)) {
			break;
		}
		_tmp5_ = self->priv->_scan_height;
		rows = _tmp5_;
		_tmp6_ = rows;
		_tmp7_ = self->priv->_scan_width;
		page_set_scan_height (self, _tmp6_ + (_tmp7_ / 2));
		_tmp8_ = rows;
		_tmp9_ = self->priv->_scan_height;
		g_debug ("page.vala:269: Extending image from %d lines to %d lines", _tmp8_, _tmp9_);
		_tmp10_ = self->priv->_scan_height;
		_tmp11_ = self->priv->_rowstride;
		_tmp12_ = _tmp10_ * _tmp11_;
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp10_ * _tmp11_);
		(_tmp12_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp12_ - self->priv->pixels_length1)) : NULL;
		self->priv->pixels_length1 = _tmp12_;
		self->priv->_pixels_size_ = _tmp12_;
		_vala_size_changed = TRUE;
	}
	_tmp13_ = line_number;
	_tmp14_ = self->priv->_rowstride;
	offset = _tmp13_ * _tmp14_;
	_tmp15_ = n;
	_tmp16_ = line;
	_tmp17_ = _tmp16_->data_length;
	line_offset = _tmp15_ * _tmp17_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				gint _tmp20_;
				ScanLine* _tmp21_;
				gint _tmp22_;
				guchar* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				gint _tmp25_;
				ScanLine* _tmp26_;
				guchar* _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_;
				gint _tmp29_;
				guchar _tmp30_;
				guchar _tmp31_;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				_tmp20_ = i;
				_tmp21_ = line;
				_tmp22_ = _tmp21_->data_length;
				if (!(_tmp20_ < _tmp22_)) {
					break;
				}
				_tmp23_ = self->priv->pixels;
				_tmp23__length1 = self->priv->pixels_length1;
				_tmp24_ = offset;
				_tmp25_ = i;
				_tmp26_ = line;
				_tmp27_ = _tmp26_->data;
				_tmp27__length1 = _tmp26_->data_length1;
				_tmp28_ = line_offset;
				_tmp29_ = i;
				_tmp30_ = _tmp27_[_tmp28_ + _tmp29_];
				_tmp23_[_tmp24_ + _tmp25_] = _tmp30_;
				_tmp31_ = _tmp23_[_tmp24_ + _tmp25_];
			}
		}
	}
	_tmp32_ = line_number;
	page_set_scan_line (self, _tmp32_);
	if (size_changed) {
		*size_changed = _vala_size_changed;
	}
}


void page_parse_scan_line (Page* self, ScanLine* line) {
	gboolean size_has_changed = FALSE;
	gboolean _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	size_has_changed = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ScanLine* _tmp3_;
				gint _tmp4_;
				ScanLine* _tmp5_;
				gint _tmp6_;
				gboolean _tmp7_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = line;
				_tmp4_ = _tmp3_->n_lines;
				if (!(_tmp2_ < _tmp4_)) {
					break;
				}
				_tmp5_ = line;
				_tmp6_ = i;
				page_parse_line (self, _tmp5_, _tmp6_, &_tmp7_);
				size_has_changed = _tmp7_;
			}
		}
	}
	page_set_has_data (self, TRUE);
	_tmp8_ = size_has_changed;
	if (_tmp8_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
}


void page_finish (Page* self) {
	gboolean size_has_changed = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	size_has_changed = FALSE;
	_tmp1_ = self->priv->expected_rows;
	if (_tmp1_ < 0) {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = self->priv->_scan_line;
		_tmp3_ = self->priv->_scan_height;
		_tmp0_ = _tmp2_ != _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint rows = 0;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp4_ = self->priv->_scan_height;
		rows = _tmp4_;
		_tmp5_ = self->priv->_scan_line;
		page_set_scan_height (self, _tmp5_);
		_tmp6_ = self->priv->_scan_height;
		_tmp7_ = self->priv->_rowstride;
		_tmp8_ = _tmp6_ * _tmp7_;
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp6_ * _tmp7_);
		(_tmp8_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp8_ - self->priv->pixels_length1)) : NULL;
		self->priv->pixels_length1 = _tmp8_;
		self->priv->_pixels_size_ = _tmp8_;
		_tmp9_ = rows;
		_tmp10_ = self->priv->_scan_height;
		g_debug ("page.vala:309: Trimming page from %d lines to %d lines", _tmp9_, _tmp10_);
		size_has_changed = TRUE;
	}
	page_set_is_scanning (self, FALSE);
	_tmp11_ = size_has_changed;
	if (_tmp11_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
	g_signal_emit (self, page_signals[PAGE_SCAN_FINISHED_SIGNAL], 0);
}


void page_rotate_left (Page* self) {
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
			break;
		}
		default:
		break;
	}
}


void page_rotate_right (Page* self) {
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
			break;
		}
		default:
		break;
	}
}


void page_set_no_crop (Page* self) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_has_crop;
	if (!_tmp0_) {
		return;
	}
	page_set_has_crop (self, FALSE);
	page_set_crop_name (self, NULL);
	page_set_crop_x (self, 0);
	page_set_crop_y (self, 0);
	page_set_crop_width (self, 0);
	page_set_crop_height (self, 0);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void page_set_custom_crop (Page* self, gint width, gint height) {
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gint _tmp11_;
	gint _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = width;
	g_return_if_fail (_tmp0_ >= 1);
	_tmp1_ = height;
	g_return_if_fail (_tmp1_ >= 1);
	_tmp5_ = self->priv->_crop_name;
	if (_tmp5_ == NULL) {
		gboolean _tmp6_;
		_tmp6_ = self->priv->_has_crop;
		_tmp4_ = _tmp6_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = self->priv->_crop_width;
		_tmp8_ = width;
		_tmp3_ = _tmp7_ == _tmp8_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gint _tmp9_;
		gint _tmp10_;
		_tmp9_ = self->priv->_crop_height;
		_tmp10_ = height;
		_tmp2_ = _tmp9_ == _tmp10_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		return;
	}
	page_set_crop_name (self, NULL);
	page_set_has_crop (self, TRUE);
	_tmp11_ = width;
	page_set_crop_width (self, _tmp11_);
	_tmp12_ = height;
	page_set_crop_height (self, _tmp12_);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void page_set_named_crop (Page* self, const gchar* name) {
	gdouble w = 0.0;
	gdouble h = 0.0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	const gchar* _tmp5_;
	gint pw = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint ph = 0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gdouble _tmp15_;
	gint _tmp16_;
	gdouble _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp23_;
	gint _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = name;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("A4")))) {
		switch (0) {
			default:
			{
				w = 8.3;
				h = 11.7;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("A5")))) {
		switch (0) {
			default:
			{
				w = 5.8;
				h = 8.3;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("A6")))) {
		switch (0) {
			default:
			{
				w = 4.1;
				h = 5.8;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("letter")))) {
		switch (0) {
			default:
			{
				w = 8.5;
				h = (gdouble) 11;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("legal")))) {
		switch (0) {
			default:
			{
				w = 8.5;
				h = (gdouble) 14;
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("4x6")))) {
		switch (0) {
			default:
			{
				w = (gdouble) 4;
				h = (gdouble) 6;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				const gchar* _tmp4_;
				_tmp4_ = name;
				g_warning ("page.vala:429: Unknown paper size '%s'", _tmp4_);
				return;
			}
		}
	}
	_tmp5_ = name;
	page_set_crop_name (self, _tmp5_);
	page_set_has_crop (self, TRUE);
	_tmp6_ = page_get_width (self);
	_tmp7_ = _tmp6_;
	pw = _tmp7_;
	_tmp8_ = page_get_height (self);
	_tmp9_ = _tmp8_;
	ph = _tmp9_;
	_tmp10_ = pw;
	_tmp11_ = ph;
	if (_tmp10_ > _tmp11_) {
		gdouble t = 0.0;
		gdouble _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		_tmp12_ = w;
		t = _tmp12_;
		_tmp13_ = h;
		w = _tmp13_;
		_tmp14_ = t;
		h = _tmp14_;
	}
	_tmp15_ = w;
	_tmp16_ = self->priv->_dpi;
	page_set_crop_width (self, (gint) ((_tmp15_ * _tmp16_) + 0.5));
	_tmp17_ = h;
	_tmp18_ = self->priv->_dpi;
	page_set_crop_height (self, (gint) ((_tmp17_ * _tmp18_) + 0.5));
	_tmp19_ = self->priv->_crop_width;
	_tmp20_ = pw;
	if (_tmp19_ < _tmp20_) {
		gint _tmp21_;
		gint _tmp22_;
		_tmp21_ = pw;
		_tmp22_ = self->priv->_crop_width;
		page_set_crop_x (self, (_tmp21_ - _tmp22_) / 2);
	} else {
		page_set_crop_x (self, 0);
	}
	_tmp23_ = self->priv->_crop_height;
	_tmp24_ = ph;
	if (_tmp23_ < _tmp24_) {
		gint _tmp25_;
		gint _tmp26_;
		_tmp25_ = ph;
		_tmp26_ = self->priv->_crop_height;
		page_set_crop_y (self, (_tmp25_ - _tmp26_) / 2);
	} else {
		page_set_crop_y (self, 0);
	}
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void page_move_crop (Page* self, gint x, gint y) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = x;
	g_return_if_fail (_tmp0_ >= 0);
	_tmp1_ = y;
	g_return_if_fail (_tmp1_ >= 0);
	_tmp2_ = x;
	_tmp3_ = page_get_width (self);
	_tmp4_ = _tmp3_;
	g_return_if_fail (_tmp2_ < _tmp4_);
	_tmp5_ = y;
	_tmp6_ = page_get_height (self);
	_tmp7_ = _tmp6_;
	g_return_if_fail (_tmp5_ < _tmp7_);
	_tmp8_ = x;
	page_set_crop_x (self, _tmp8_);
	_tmp9_ = y;
	page_set_crop_y (self, _tmp9_);
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


void page_rotate_crop (Page* self) {
	gboolean _tmp0_;
	gint t = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_has_crop;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_crop_width;
	t = _tmp1_;
	_tmp2_ = self->priv->_crop_height;
	page_set_crop_width (self, _tmp2_);
	_tmp3_ = t;
	page_set_crop_height (self, _tmp3_);
	_tmp4_ = self->priv->_crop_name;
	if (_tmp4_ == NULL) {
		gint w = 0;
		gint _tmp5_;
		gint _tmp6_;
		gint h = 0;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp14_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _tmp21_;
		_tmp5_ = page_get_width (self);
		_tmp6_ = _tmp5_;
		w = _tmp6_;
		_tmp7_ = page_get_height (self);
		_tmp8_ = _tmp7_;
		h = _tmp8_;
		_tmp9_ = self->priv->_crop_x;
		_tmp10_ = self->priv->_crop_width;
		_tmp11_ = w;
		if ((_tmp9_ + _tmp10_) > _tmp11_) {
			gint _tmp12_;
			gint _tmp13_;
			_tmp12_ = w;
			_tmp13_ = self->priv->_crop_width;
			page_set_crop_x (self, _tmp12_ - _tmp13_);
		}
		_tmp14_ = self->priv->_crop_x;
		if (_tmp14_ < 0) {
			gint _tmp15_;
			page_set_crop_x (self, 0);
			_tmp15_ = w;
			page_set_crop_width (self, _tmp15_);
		}
		_tmp16_ = self->priv->_crop_y;
		_tmp17_ = self->priv->_crop_height;
		_tmp18_ = h;
		if ((_tmp16_ + _tmp17_) > _tmp18_) {
			gint _tmp19_;
			gint _tmp20_;
			_tmp19_ = h;
			_tmp20_ = self->priv->_crop_height;
			page_set_crop_y (self, _tmp19_ - _tmp20_);
		}
		_tmp21_ = self->priv->_crop_y;
		if (_tmp21_ < 0) {
			gint _tmp22_;
			page_set_crop_y (self, 0);
			_tmp22_ = h;
			page_set_crop_height (self, _tmp22_);
		}
	}
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
}


guchar* page_get_pixels (Page* self, int* result_length1) {
	guchar* result = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	guchar* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->pixels;
	_tmp0__length1 = self->priv->pixels_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static guchar page_get_sample (Page* self, guchar* pixels, int pixels_length1, gint offset, gint x, gint depth, gint n_channels, gint channel) {
	guchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = (guchar) 0xFF;
	return result;
}


static void page_get_pixel (Page* self, gint x, gint y, guchar* pixel, int pixel_length1, gint offset) {
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint line_offset = 0;
	gint _tmp14_;
	gint _tmp15_;
	gboolean _tmp16_ = FALSE;
	gint _tmp17_;
	guchar* _tmp98_;
	gint _tmp98__length1;
	gint _tmp99_;
	guchar* _tmp100_;
	gint _tmp100__length1;
	gint _tmp101_;
	gint _tmp102_;
	gint _tmp103_;
	gint _tmp104_;
	guchar _tmp105_;
	guchar _tmp106_;
	guchar* _tmp107_;
	gint _tmp107__length1;
	gint _tmp108_;
	guchar* _tmp109_;
	gint _tmp109__length1;
	gint _tmp110_;
	gint _tmp111_;
	gint _tmp112_;
	gint _tmp113_;
	guchar _tmp114_;
	guchar _tmp115_;
	guchar* _tmp116_;
	gint _tmp116__length1;
	gint _tmp117_;
	guchar* _tmp118_;
	gint _tmp118__length1;
	gint _tmp119_;
	gint _tmp120_;
	gint _tmp121_;
	gint _tmp122_;
	guchar _tmp123_;
	guchar _tmp124_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_get_scan_direction (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
		{
			break;
		}
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp2_ = self->priv->_scan_width;
			_tmp3_ = x;
			x = (_tmp2_ - _tmp3_) - 1;
			_tmp4_ = self->priv->_scan_height;
			_tmp5_ = y;
			y = (_tmp4_ - _tmp5_) - 1;
			break;
		}
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			_tmp6_ = x;
			t = _tmp6_;
			_tmp7_ = self->priv->_scan_width;
			_tmp8_ = y;
			x = (_tmp7_ - _tmp8_) - 1;
			_tmp9_ = t;
			y = _tmp9_;
			break;
		}
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
		{
			gint t = 0;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			_tmp10_ = x;
			t = _tmp10_;
			_tmp11_ = y;
			x = _tmp11_;
			_tmp12_ = self->priv->_scan_height;
			_tmp13_ = t;
			y = (_tmp12_ - _tmp13_) - 1;
			break;
		}
		default:
		break;
	}
	_tmp14_ = self->priv->_rowstride;
	_tmp15_ = y;
	line_offset = _tmp14_ * _tmp15_;
	_tmp17_ = self->priv->_depth;
	if (_tmp17_ == 8) {
		gint _tmp18_;
		_tmp18_ = self->priv->_n_channels;
		_tmp16_ = _tmp18_ == 3;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		gint o = 0;
		gint _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		guchar* _tmp22_;
		gint _tmp22__length1;
		gint _tmp23_;
		guchar* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		guchar _tmp26_;
		guchar _tmp27_;
		guchar* _tmp28_;
		gint _tmp28__length1;
		gint _tmp29_;
		guchar* _tmp30_;
		gint _tmp30__length1;
		gint _tmp31_;
		guchar _tmp32_;
		guchar _tmp33_;
		guchar* _tmp34_;
		gint _tmp34__length1;
		gint _tmp35_;
		guchar* _tmp36_;
		gint _tmp36__length1;
		gint _tmp37_;
		guchar _tmp38_;
		guchar _tmp39_;
		_tmp19_ = line_offset;
		_tmp20_ = x;
		_tmp21_ = self->priv->_n_channels;
		o = _tmp19_ + (_tmp20_ * _tmp21_);
		_tmp22_ = pixel;
		_tmp22__length1 = pixel_length1;
		_tmp23_ = offset;
		_tmp24_ = self->priv->pixels;
		_tmp24__length1 = self->priv->pixels_length1;
		_tmp25_ = o;
		_tmp26_ = _tmp24_[_tmp25_];
		_tmp22_[_tmp23_ + 0] = _tmp26_;
		_tmp27_ = _tmp22_[_tmp23_ + 0];
		_tmp28_ = pixel;
		_tmp28__length1 = pixel_length1;
		_tmp29_ = offset;
		_tmp30_ = self->priv->pixels;
		_tmp30__length1 = self->priv->pixels_length1;
		_tmp31_ = o;
		_tmp32_ = _tmp30_[_tmp31_ + 1];
		_tmp28_[_tmp29_ + 1] = _tmp32_;
		_tmp33_ = _tmp28_[_tmp29_ + 1];
		_tmp34_ = pixel;
		_tmp34__length1 = pixel_length1;
		_tmp35_ = offset;
		_tmp36_ = self->priv->pixels;
		_tmp36__length1 = self->priv->pixels_length1;
		_tmp37_ = o;
		_tmp38_ = _tmp36_[_tmp37_ + 2];
		_tmp34_[_tmp35_ + 2] = _tmp38_;
		_tmp39_ = _tmp34_[_tmp35_ + 2];
		return;
	} else {
		gboolean _tmp40_ = FALSE;
		gint _tmp41_;
		_tmp41_ = self->priv->_depth;
		if (_tmp41_ == 8) {
			gint _tmp42_;
			_tmp42_ = self->priv->_n_channels;
			_tmp40_ = _tmp42_ == 1;
		} else {
			_tmp40_ = FALSE;
		}
		if (_tmp40_) {
			guchar p = '\0';
			guchar* _tmp43_;
			gint _tmp43__length1;
			gint _tmp44_;
			gint _tmp45_;
			guchar _tmp46_;
			guchar* _tmp47_;
			gint _tmp47__length1;
			gint _tmp48_;
			guchar* _tmp49_;
			gint _tmp49__length1;
			gint _tmp50_;
			guchar* _tmp51_;
			gint _tmp51__length1;
			gint _tmp52_;
			guchar _tmp53_;
			guchar _tmp54_;
			guchar _tmp55_;
			guchar _tmp56_;
			_tmp43_ = self->priv->pixels;
			_tmp43__length1 = self->priv->pixels_length1;
			_tmp44_ = line_offset;
			_tmp45_ = x;
			_tmp46_ = _tmp43_[_tmp44_ + _tmp45_];
			p = _tmp46_;
			_tmp47_ = pixel;
			_tmp47__length1 = pixel_length1;
			_tmp48_ = offset;
			_tmp49_ = pixel;
			_tmp49__length1 = pixel_length1;
			_tmp50_ = offset;
			_tmp51_ = pixel;
			_tmp51__length1 = pixel_length1;
			_tmp52_ = offset;
			_tmp53_ = p;
			_tmp51_[_tmp52_ + 2] = _tmp53_;
			_tmp54_ = _tmp51_[_tmp52_ + 2];
			_tmp49_[_tmp50_ + 1] = _tmp54_;
			_tmp55_ = _tmp49_[_tmp50_ + 1];
			_tmp47_[_tmp48_ + 0] = _tmp55_;
			_tmp56_ = _tmp47_[_tmp48_ + 0];
			return;
		} else {
			gboolean _tmp57_ = FALSE;
			gint _tmp58_;
			_tmp58_ = self->priv->_depth;
			if (_tmp58_ == 1) {
				gint _tmp59_;
				_tmp59_ = self->priv->_n_channels;
				_tmp57_ = _tmp59_ == 1;
			} else {
				_tmp57_ = FALSE;
			}
			if (_tmp57_) {
				guchar p = '\0';
				guchar* _tmp60_;
				gint _tmp60__length1;
				gint _tmp61_;
				gint _tmp62_;
				guchar _tmp63_;
				gint _tmp64_ = 0;
				guchar _tmp65_;
				gint _tmp66_;
				guchar* _tmp67_;
				gint _tmp67__length1;
				gint _tmp68_;
				guchar* _tmp69_;
				gint _tmp69__length1;
				gint _tmp70_;
				guchar* _tmp71_;
				gint _tmp71__length1;
				gint _tmp72_;
				guchar _tmp73_;
				guchar _tmp74_;
				guchar _tmp75_;
				_tmp60_ = self->priv->pixels;
				_tmp60__length1 = self->priv->pixels_length1;
				_tmp61_ = line_offset;
				_tmp62_ = x;
				_tmp63_ = _tmp60_[_tmp61_ + (_tmp62_ / 8)];
				p = _tmp63_;
				_tmp65_ = p;
				_tmp66_ = x;
				if (((gint) (_tmp65_ & (0x80 >> (_tmp66_ % 8)))) != 0) {
					_tmp64_ = 0x00;
				} else {
					_tmp64_ = 0xFF;
				}
				_tmp67_ = pixel;
				_tmp67__length1 = pixel_length1;
				_tmp68_ = offset;
				_tmp69_ = pixel;
				_tmp69__length1 = pixel_length1;
				_tmp70_ = offset;
				_tmp71_ = pixel;
				_tmp71__length1 = pixel_length1;
				_tmp72_ = offset;
				_tmp71_[_tmp72_ + 2] = (guchar) _tmp64_;
				_tmp73_ = _tmp71_[_tmp72_ + 2];
				_tmp69_[_tmp70_ + 1] = _tmp73_;
				_tmp74_ = _tmp69_[_tmp70_ + 1];
				_tmp67_[_tmp68_ + 0] = _tmp74_;
				_tmp75_ = _tmp67_[_tmp68_ + 0];
				return;
			} else {
				gboolean _tmp76_ = FALSE;
				gint _tmp77_;
				_tmp77_ = self->priv->_depth;
				if (_tmp77_ == 2) {
					gint _tmp78_;
					_tmp78_ = self->priv->_n_channels;
					_tmp76_ = _tmp78_ == 1;
				} else {
					_tmp76_ = FALSE;
				}
				if (_tmp76_) {
					gint block_shift[4] = {0};
					gint _tmp79_[4] = {0};
					guchar p = '\0';
					guchar* _tmp80_;
					gint _tmp80__length1;
					gint _tmp81_;
					gint _tmp82_;
					guchar _tmp83_;
					gint sample = 0;
					guchar _tmp84_;
					gint _tmp85_;
					gint _tmp86_;
					gint _tmp87_;
					guchar* _tmp88_;
					gint _tmp88__length1;
					gint _tmp89_;
					guchar* _tmp90_;
					gint _tmp90__length1;
					gint _tmp91_;
					guchar* _tmp92_;
					gint _tmp92__length1;
					gint _tmp93_;
					gint _tmp94_;
					guchar _tmp95_;
					guchar _tmp96_;
					guchar _tmp97_;
					_tmp79_[0] = 6;
					_tmp79_[1] = 4;
					_tmp79_[2] = 2;
					_tmp79_[3] = 0;
					memcpy (block_shift, _tmp79_, 4 * sizeof (gint));
					_tmp80_ = self->priv->pixels;
					_tmp80__length1 = self->priv->pixels_length1;
					_tmp81_ = line_offset;
					_tmp82_ = x;
					_tmp83_ = _tmp80_[_tmp81_ + (_tmp82_ / 4)];
					p = _tmp83_;
					_tmp84_ = p;
					_tmp85_ = x;
					_tmp86_ = block_shift[_tmp85_ % 4];
					sample = (_tmp84_ >> _tmp86_) & 0x3;
					_tmp87_ = sample;
					sample = (_tmp87_ * 255) / 3;
					_tmp88_ = pixel;
					_tmp88__length1 = pixel_length1;
					_tmp89_ = offset;
					_tmp90_ = pixel;
					_tmp90__length1 = pixel_length1;
					_tmp91_ = offset;
					_tmp92_ = pixel;
					_tmp92__length1 = pixel_length1;
					_tmp93_ = offset;
					_tmp94_ = sample;
					_tmp92_[_tmp93_ + 2] = (guchar) _tmp94_;
					_tmp95_ = _tmp92_[_tmp93_ + 2];
					_tmp90_[_tmp91_ + 1] = _tmp95_;
					_tmp96_ = _tmp90_[_tmp91_ + 1];
					_tmp88_[_tmp89_ + 0] = _tmp96_;
					_tmp97_ = _tmp88_[_tmp89_ + 0];
					return;
				}
			}
		}
	}
	_tmp98_ = pixel;
	_tmp98__length1 = pixel_length1;
	_tmp99_ = offset;
	_tmp100_ = self->priv->pixels;
	_tmp100__length1 = self->priv->pixels_length1;
	_tmp101_ = line_offset;
	_tmp102_ = x;
	_tmp103_ = self->priv->_depth;
	_tmp104_ = self->priv->_n_channels;
	_tmp105_ = page_get_sample (self, _tmp100_, _tmp100__length1, _tmp101_, _tmp102_, _tmp103_, _tmp104_, 0);
	_tmp98_[_tmp99_ + 0] = _tmp105_;
	_tmp106_ = _tmp98_[_tmp99_ + 0];
	_tmp107_ = pixel;
	_tmp107__length1 = pixel_length1;
	_tmp108_ = offset;
	_tmp109_ = self->priv->pixels;
	_tmp109__length1 = self->priv->pixels_length1;
	_tmp110_ = line_offset;
	_tmp111_ = x;
	_tmp112_ = self->priv->_depth;
	_tmp113_ = self->priv->_n_channels;
	_tmp114_ = page_get_sample (self, _tmp109_, _tmp109__length1, _tmp110_, _tmp111_, _tmp112_, _tmp113_, 1);
	_tmp107_[_tmp108_ + 1] = _tmp114_;
	_tmp115_ = _tmp107_[_tmp108_ + 1];
	_tmp116_ = pixel;
	_tmp116__length1 = pixel_length1;
	_tmp117_ = offset;
	_tmp118_ = self->priv->pixels;
	_tmp118__length1 = self->priv->pixels_length1;
	_tmp119_ = line_offset;
	_tmp120_ = x;
	_tmp121_ = self->priv->_depth;
	_tmp122_ = self->priv->_n_channels;
	_tmp123_ = page_get_sample (self, _tmp118_, _tmp118__length1, _tmp119_, _tmp120_, _tmp121_, _tmp122_, 2);
	_tmp116_[_tmp117_ + 2] = _tmp123_;
	_tmp124_ = _tmp116_[_tmp117_ + 2];
}


GdkPixbuf* page_get_image (Page* self, gboolean apply_crop) {
	GdkPixbuf* result = NULL;
	gint l = 0;
	gint r = 0;
	gint t = 0;
	gint b = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GdkPixbuf* image = NULL;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GdkPixbuf* _tmp29_;
	guint8* image_pixels = NULL;
	GdkPixbuf* _tmp30_;
	guint8* _tmp31_;
	gint image_pixels_length1;
	gint _image_pixels_size_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = apply_crop;
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_has_crop;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		_tmp3_ = self->priv->_crop_x;
		l = _tmp3_;
		_tmp4_ = l;
		_tmp5_ = self->priv->_crop_width;
		r = _tmp4_ + _tmp5_;
		_tmp6_ = self->priv->_crop_y;
		t = _tmp6_;
		_tmp7_ = t;
		_tmp8_ = self->priv->_crop_height;
		b = _tmp7_ + _tmp8_;
		_tmp9_ = l;
		if (_tmp9_ < 0) {
			l = 0;
		}
		_tmp10_ = r;
		_tmp11_ = page_get_width (self);
		_tmp12_ = _tmp11_;
		if (_tmp10_ > _tmp12_) {
			gint _tmp13_;
			gint _tmp14_;
			_tmp13_ = page_get_width (self);
			_tmp14_ = _tmp13_;
			r = _tmp14_;
		}
		_tmp15_ = t;
		if (_tmp15_ < 0) {
			t = 0;
		}
		_tmp16_ = b;
		_tmp17_ = page_get_height (self);
		_tmp18_ = _tmp17_;
		if (_tmp16_ > _tmp18_) {
			gint _tmp19_;
			gint _tmp20_;
			_tmp19_ = page_get_height (self);
			_tmp20_ = _tmp19_;
			b = _tmp20_;
		}
	} else {
		gint _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		l = 0;
		_tmp21_ = page_get_width (self);
		_tmp22_ = _tmp21_;
		r = _tmp22_;
		t = 0;
		_tmp23_ = page_get_height (self);
		_tmp24_ = _tmp23_;
		b = _tmp24_;
	}
	_tmp25_ = r;
	_tmp26_ = l;
	_tmp27_ = b;
	_tmp28_ = t;
	_tmp29_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, _tmp25_ - _tmp26_, _tmp27_ - _tmp28_);
	image = _tmp29_;
	_tmp30_ = image;
	_tmp31_ = gdk_pixbuf_get_pixels (_tmp30_);
	image_pixels = _tmp31_;
	image_pixels_length1 = -1;
	_image_pixels_size_ = image_pixels_length1;
	{
		gint y = 0;
		gint _tmp32_;
		_tmp32_ = t;
		y = _tmp32_;
		{
			gboolean _tmp33_ = FALSE;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint _tmp35_;
				gint _tmp36_;
				gint offset = 0;
				GdkPixbuf* _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = y;
					y = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = y;
				_tmp36_ = b;
				if (!(_tmp35_ < _tmp36_)) {
					break;
				}
				_tmp37_ = image;
				_tmp38_ = gdk_pixbuf_get_rowstride (_tmp37_);
				_tmp39_ = y;
				_tmp40_ = t;
				offset = _tmp38_ * (_tmp39_ - _tmp40_);
				{
					gint x = 0;
					gint _tmp41_;
					_tmp41_ = l;
					x = _tmp41_;
					{
						gboolean _tmp42_ = FALSE;
						_tmp42_ = TRUE;
						while (TRUE) {
							gint _tmp44_;
							gint _tmp45_;
							gint _tmp46_;
							gint _tmp47_;
							guint8* _tmp48_;
							gint _tmp48__length1;
							gint _tmp49_;
							gint _tmp50_;
							gint _tmp51_;
							if (!_tmp42_) {
								gint _tmp43_;
								_tmp43_ = x;
								x = _tmp43_ + 1;
							}
							_tmp42_ = FALSE;
							_tmp44_ = x;
							_tmp45_ = r;
							if (!(_tmp44_ < _tmp45_)) {
								break;
							}
							_tmp46_ = x;
							_tmp47_ = y;
							_tmp48_ = image_pixels;
							_tmp48__length1 = image_pixels_length1;
							_tmp49_ = offset;
							_tmp50_ = x;
							_tmp51_ = l;
							page_get_pixel (self, _tmp46_, _tmp47_, _tmp48_, _tmp48__length1, _tmp49_ + ((_tmp50_ - _tmp51_) * 3));
						}
					}
				}
			}
		}
	}
	result = image;
	return result;
}


static gchar* string_to_utf8 (const gchar* self, int* result_length1) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (gchar, _tmp1_ + 1);
	_result_ = _tmp2_;
	_result__length1 = _tmp1_ + 1;
	__result__size_ = _result__length1;
	_tmp3_ = _result__length1;
	_result__length1 = _tmp3_ - 1;
	_tmp4_ = _result_;
	_tmp4__length1 = _result__length1;
	_tmp5_ = strlen (self);
	_tmp6_ = _tmp5_;
	memcpy (_tmp4_, self, (gsize) _tmp6_);
	_tmp7_ = _result_;
	_tmp7__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}


gchar* page_get_icc_data_encoded (Page* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* contents = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	guchar* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_color_profile;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		_tmp1_ = self->priv->_color_profile;
		g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("page.vala:640: failed to get icc profile data: %s", _tmp4_);
		result = NULL;
		_g_error_free0 (e);
		_g_free0 (contents);
		return result;
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp5_ = contents;
	_tmp7_ = string_to_utf8 (_tmp5_, &_tmp6_);
	_tmp8_ = (guchar*) _tmp7_;
	_tmp8__length1 = (_tmp6_ * sizeof (gchar)) / sizeof (guchar);
	_tmp9_ = g_base64_encode (_tmp8_, (_tmp6_ * sizeof (gchar)) / sizeof (guchar));
	_tmp10_ = _tmp9_;
	_tmp8_ = (g_free (_tmp8_), NULL);
	result = _tmp10_;
	_g_free0 (contents);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void page_copy_to_clipboard (Page* self, GtkWindow* window) {
	GdkDisplay* display = NULL;
	GtkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp3_;
	GtkClipboard* _tmp4_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	_tmp1_ = gtk_widget_get_display ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	display = _tmp2_;
	_tmp3_ = gtk_clipboard_get_for_display (display, GDK_SELECTION_CLIPBOARD);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	clipboard = _tmp4_;
	_tmp5_ = page_get_image (self, TRUE);
	image = _tmp5_;
	gtk_clipboard_set_image (clipboard, image);
	_g_object_unref0 (image);
	_g_object_unref0 (clipboard);
	_g_object_unref0 (display);
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		Page* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->stream);
		_page_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static gboolean __lambda17_ (Block6Data* _data6_, guint8* buf, int buf_length1, GError** error) {
	Page* self;
	gboolean result = FALSE;
	GFileOutputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	GError * _inner_error_ = NULL;
	self = _data6_->self;
	_tmp0_ = _data6_->stream;
	_tmp1_ = buf;
	_tmp1__length1 = buf_length1;
	g_output_stream_write_all ((GOutputStream*) _tmp0_, _tmp1_, (gsize) _tmp1__length1, NULL, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp2_ = FALSE;
		g_propagate_error (error, _inner_error_);
		return _tmp2_;
	}
	result = TRUE;
	return result;
}


static gboolean ___lambda17__gdk_pixbuf_save_func (guint8* buf, gsize buf_length1, GError** error, gpointer self) {
	gboolean result;
	result = __lambda17_ (self, buf, buf_length1, error);
	return result;
}


void page_save_png (Page* self, GFile* file, GError** error) {
	Block6Data* _data6_;
	GFile* _tmp0_;
	GFileOutputStream* _tmp1_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp2_;
	gchar* icc_profile_data = NULL;
	const gchar* _tmp3_;
	gchar** keys = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint keys_length1;
	gint _keys_size_;
	gchar** values = NULL;
	gint _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint values_length1;
	gint _values_size_;
	const gchar* _tmp16_;
	GdkPixbuf* _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar** _tmp21_;
	gint _tmp21__length1;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = page_ref (self);
	_tmp0_ = file;
	_tmp1_ = g_file_replace (_tmp0_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	_data6_->stream = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	_tmp2_ = page_get_image (self, TRUE);
	image = _tmp2_;
	icc_profile_data = NULL;
	_tmp3_ = self->priv->_color_profile;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_;
		_tmp4_ = page_get_icc_data_encoded (self);
		_g_free0 (icc_profile_data);
		icc_profile_data = _tmp4_;
	}
	_tmp5_ = g_strdup ("x-dpi");
	_tmp6_ = g_strdup ("y-dpi");
	_tmp7_ = g_strdup ("icc-profile");
	_tmp8_ = g_new0 (gchar*, 4 + 1);
	_tmp8_[0] = _tmp5_;
	_tmp8_[1] = _tmp6_;
	_tmp8_[2] = _tmp7_;
	_tmp8_[3] = NULL;
	keys = _tmp8_;
	keys_length1 = 4;
	_keys_size_ = keys_length1;
	_tmp9_ = self->priv->_dpi;
	_tmp10_ = g_strdup_printf ("%d", _tmp9_);
	_tmp11_ = self->priv->_dpi;
	_tmp12_ = g_strdup_printf ("%d", _tmp11_);
	_tmp13_ = icc_profile_data;
	_tmp14_ = g_strdup (_tmp13_);
	_tmp15_ = g_new0 (gchar*, 4 + 1);
	_tmp15_[0] = _tmp10_;
	_tmp15_[1] = _tmp12_;
	_tmp15_[2] = _tmp14_;
	_tmp15_[3] = NULL;
	values = _tmp15_;
	values_length1 = 4;
	_values_size_ = values_length1;
	_tmp16_ = icc_profile_data;
	if (_tmp16_ == NULL) {
		gchar** _tmp17_;
		gint _tmp17__length1;
		gchar* _tmp18_;
		_tmp17_ = keys;
		_tmp17__length1 = keys_length1;
		_g_free0 (_tmp17_[2]);
		_tmp17_[2] = NULL;
		_tmp18_ = _tmp17_[2];
	}
	_tmp19_ = image;
	_tmp20_ = keys;
	_tmp20__length1 = keys_length1;
	_tmp21_ = values;
	_tmp21__length1 = values_length1;
	gdk_pixbuf_save_to_callbackv (_tmp19_, ___lambda17__gdk_pixbuf_save_func, _data6_, "png", _tmp20_, _tmp21_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (icc_profile_data);
		_g_object_unref0 (image);
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (icc_profile_data);
	_g_object_unref0 (image);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


gint page_get_width (Page* self) {
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = page_get_scan_direction (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
		_tmp3_ = page_get_scan_direction (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_scan_width;
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_scan_height;
		result = _tmp6_;
		return result;
	}
}


gint page_get_height (Page* self) {
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = page_get_scan_direction (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
		_tmp0_ = TRUE;
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
		_tmp3_ = page_get_scan_direction (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
	}
	if (_tmp0_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_scan_height;
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_scan_width;
		result = _tmp6_;
		return result;
	}
}


gboolean page_get_is_landscape (Page* self) {
	gboolean result;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = page_get_width (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = page_get_height (self);
	_tmp3_ = _tmp2_;
	result = _tmp1_ > _tmp3_;
	return result;
}


gint page_get_dpi (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dpi;
	result = _tmp0_;
	return result;
}


static void page_set_dpi (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_dpi = _tmp0_;
}


gint page_get_depth (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_depth;
	result = _tmp0_;
	return result;
}


static void page_set_depth (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_depth = _tmp0_;
}


const gchar* page_get_color_profile (Page* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_color_profile;
	result = _tmp0_;
	return result;
}


void page_set_color_profile (Page* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_color_profile);
	self->priv->_color_profile = _tmp1_;
}


gint page_get_scan_width (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_width;
	result = _tmp0_;
	return result;
}


static void page_set_scan_width (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_scan_width = _tmp0_;
}


gint page_get_scan_height (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_height;
	result = _tmp0_;
	return result;
}


static void page_set_scan_height (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_scan_height = _tmp0_;
}


gint page_get_rowstride (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_rowstride;
	result = _tmp0_;
	return result;
}


static void page_set_rowstride (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_rowstride = _tmp0_;
}


gint page_get_n_channels (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_n_channels;
	result = _tmp0_;
	return result;
}


static void page_set_n_channels (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_n_channels = _tmp0_;
}


gboolean page_get_is_scanning (Page* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_scanning;
	result = _tmp0_;
	return result;
}


static void page_set_is_scanning (Page* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_is_scanning = _tmp0_;
}


gboolean page_get_has_data (Page* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_data;
	result = _tmp0_;
	return result;
}


static void page_set_has_data (Page* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_has_data = _tmp0_;
}


gint page_get_scan_line (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_scan_line;
	result = _tmp0_;
	return result;
}


static void page_set_scan_line (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_scan_line = _tmp0_;
}


gboolean page_get_is_color (Page* self) {
	gboolean result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_n_channels;
	result = _tmp0_ > 1;
	return result;
}


ScanDirection page_get_scan_direction (Page* self) {
	ScanDirection result;
	ScanDirection _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->scan_direction_;
	result = _tmp0_;
	return result;
}


void page_set_scan_direction (Page* self, ScanDirection value) {
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gboolean size_has_changed = FALSE;
	gint left_steps = 0;
	ScanDirection _tmp2_;
	ScanDirection _tmp3_;
	gint _tmp4_;
	gint _tmp6_;
	gboolean _tmp7_;
	ScanDirection _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->scan_direction_;
	_tmp1_ = value;
	if (_tmp0_ == _tmp1_) {
		return;
	}
	size_has_changed = FALSE;
	_tmp2_ = value;
	_tmp3_ = self->priv->scan_direction_;
	left_steps = (gint) (_tmp2_ - _tmp3_);
	_tmp4_ = left_steps;
	if (_tmp4_ < 0) {
		gint _tmp5_;
		_tmp5_ = left_steps;
		left_steps = _tmp5_ + 4;
	}
	_tmp6_ = left_steps;
	if (_tmp6_ != 2) {
		size_has_changed = TRUE;
	}
	_tmp7_ = self->priv->_has_crop;
	if (_tmp7_) {
		gint _tmp8_;
		_tmp8_ = left_steps;
		switch (_tmp8_) {
			case 1:
			{
				gint t = 0;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				_tmp9_ = self->priv->_crop_x;
				t = _tmp9_;
				_tmp10_ = self->priv->_crop_y;
				page_set_crop_x (self, _tmp10_);
				_tmp11_ = page_get_width (self);
				_tmp12_ = _tmp11_;
				_tmp13_ = t;
				_tmp14_ = self->priv->_crop_width;
				page_set_crop_y (self, _tmp12_ - (_tmp13_ + _tmp14_));
				_tmp15_ = self->priv->_crop_width;
				t = _tmp15_;
				_tmp16_ = self->priv->_crop_height;
				page_set_crop_width (self, _tmp16_);
				_tmp17_ = t;
				page_set_crop_height (self, _tmp17_);
				break;
			}
			case 2:
			{
				gint _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				_tmp18_ = page_get_width (self);
				_tmp19_ = _tmp18_;
				_tmp20_ = self->priv->_crop_x;
				_tmp21_ = self->priv->_crop_width;
				page_set_crop_x (self, _tmp19_ - (_tmp20_ + _tmp21_));
				_tmp22_ = page_get_width (self);
				_tmp23_ = _tmp22_;
				_tmp24_ = self->priv->_crop_y;
				_tmp25_ = self->priv->_crop_height;
				page_set_crop_y (self, _tmp23_ - (_tmp24_ + _tmp25_));
				break;
			}
			case 3:
			{
				gint t = 0;
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				_tmp26_ = self->priv->_crop_y;
				t = _tmp26_;
				_tmp27_ = self->priv->_crop_x;
				page_set_crop_y (self, _tmp27_);
				_tmp28_ = page_get_height (self);
				_tmp29_ = _tmp28_;
				_tmp30_ = t;
				_tmp31_ = self->priv->_crop_height;
				page_set_crop_x (self, _tmp29_ - (_tmp30_ + _tmp31_));
				_tmp32_ = self->priv->_crop_width;
				t = _tmp32_;
				_tmp33_ = self->priv->_crop_height;
				page_set_crop_width (self, _tmp33_);
				_tmp34_ = t;
				page_set_crop_height (self, _tmp34_);
				break;
			}
			default:
			break;
		}
	}
	_tmp35_ = value;
	self->priv->scan_direction_ = _tmp35_;
	_tmp36_ = size_has_changed;
	if (_tmp36_) {
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
	}
	g_signal_emit (self, page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL], 0);
	_tmp37_ = self->priv->_has_crop;
	if (_tmp37_) {
		g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
	}
}


gboolean page_get_has_crop (Page* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_crop;
	result = _tmp0_;
	return result;
}


static void page_set_has_crop (Page* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_has_crop = _tmp0_;
}


const gchar* page_get_crop_name (Page* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_crop_name;
	result = _tmp0_;
	return result;
}


static void page_set_crop_name (Page* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_crop_name);
	self->priv->_crop_name = _tmp1_;
}


gint page_get_crop_x (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_x;
	result = _tmp0_;
	return result;
}


static void page_set_crop_x (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_crop_x = _tmp0_;
}


gint page_get_crop_y (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_y;
	result = _tmp0_;
	return result;
}


static void page_set_crop_y (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_crop_y = _tmp0_;
}


gint page_get_crop_width (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_width;
	result = _tmp0_;
	return result;
}


static void page_set_crop_width (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_crop_width = _tmp0_;
}


gint page_get_crop_height (Page* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_crop_height;
	result = _tmp0_;
	return result;
}


static void page_set_crop_height (Page* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_crop_height = _tmp0_;
}


static void value_page_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_page_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		page_unref (value->data[0].v_pointer);
	}
}


static void value_page_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = page_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_page_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_page_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Page * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = page_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_page_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Page ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = page_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_page (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPage* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PAGE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_page (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE), NULL);
	return value->data[0].v_pointer;
}


void value_set_page (GValue* value, gpointer v_object) {
	Page * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		page_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_unref (old);
	}
}


void value_take_page (GValue* value, gpointer v_object) {
	Page * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		page_unref (old);
	}
}


static void page_class_init (PageClass * klass) {
	page_parent_class = g_type_class_peek_parent (klass);
	((PageClass *) klass)->finalize = page_finalize;
	g_type_class_add_private (klass, sizeof (PagePrivate));
	page_signals[PAGE_PIXELS_CHANGED_SIGNAL] = g_signal_new ("pixels-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL] = g_signal_new ("scan-line-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL] = g_signal_new ("scan-direction-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_CROP_CHANGED_SIGNAL] = g_signal_new ("crop-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	page_signals[PAGE_SCAN_FINISHED_SIGNAL] = g_signal_new ("scan-finished", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void page_instance_init (Page * self) {
	self->priv = PAGE_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void page_finalize (Page * obj) {
	Page * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE, Page);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_color_profile);
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
	_g_free0 (self->priv->_crop_name);
}


GType page_get_type (void) {
	static volatile gsize page_type_id__volatile = 0;
	if (g_once_init_enter (&page_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_page_init, value_page_free_value, value_page_copy_value, value_page_peek_pointer, "p", value_page_collect_value, "p", value_page_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Page), 0, (GInstanceInitFunc) page_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType page_type_id;
		page_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Page", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&page_type_id__volatile, page_type_id);
	}
	return page_type_id__volatile;
}


gpointer page_ref (gpointer instance) {
	Page * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void page_unref (gpointer instance) {
	Page * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PAGE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



