/* preferences-dialog.c generated by valac 0.38.5, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;

#define TYPE_SCAN_TYPE (scan_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_DEVICE (scan_device_get_type ())
#define SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_DEVICE, ScanDevice))
#define SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_DEVICE, ScanDeviceClass))
#define IS_SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_DEVICE))
#define IS_SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_DEVICE))
#define SCAN_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_DEVICE, ScanDeviceClass))

typedef struct _ScanDevice ScanDevice;
typedef struct _ScanDeviceClass ScanDeviceClass;
typedef struct _ScanDevicePrivate ScanDevicePrivate;
#define _scan_device_unref0(var) ((var == NULL) ? NULL : (var = (scan_device_unref (var), NULL)))

#define TYPE_PAGE_ICON (page_icon_get_type ())
#define PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_ICON, PageIcon))
#define PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_ICON, PageIconClass))
#define IS_PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_ICON))
#define IS_PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_ICON))
#define PAGE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_ICON, PageIconClass))

typedef struct _PageIcon PageIcon;
typedef struct _PageIconClass PageIconClass;
typedef struct _PageIconPrivate PageIconPrivate;
enum  {
	PAGE_ICON_0_PROPERTY,
	PAGE_ICON_NUM_PROPERTIES
};
static GParamSpec* page_icon_properties[PAGE_ICON_NUM_PROPERTIES];

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	gboolean setting_devices;
	gboolean user_selected_device;
	GtkComboBox* device_combo;
	GtkComboBox* text_dpi_combo;
	GtkComboBox* photo_dpi_combo;
	GtkComboBox* paper_size_combo;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
	GtkListStore* device_model;
	GtkRadioButton* page_delay_3s_button;
	GtkRadioButton* page_delay_5s_button;
	GtkRadioButton* page_delay_7s_button;
	GtkRadioButton* page_delay_10s_button;
	GtkRadioButton* page_delay_15s_button;
	GtkListStore* text_dpi_model;
	GtkListStore* photo_dpi_model;
	GtkRadioButton* front_side_button;
	GtkRadioButton* back_side_button;
	GtkRadioButton* both_side_button;
	GtkListStore* paper_size_model;
	GtkAdjustment* brightness_adjustment;
	GtkAdjustment* contrast_adjustment;
	GtkButton* preferences_close_button;
};

struct _Block7Data {
	int _ref_count_;
	PreferencesDialog* self;
	GSettings* settings;
};

typedef enum  {
	SCAN_TYPE_SINGLE,
	SCAN_TYPE_ADF_FRONT,
	SCAN_TYPE_ADF_BACK,
	SCAN_TYPE_ADF_BOTH,
	SCAN_TYPE_BATCH
} ScanType;

struct _ScanDevice {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanDevicePrivate * priv;
	gchar* name;
	gchar* label;
};

struct _ScanDeviceClass {
	GTypeClass parent_class;
	void (*finalize) (ScanDevice *self);
};

struct _PageIcon {
	GtkDrawingArea parent_instance;
	PageIconPrivate * priv;
};

struct _PageIconClass {
	GtkDrawingAreaClass parent_class;
};

struct _PageIconPrivate {
	gchar* text;
	gdouble r;
	gdouble g;
	gdouble b;
};


static gpointer preferences_dialog_parent_class = NULL;
static gpointer page_icon_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
#define PREFERENCES_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFERENCES_DIALOG, PreferencesDialogPrivate))
PreferencesDialog* preferences_dialog_new (GSettings* settings, gboolean use_header_bar);
PreferencesDialog* preferences_dialog_construct (GType object_type, GSettings* settings, gboolean use_header_bar);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
#define DEFAULT_TEXT_DPI 150
static void preferences_dialog_set_dpi_combo (PreferencesDialog* self, GtkComboBox* combo, gint default_dpi, gint current_dpi);
static void __lambda4_ (Block7Data* _data7_);
gint preferences_dialog_get_text_dpi (PreferencesDialog* self);
static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
#define DEFAULT_PHOTO_DPI 300
static void __lambda5_ (Block7Data* _data7_);
gint preferences_dialog_get_photo_dpi (PreferencesDialog* self);
static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
GType scan_type_get_type (void) G_GNUC_CONST;
static void preferences_dialog_set_page_side (PreferencesDialog* self, ScanType page_side);
static void __lambda6_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda7_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda8_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda9_ (Block7Data* _data7_);
gint preferences_dialog_get_brightness (PreferencesDialog* self);
static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void __lambda10_ (Block7Data* _data7_);
gint preferences_dialog_get_contrast (PreferencesDialog* self);
static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
void preferences_dialog_set_paper_size (PreferencesDialog* self, gint width, gint height);
static void __lambda11_ (Block7Data* _data7_);
gboolean preferences_dialog_get_paper_size (PreferencesDialog* self, gint* width, gint* height);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
void preferences_dialog_set_page_delay (PreferencesDialog* self, gint page_delay);
static void __lambda12_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda13_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda14_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda15_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda16_ (Block7Data* _data7_, GtkToggleButton* button);
static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gpointer scan_device_ref (gpointer instance);
void scan_device_unref (gpointer instance);
GParamSpec* param_spec_scan_device (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_scan_device (GValue* value, gpointer v_object);
void value_take_scan_device (GValue* value, gpointer v_object);
gpointer value_get_scan_device (const GValue* value);
GType scan_device_get_type (void) G_GNUC_CONST;
void preferences_dialog_set_scan_devices (PreferencesDialog* self, GList* devices);
static gboolean preferences_dialog_find_scan_device (PreferencesDialog* self, const gchar* device, GtkTreeIter* iter);
gchar* preferences_dialog_get_selected_device (PreferencesDialog* self);
gchar* preferences_dialog_get_selected_device_label (PreferencesDialog* self);
void preferences_dialog_set_selected_device (PreferencesDialog* self, const gchar* device);
ScanType preferences_dialog_get_page_side (PreferencesDialog* self);
void preferences_dialog_set_brightness (PreferencesDialog* self, gint brightness);
void preferences_dialog_set_contrast (PreferencesDialog* self, gint contrast);
gint preferences_dialog_get_page_delay (PreferencesDialog* self);
static void preferences_dialog_device_combo_changed_cb (PreferencesDialog* self, GtkWidget* widget);
static void _preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void preferences_dialog_finalize (GObject * obj);
GType page_icon_get_type (void) G_GNUC_CONST;
#define PAGE_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PAGE_ICON, PageIconPrivate))
#define PAGE_ICON_MINIMUM_WIDTH 20
PageIcon* page_icon_new (const gchar* text, gdouble r, gdouble g, gdouble b);
PageIcon* page_icon_construct (GType object_type, const gchar* text, gdouble r, gdouble g, gdouble b);
static void page_icon_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width);
static void page_icon_real_get_preferred_height (GtkWidget* base, gint* minimum_height, gint* natural_height);
static void page_icon_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* minimum_height, gint* natural_height);
static void page_icon_real_get_preferred_width_for_height (GtkWidget* base, gint height, gint* minimum_width, gint* natural_width);
static gboolean page_icon_real_draw (GtkWidget* base, cairo_t* c);
static void page_icon_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block7Data* block7_data_ref (Block7Data* _data7_) {
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}


static void block7_data_unref (void * _userdata_) {
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		PreferencesDialog* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}


static void __lambda4_ (Block7Data* _data7_) {
	PreferencesDialog* self;
	GSettings* _tmp0_;
	gint _tmp1_;
	self = _data7_->self;
	_tmp0_ = _data7_->settings;
	_tmp1_ = preferences_dialog_get_text_dpi (self);
	g_settings_set_int (_tmp0_, "text-dpi", _tmp1_);
}


static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
	__lambda4_ (self);
}


static void __lambda5_ (Block7Data* _data7_) {
	PreferencesDialog* self;
	GSettings* _tmp0_;
	gint _tmp1_;
	self = _data7_->self;
	_tmp0_ = _data7_->settings;
	_tmp1_ = preferences_dialog_get_photo_dpi (self);
	g_settings_set_int (_tmp0_, "photo-dpi", _tmp1_);
}


static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
	__lambda5_ (self);
}


static void __lambda6_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_enum (_tmp3_, "page-side", (gint) SCAN_TYPE_ADF_FRONT);
	}
}


static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda6_ (self, _sender);
}


static void __lambda7_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_enum (_tmp3_, "page-side", (gint) SCAN_TYPE_ADF_BACK);
	}
}


static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda7_ (self, _sender);
}


static void __lambda8_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_enum (_tmp3_, "page-side", (gint) SCAN_TYPE_ADF_BOTH);
	}
}


static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda8_ (self, _sender);
}


static void __lambda9_ (Block7Data* _data7_) {
	PreferencesDialog* self;
	GSettings* _tmp0_;
	gint _tmp1_;
	self = _data7_->self;
	_tmp0_ = _data7_->settings;
	_tmp1_ = preferences_dialog_get_brightness (self);
	g_settings_set_int (_tmp0_, "brightness", _tmp1_);
}


static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda9_ (self);
}


static void __lambda10_ (Block7Data* _data7_) {
	PreferencesDialog* self;
	GSettings* _tmp0_;
	gint _tmp1_;
	self = _data7_->self;
	_tmp0_ = _data7_->settings;
	_tmp1_ = preferences_dialog_get_contrast (self);
	g_settings_set_int (_tmp0_, "contrast", _tmp1_);
}


static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda10_ (self);
}


static void __lambda11_ (Block7Data* _data7_) {
	PreferencesDialog* self;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	self = _data7_->self;
	preferences_dialog_get_paper_size (self, &_tmp0_, &_tmp1_);
	w = _tmp0_;
	h = _tmp1_;
	_tmp2_ = _data7_->settings;
	g_settings_set_int (_tmp2_, "paper-width", w);
	_tmp3_ = _data7_->settings;
	g_settings_set_int (_tmp3_, "paper-height", h);
}


static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
	__lambda11_ (self);
}


static void __lambda12_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_int (_tmp3_, "page-delay", 3);
	}
}


static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda12_ (self, _sender);
}


static void __lambda13_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_int (_tmp3_, "page-delay", 5);
	}
}


static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda13_ (self, _sender);
}


static void __lambda14_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_int (_tmp3_, "page-delay", 7);
	}
}


static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda14_ (self, _sender);
}


static void __lambda15_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_int (_tmp3_, "page-delay", 10);
	}
}


static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda15_ (self, _sender);
}


static void __lambda16_ (Block7Data* _data7_, GtkToggleButton* button) {
	PreferencesDialog* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		_tmp3_ = _data7_->settings;
		g_settings_set_int (_tmp3_, "page-delay", 15);
	}
}


static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda16_ (self, _sender);
}


PreferencesDialog* preferences_dialog_construct (GType object_type, GSettings* settings, gboolean use_header_bar) {
	PreferencesDialog * self = NULL;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_ = {0};
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_;
	GtkListStore* _tmp12_;
	GtkTreeIter _tmp13_ = {0};
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_ = {0};
	GtkListStore* _tmp18_;
	GtkTreeIter _tmp19_;
	GtkListStore* _tmp20_;
	GtkTreeIter _tmp21_ = {0};
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_;
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_ = {0};
	GtkListStore* _tmp26_;
	GtkTreeIter _tmp27_;
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_ = {0};
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_;
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_ = {0};
	GtkListStore* _tmp34_;
	GtkTreeIter _tmp35_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkCellRendererText* _tmp38_;
	GtkComboBox* _tmp39_;
	GtkCellRendererText* _tmp40_;
	gint dpi = 0;
	GSettings* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	GtkComboBox* _tmp44_;
	gint _tmp45_;
	GtkComboBox* _tmp46_;
	GSettings* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	GtkComboBox* _tmp50_;
	gint _tmp51_;
	GtkComboBox* _tmp52_;
	GSettings* _tmp53_;
	gint _tmp54_;
	GtkRadioButton* _tmp55_;
	GtkRadioButton* _tmp56_;
	GtkRadioButton* _tmp57_;
	GtkCellRendererText* _tmp58_;
	GtkComboBox* _tmp59_;
	GtkCellRendererText* _tmp60_;
	GtkComboBox* _tmp61_;
	GtkCellRendererText* _tmp62_;
	gdouble lower = 0.0;
	GtkAdjustment* _tmp63_;
	gdouble _tmp64_;
	gdouble _tmp65_;
	gchar* darker_label = NULL;
	gchar* _tmp66_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp67_;
	gdouble _tmp68_;
	gdouble _tmp69_;
	gchar* lighter_label = NULL;
	gchar* _tmp70_;
	GtkScale* _tmp71_;
	gdouble _tmp72_;
	GtkScale* _tmp73_;
	GtkScale* _tmp74_;
	gdouble _tmp75_;
	GtkAdjustment* _tmp76_;
	GSettings* _tmp77_;
	gint _tmp78_;
	GtkAdjustment* _tmp79_;
	GtkAdjustment* _tmp80_;
	gdouble _tmp81_;
	gdouble _tmp82_;
	gchar* less_label = NULL;
	gchar* _tmp83_;
	GtkAdjustment* _tmp84_;
	gdouble _tmp85_;
	gdouble _tmp86_;
	gchar* more_label = NULL;
	gchar* _tmp87_;
	GtkScale* _tmp88_;
	gdouble _tmp89_;
	GtkScale* _tmp90_;
	GtkScale* _tmp91_;
	gdouble _tmp92_;
	GtkAdjustment* _tmp93_;
	GSettings* _tmp94_;
	gint _tmp95_;
	GtkAdjustment* _tmp96_;
	gint paper_width = 0;
	GSettings* _tmp97_;
	gint _tmp98_;
	gint paper_height = 0;
	GSettings* _tmp99_;
	gint _tmp100_;
	GtkComboBox* _tmp101_;
	GSettings* _tmp102_;
	gint _tmp103_;
	GtkRadioButton* _tmp104_;
	GtkRadioButton* _tmp105_;
	GtkRadioButton* _tmp106_;
	GtkRadioButton* _tmp107_;
	GtkRadioButton* _tmp108_;
	g_return_val_if_fail (settings != NULL, NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = settings;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data7_->settings);
	_data7_->settings = _tmp1_;
	_tmp3_ = use_header_bar;
	if (_tmp3_) {
		_tmp2_ = 1;
	} else {
		_tmp2_ = -1;
	}
	self = (PreferencesDialog*) g_object_new (object_type, "use-header-bar", _tmp2_, NULL);
	_data7_->self = g_object_ref (self);
	_tmp4_ = use_header_bar;
	if (_tmp4_) {
		GtkButton* _tmp5_;
		_tmp5_ = self->priv->preferences_close_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	}
	_tmp6_ = _data7_->settings;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp7_;
	_tmp8_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp8_, &_tmp9_);
	iter = _tmp9_;
	_tmp10_ = self->priv->paper_size_model;
	_tmp11_ = iter;
	gtk_list_store_set (_tmp10_, &_tmp11_, 0, 0, 1, 0, 2, _ ("Automatic"), -1, -1);
	_tmp12_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp12_, &_tmp13_);
	iter = _tmp13_;
	_tmp14_ = self->priv->paper_size_model;
	_tmp15_ = iter;
	gtk_list_store_set (_tmp14_, &_tmp15_, 0, 1050, 1, 1480, 2, "A6", -1, -1);
	_tmp16_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp16_, &_tmp17_);
	iter = _tmp17_;
	_tmp18_ = self->priv->paper_size_model;
	_tmp19_ = iter;
	gtk_list_store_set (_tmp18_, &_tmp19_, 0, 1480, 1, 2100, 2, "A5", -1, -1);
	_tmp20_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp20_, &_tmp21_);
	iter = _tmp21_;
	_tmp22_ = self->priv->paper_size_model;
	_tmp23_ = iter;
	gtk_list_store_set (_tmp22_, &_tmp23_, 0, 2100, 1, 2970, 2, "A4", -1, -1);
	_tmp24_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp24_, &_tmp25_);
	iter = _tmp25_;
	_tmp26_ = self->priv->paper_size_model;
	_tmp27_ = iter;
	gtk_list_store_set (_tmp26_, &_tmp27_, 0, 2159, 1, 2794, 2, "Letter", -1, -1);
	_tmp28_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp28_, &_tmp29_);
	iter = _tmp29_;
	_tmp30_ = self->priv->paper_size_model;
	_tmp31_ = iter;
	gtk_list_store_set (_tmp30_, &_tmp31_, 0, 2159, 1, 3556, 2, "Legal", -1, -1);
	_tmp32_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp32_, &_tmp33_);
	iter = _tmp33_;
	_tmp34_ = self->priv->paper_size_model;
	_tmp35_ = iter;
	gtk_list_store_set (_tmp34_, &_tmp35_, 0, 1016, 1, 1524, 2, "4×6", -1, -1);
	_tmp36_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp36_);
	renderer = _tmp36_;
	_tmp37_ = self->priv->device_combo;
	_tmp38_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp37_, (GtkCellRenderer*) _tmp38_, TRUE);
	_tmp39_ = self->priv->device_combo;
	_tmp40_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp39_, (GtkCellRenderer*) _tmp40_, "text", 1);
	_tmp41_ = _data7_->settings;
	_tmp42_ = g_settings_get_int (_tmp41_, "text-dpi");
	dpi = _tmp42_;
	_tmp43_ = dpi;
	if (_tmp43_ <= 0) {
		dpi = DEFAULT_TEXT_DPI;
	}
	_tmp44_ = self->priv->text_dpi_combo;
	_tmp45_ = dpi;
	preferences_dialog_set_dpi_combo (self, _tmp44_, DEFAULT_TEXT_DPI, _tmp45_);
	_tmp46_ = self->priv->text_dpi_combo;
	g_signal_connect_data (_tmp46_, "changed", (GCallback) ___lambda4__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp47_ = _data7_->settings;
	_tmp48_ = g_settings_get_int (_tmp47_, "photo-dpi");
	dpi = _tmp48_;
	_tmp49_ = dpi;
	if (_tmp49_ <= 0) {
		dpi = DEFAULT_PHOTO_DPI;
	}
	_tmp50_ = self->priv->photo_dpi_combo;
	_tmp51_ = dpi;
	preferences_dialog_set_dpi_combo (self, _tmp50_, DEFAULT_PHOTO_DPI, _tmp51_);
	_tmp52_ = self->priv->photo_dpi_combo;
	g_signal_connect_data (_tmp52_, "changed", (GCallback) ___lambda5__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp53_ = _data7_->settings;
	_tmp54_ = g_settings_get_enum (_tmp53_, "page-side");
	preferences_dialog_set_page_side (self, (ScanType) _tmp54_);
	_tmp55_ = self->priv->front_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp55_, "toggled", (GCallback) ___lambda6__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp56_ = self->priv->back_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp56_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp57_ = self->priv->both_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp57_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp58_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (renderer);
	renderer = _tmp58_;
	_tmp59_ = self->priv->paper_size_combo;
	_tmp60_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp59_, (GtkCellRenderer*) _tmp60_, TRUE);
	_tmp61_ = self->priv->paper_size_combo;
	_tmp62_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp61_, (GtkCellRenderer*) _tmp62_, "text", 2);
	_tmp63_ = self->priv->brightness_adjustment;
	_tmp64_ = gtk_adjustment_get_lower (_tmp63_);
	_tmp65_ = _tmp64_;
	lower = _tmp65_;
	_tmp66_ = g_strdup_printf ("<small>%s</small>", _ ("Darker"));
	darker_label = _tmp66_;
	_tmp67_ = self->priv->brightness_adjustment;
	_tmp68_ = gtk_adjustment_get_upper (_tmp67_);
	_tmp69_ = _tmp68_;
	upper = _tmp69_;
	_tmp70_ = g_strdup_printf ("<small>%s</small>", _ ("Lighter"));
	lighter_label = _tmp70_;
	_tmp71_ = self->priv->brightness_scale;
	_tmp72_ = lower;
	gtk_scale_add_mark (_tmp71_, _tmp72_, GTK_POS_BOTTOM, darker_label);
	_tmp73_ = self->priv->brightness_scale;
	gtk_scale_add_mark (_tmp73_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp74_ = self->priv->brightness_scale;
	_tmp75_ = upper;
	gtk_scale_add_mark (_tmp74_, _tmp75_, GTK_POS_BOTTOM, lighter_label);
	_tmp76_ = self->priv->brightness_adjustment;
	_tmp77_ = _data7_->settings;
	_tmp78_ = g_settings_get_int (_tmp77_, "brightness");
	gtk_adjustment_set_value (_tmp76_, (gdouble) _tmp78_);
	_tmp79_ = self->priv->brightness_adjustment;
	g_signal_connect_data (_tmp79_, "value-changed", (GCallback) ___lambda9__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp80_ = self->priv->contrast_adjustment;
	_tmp81_ = gtk_adjustment_get_lower (_tmp80_);
	_tmp82_ = _tmp81_;
	lower = _tmp82_;
	_tmp83_ = g_strdup_printf ("<small>%s</small>", _ ("Less"));
	less_label = _tmp83_;
	_tmp84_ = self->priv->contrast_adjustment;
	_tmp85_ = gtk_adjustment_get_upper (_tmp84_);
	_tmp86_ = _tmp85_;
	upper = _tmp86_;
	_tmp87_ = g_strdup_printf ("<small>%s</small>", _ ("More"));
	more_label = _tmp87_;
	_tmp88_ = self->priv->contrast_scale;
	_tmp89_ = lower;
	gtk_scale_add_mark (_tmp88_, _tmp89_, GTK_POS_BOTTOM, less_label);
	_tmp90_ = self->priv->contrast_scale;
	gtk_scale_add_mark (_tmp90_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp91_ = self->priv->contrast_scale;
	_tmp92_ = upper;
	gtk_scale_add_mark (_tmp91_, _tmp92_, GTK_POS_BOTTOM, more_label);
	_tmp93_ = self->priv->contrast_adjustment;
	_tmp94_ = _data7_->settings;
	_tmp95_ = g_settings_get_int (_tmp94_, "contrast");
	gtk_adjustment_set_value (_tmp93_, (gdouble) _tmp95_);
	_tmp96_ = self->priv->contrast_adjustment;
	g_signal_connect_data (_tmp96_, "value-changed", (GCallback) ___lambda10__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp97_ = _data7_->settings;
	_tmp98_ = g_settings_get_int (_tmp97_, "paper-width");
	paper_width = _tmp98_;
	_tmp99_ = _data7_->settings;
	_tmp100_ = g_settings_get_int (_tmp99_, "paper-height");
	paper_height = _tmp100_;
	preferences_dialog_set_paper_size (self, paper_width, paper_height);
	_tmp101_ = self->priv->paper_size_combo;
	g_signal_connect_data (_tmp101_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp102_ = _data7_->settings;
	_tmp103_ = g_settings_get_int (_tmp102_, "page-delay");
	preferences_dialog_set_page_delay (self, _tmp103_);
	_tmp104_ = self->priv->page_delay_3s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp104_, "toggled", (GCallback) ___lambda12__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp105_ = self->priv->page_delay_5s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp105_, "toggled", (GCallback) ___lambda13__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp106_ = self->priv->page_delay_7s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp106_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp107_ = self->priv->page_delay_10s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp107_, "toggled", (GCallback) ___lambda15__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp108_ = self->priv->page_delay_15s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp108_, "toggled", (GCallback) ___lambda16__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_g_free0 (more_label);
	_g_free0 (less_label);
	_g_free0 (lighter_label);
	_g_free0 (darker_label);
	_g_object_unref0 (renderer);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return self;
}


PreferencesDialog* preferences_dialog_new (GSettings* settings, gboolean use_header_bar) {
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings, use_header_bar);
}


static gpointer _scan_device_ref0 (gpointer self) {
	return self ? scan_device_ref (self) : NULL;
}


void preferences_dialog_set_scan_devices (PreferencesDialog* self, GList* devices) {
	gboolean have_selection = FALSE;
	gboolean _tmp0_;
	gint index = 0;
	GtkTreeIter iter = {0};
	GList* _tmp4_;
	gboolean _tmp49_;
	g_return_if_fail (self != NULL);
	self->priv->setting_devices = TRUE;
	have_selection = FALSE;
	_tmp0_ = self->priv->user_selected_device;
	if (_tmp0_) {
		GtkComboBox* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->device_combo;
		_tmp2_ = gtk_combo_box_get_active (_tmp1_);
		_tmp3_ = _tmp2_;
		have_selection = _tmp3_ >= 0;
	}
	index = 0;
	_tmp4_ = devices;
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp4_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			ScanDevice* _tmp5_;
			ScanDevice* device = NULL;
			_tmp5_ = _scan_device_ref0 ((ScanDevice*) device_it->data);
			device = _tmp5_;
			{
				gint n_delete = 0;
				GtkListStore* _tmp6_;
				gint _tmp7_;
				GtkTreeIter _tmp8_ = {0};
				gboolean _tmp9_;
				gint _tmp21_;
				gint _tmp43_;
				n_delete = -1;
				_tmp6_ = self->priv->device_model;
				_tmp7_ = index;
				_tmp9_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp6_, &_tmp8_, NULL, _tmp7_);
				iter = _tmp8_;
				if (_tmp9_) {
					gint i = 0;
					i = 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							gchar* name = NULL;
							gboolean matched = FALSE;
							GtkListStore* _tmp13_;
							GtkTreeIter _tmp14_;
							const gchar* _tmp15_;
							ScanDevice* _tmp16_;
							const gchar* _tmp17_;
							gboolean _tmp18_;
							gint _tmp20_;
							if (!_tmp10_) {
								GtkListStore* _tmp11_;
								gboolean _tmp12_;
								_tmp11_ = self->priv->device_model;
								_tmp12_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp11_, &iter);
								if (!_tmp12_) {
									break;
								}
							}
							_tmp10_ = FALSE;
							_tmp13_ = self->priv->device_model;
							_tmp14_ = iter;
							gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, 0, &name, -1, -1);
							_tmp15_ = name;
							_tmp16_ = device;
							_tmp17_ = _tmp16_->name;
							matched = g_strcmp0 (_tmp15_, _tmp17_) == 0;
							_tmp18_ = matched;
							if (_tmp18_) {
								gint _tmp19_;
								_tmp19_ = i;
								n_delete = _tmp19_;
								_g_free0 (name);
								break;
							}
							_tmp20_ = i;
							i = _tmp20_ + 1;
							_g_free0 (name);
						}
					}
				}
				_tmp21_ = n_delete;
				if (_tmp21_ >= 0) {
					gint i = 0;
					GtkListStore* _tmp22_;
					GtkTreeIter _tmp23_;
					ScanDevice* _tmp24_;
					const gchar* _tmp25_;
					_tmp22_ = self->priv->device_model;
					_tmp23_ = iter;
					_tmp24_ = device;
					_tmp25_ = _tmp24_->label;
					gtk_list_store_set (_tmp22_, &_tmp23_, 1, _tmp25_, -1, -1);
					{
						gboolean _tmp26_ = FALSE;
						i = 0;
						_tmp26_ = TRUE;
						while (TRUE) {
							gint _tmp28_;
							gint _tmp29_;
							GtkListStore* _tmp30_;
							gint _tmp31_;
							GtkTreeIter _tmp32_ = {0};
							GtkListStore* _tmp33_;
							if (!_tmp26_) {
								gint _tmp27_;
								_tmp27_ = i;
								i = _tmp27_ + 1;
							}
							_tmp26_ = FALSE;
							_tmp28_ = i;
							_tmp29_ = n_delete;
							if (!(_tmp28_ < _tmp29_)) {
								break;
							}
							_tmp30_ = self->priv->device_model;
							_tmp31_ = index;
							gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp30_, &_tmp32_, NULL, _tmp31_);
							iter = _tmp32_;
							_tmp33_ = self->priv->device_model;
							gtk_list_store_remove (_tmp33_, &iter);
						}
					}
				} else {
					GtkListStore* _tmp34_;
					gint _tmp35_;
					GtkTreeIter _tmp36_ = {0};
					GtkListStore* _tmp37_;
					GtkTreeIter _tmp38_;
					ScanDevice* _tmp39_;
					const gchar* _tmp40_;
					ScanDevice* _tmp41_;
					const gchar* _tmp42_;
					_tmp34_ = self->priv->device_model;
					_tmp35_ = index;
					gtk_list_store_insert (_tmp34_, &_tmp36_, _tmp35_);
					iter = _tmp36_;
					_tmp37_ = self->priv->device_model;
					_tmp38_ = iter;
					_tmp39_ = device;
					_tmp40_ = _tmp39_->name;
					_tmp41_ = device;
					_tmp42_ = _tmp41_->label;
					gtk_list_store_set (_tmp37_, &_tmp38_, 0, _tmp40_, 1, _tmp42_, -1, -1);
				}
				_tmp43_ = index;
				index = _tmp43_ + 1;
				_scan_device_unref0 (device);
			}
		}
	}
	while (TRUE) {
		GtkListStore* _tmp44_;
		gint _tmp45_;
		GtkTreeIter _tmp46_ = {0};
		gboolean _tmp47_;
		GtkListStore* _tmp48_;
		_tmp44_ = self->priv->device_model;
		_tmp45_ = index;
		_tmp47_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp44_, &_tmp46_, NULL, _tmp45_);
		iter = _tmp46_;
		if (!_tmp47_) {
			break;
		}
		_tmp48_ = self->priv->device_model;
		gtk_list_store_remove (_tmp48_, &iter);
	}
	_tmp49_ = have_selection;
	if (!_tmp49_) {
		gchar* device = NULL;
		GSettings* _tmp50_;
		gchar* _tmp51_;
		gboolean _tmp52_ = FALSE;
		const gchar* _tmp53_;
		_tmp50_ = self->priv->settings;
		_tmp51_ = g_settings_get_string (_tmp50_, "selected-device");
		device = _tmp51_;
		_tmp53_ = device;
		if (_tmp53_ != NULL) {
			const gchar* _tmp54_;
			GtkTreeIter _tmp55_ = {0};
			gboolean _tmp56_;
			_tmp54_ = device;
			_tmp56_ = preferences_dialog_find_scan_device (self, _tmp54_, &_tmp55_);
			iter = _tmp55_;
			_tmp52_ = _tmp56_;
		} else {
			_tmp52_ = FALSE;
		}
		if (_tmp52_) {
			GtkComboBox* _tmp57_;
			GtkTreeIter _tmp58_;
			_tmp57_ = self->priv->device_combo;
			_tmp58_ = iter;
			gtk_combo_box_set_active_iter (_tmp57_, &_tmp58_);
		} else {
			GtkComboBox* _tmp59_;
			_tmp59_ = self->priv->device_combo;
			gtk_combo_box_set_active (_tmp59_, 0);
		}
		_g_free0 (device);
	}
	self->priv->setting_devices = FALSE;
}


gchar* preferences_dialog_get_selected_device (PreferencesDialog* self) {
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* device = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &device, -1, -1);
		result = device;
		return result;
	}
	result = NULL;
	return result;
}


gchar* preferences_dialog_get_selected_device_label (PreferencesDialog* self) {
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* label = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &label, -1, -1);
		result = label;
		return result;
	}
	result = NULL;
	return result;
}


void preferences_dialog_set_selected_device (PreferencesDialog* self, const gchar* device) {
	GtkTreeIter iter = {0};
	const gchar* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkComboBox* _tmp3_;
	GtkTreeIter _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	self->priv->user_selected_device = TRUE;
	_tmp0_ = device;
	_tmp2_ = preferences_dialog_find_scan_device (self, _tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = self->priv->device_combo;
	_tmp4_ = iter;
	gtk_combo_box_set_active_iter (_tmp3_, &_tmp4_);
}


static gboolean preferences_dialog_find_scan_device (PreferencesDialog* self, const gchar* device, GtkTreeIter* iter) {
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean have_iter = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	have_iter = FALSE;
	_tmp0_ = self->priv->device_model;
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
	_vala_iter = _tmp1_;
	if (_tmp2_) {
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gchar* d = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp3_) {
					gboolean _tmp4_ = FALSE;
					gboolean _tmp5_;
					_tmp5_ = have_iter;
					if (!_tmp5_) {
						GtkListStore* _tmp6_;
						gboolean _tmp7_;
						_tmp6_ = self->priv->device_model;
						_tmp7_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp6_, &_vala_iter);
						_tmp4_ = _tmp7_;
					} else {
						_tmp4_ = FALSE;
					}
					if (!_tmp4_) {
						break;
					}
				}
				_tmp3_ = FALSE;
				_tmp8_ = self->priv->device_model;
				_tmp9_ = _vala_iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &d, -1, -1);
				_tmp10_ = d;
				_tmp11_ = device;
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
					have_iter = TRUE;
				}
				_g_free0 (d);
			}
		}
	}
	result = have_iter;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}


static void preferences_dialog_set_page_side (PreferencesDialog* self, ScanType page_side) {
	ScanType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_side;
	switch (_tmp0_) {
		case SCAN_TYPE_ADF_FRONT:
		{
			GtkRadioButton* _tmp1_;
			_tmp1_ = self->priv->front_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
			break;
		}
		case SCAN_TYPE_ADF_BACK:
		{
			GtkRadioButton* _tmp2_;
			_tmp2_ = self->priv->back_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
			break;
		}
		default:
		case SCAN_TYPE_ADF_BOTH:
		{
			GtkRadioButton* _tmp3_;
			_tmp3_ = self->priv->both_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
			break;
		}
	}
}


ScanType preferences_dialog_get_page_side (PreferencesDialog* self) {
	ScanType result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->front_side_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = SCAN_TYPE_ADF_FRONT;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->back_side_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = SCAN_TYPE_ADF_BACK;
			return result;
		} else {
			result = SCAN_TYPE_ADF_BOTH;
			return result;
		}
	}
}


void preferences_dialog_set_paper_size (PreferencesDialog* self, gint width, gint height) {
	GtkTreeIter iter = {0};
	gboolean have_iter = FALSE;
	gboolean _tmp14_;
	gboolean _tmp18_;
	g_return_if_fail (self != NULL);
	{
		GtkListStore* _tmp0_;
		GtkTreeIter _tmp1_ = {0};
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->paper_size_model;
		_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
		iter = _tmp1_;
		have_iter = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gboolean _tmp6_;
			gint w = 0;
			gint h = 0;
			GtkListStore* _tmp7_;
			GtkTreeIter _tmp8_;
			gboolean _tmp9_ = FALSE;
			gint _tmp10_;
			gint _tmp11_;
			if (!_tmp3_) {
				GtkListStore* _tmp4_;
				gboolean _tmp5_;
				_tmp4_ = self->priv->paper_size_model;
				_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
				have_iter = _tmp5_;
			}
			_tmp3_ = FALSE;
			_tmp6_ = have_iter;
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = self->priv->paper_size_model;
			_tmp8_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 0, &w, 1, &h, -1, -1);
			_tmp10_ = w;
			_tmp11_ = width;
			if (_tmp10_ == _tmp11_) {
				gint _tmp12_;
				gint _tmp13_;
				_tmp12_ = h;
				_tmp13_ = height;
				_tmp9_ = _tmp12_ == _tmp13_;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				break;
			}
		}
	}
	_tmp14_ = have_iter;
	if (!_tmp14_) {
		GtkListStore* _tmp15_;
		GtkTreeIter _tmp16_ = {0};
		gboolean _tmp17_;
		_tmp15_ = self->priv->paper_size_model;
		_tmp17_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp15_, &_tmp16_);
		iter = _tmp16_;
		have_iter = _tmp17_;
	}
	_tmp18_ = have_iter;
	if (_tmp18_) {
		GtkComboBox* _tmp19_;
		GtkTreeIter _tmp20_;
		_tmp19_ = self->priv->paper_size_combo;
		_tmp20_ = iter;
		gtk_combo_box_set_active_iter (_tmp19_, &_tmp20_);
	}
}


gint preferences_dialog_get_text_dpi (PreferencesDialog* self) {
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_TEXT_DPI;
	_tmp0_ = self->priv->text_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->text_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &dpi, -1, -1);
	}
	result = dpi;
	return result;
}


gint preferences_dialog_get_photo_dpi (PreferencesDialog* self) {
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_PHOTO_DPI;
	_tmp0_ = self->priv->photo_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->photo_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &dpi, -1, -1);
	}
	result = dpi;
	return result;
}


gboolean preferences_dialog_get_paper_size (PreferencesDialog* self, gint* width, gint* height) {
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	gint _tmp0_;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_height = 0;
	_tmp0_ = _vala_height;
	_vala_width = _tmp0_;
	_tmp1_ = self->priv->paper_size_combo;
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
	iter = _tmp2_;
	if (_tmp3_) {
		GtkListStore* _tmp4_;
		GtkTreeIter _tmp5_;
		_tmp4_ = self->priv->paper_size_model;
		_tmp5_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &_vala_width, 1, &_vala_height, -1, -1);
		result = TRUE;
		if (width) {
			*width = _vala_width;
		}
		if (height) {
			*height = _vala_height;
		}
		return result;
	}
	result = FALSE;
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
	return result;
}


gint preferences_dialog_get_brightness (PreferencesDialog* self) {
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->brightness_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}


void preferences_dialog_set_brightness (PreferencesDialog* self, gint brightness) {
	GtkAdjustment* _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->brightness_adjustment;
	_tmp1_ = brightness;
	gtk_adjustment_set_value (_tmp0_, (gdouble) _tmp1_);
}


gint preferences_dialog_get_contrast (PreferencesDialog* self) {
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->contrast_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}


void preferences_dialog_set_contrast (PreferencesDialog* self, gint contrast) {
	GtkAdjustment* _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->contrast_adjustment;
	_tmp1_ = contrast;
	gtk_adjustment_set_value (_tmp0_, (gdouble) _tmp1_);
}


gint preferences_dialog_get_page_delay (PreferencesDialog* self) {
	gint result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->page_delay_15s_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = 15;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->page_delay_10s_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = 10;
			return result;
		} else {
			GtkRadioButton* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = self->priv->page_delay_7s_button;
			_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_) {
				result = 7;
				return result;
			} else {
				GtkRadioButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp9_ = self->priv->page_delay_5s_button;
				_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp11_) {
					result = 5;
					return result;
				} else {
					result = 3;
					return result;
				}
			}
		}
	}
}


void preferences_dialog_set_page_delay (PreferencesDialog* self, gint page_delay) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = page_delay;
	if (_tmp0_ >= 15) {
		GtkRadioButton* _tmp1_;
		_tmp1_ = self->priv->page_delay_15s_button;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
	} else {
		gint _tmp2_;
		_tmp2_ = page_delay;
		if (_tmp2_ >= 10) {
			GtkRadioButton* _tmp3_;
			_tmp3_ = self->priv->page_delay_10s_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
		} else {
			gint _tmp4_;
			_tmp4_ = page_delay;
			if (_tmp4_ >= 7) {
				GtkRadioButton* _tmp5_;
				_tmp5_ = self->priv->page_delay_7s_button;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp5_, TRUE);
			} else {
				gint _tmp6_;
				_tmp6_ = page_delay;
				if (_tmp6_ >= 5) {
					GtkRadioButton* _tmp7_;
					_tmp7_ = self->priv->page_delay_5s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, TRUE);
				} else {
					GtkRadioButton* _tmp8_;
					_tmp8_ = self->priv->page_delay_3s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp8_, TRUE);
				}
			}
		}
	}
}


static void preferences_dialog_set_dpi_combo (PreferencesDialog* self, GtkComboBox* combo, gint default_dpi, gint current_dpi) {
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkComboBox* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GtkComboBox* _tmp3_;
	GtkCellRendererText* _tmp4_;
	GtkListStore* model = NULL;
	GtkComboBox* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkListStore* _tmp8_;
	gint* scan_resolutions = NULL;
	gint* _tmp9_;
	gint scan_resolutions_length1;
	gint _scan_resolutions_size_;
	gint* _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo != NULL);
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp0_);
	renderer = _tmp0_;
	_tmp1_ = combo;
	_tmp2_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp1_, (GtkCellRenderer*) _tmp2_, TRUE);
	_tmp3_ = combo;
	_tmp4_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp3_, (GtkCellRenderer*) _tmp4_, "text", 1);
	_tmp5_ = combo;
	_tmp6_ = gtk_combo_box_get_model (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp7_) : NULL);
	model = _tmp8_;
	_tmp9_ = g_new0 (gint, 6);
	_tmp9_[0] = 75;
	_tmp9_[1] = 150;
	_tmp9_[2] = 300;
	_tmp9_[3] = 600;
	_tmp9_[4] = 1200;
	_tmp9_[5] = 2400;
	scan_resolutions = _tmp9_;
	scan_resolutions_length1 = 6;
	_scan_resolutions_size_ = scan_resolutions_length1;
	_tmp10_ = scan_resolutions;
	_tmp10__length1 = scan_resolutions_length1;
	{
		gint* dpi_collection = NULL;
		gint dpi_collection_length1 = 0;
		gint _dpi_collection_size_ = 0;
		gint dpi_it = 0;
		dpi_collection = _tmp10_;
		dpi_collection_length1 = _tmp10__length1;
		for (dpi_it = 0; dpi_it < _tmp10__length1; dpi_it = dpi_it + 1) {
			gint dpi = 0;
			dpi = dpi_collection[dpi_it];
			{
				gchar* label = NULL;
				gint _tmp11_;
				gint _tmp12_;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp23_;
				GtkTreeIter _tmp24_ = {0};
				GtkListStore* _tmp25_;
				GtkTreeIter _tmp26_;
				gint _tmp27_;
				const gchar* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				_tmp11_ = dpi;
				_tmp12_ = default_dpi;
				if (_tmp11_ == _tmp12_) {
					gint _tmp13_;
					gchar* _tmp14_;
					_tmp13_ = dpi;
					_tmp14_ = g_strdup_printf (_ ("%d dpi (default)"), _tmp13_);
					_g_free0 (label);
					label = _tmp14_;
				} else {
					gint _tmp15_;
					_tmp15_ = dpi;
					if (_tmp15_ == 75) {
						gint _tmp16_;
						gchar* _tmp17_;
						_tmp16_ = dpi;
						_tmp17_ = g_strdup_printf (_ ("%d dpi (draft)"), _tmp16_);
						_g_free0 (label);
						label = _tmp17_;
					} else {
						gint _tmp18_;
						_tmp18_ = dpi;
						if (_tmp18_ == 1200) {
							gint _tmp19_;
							gchar* _tmp20_;
							_tmp19_ = dpi;
							_tmp20_ = g_strdup_printf (_ ("%d dpi (high resolution)"), _tmp19_);
							_g_free0 (label);
							label = _tmp20_;
						} else {
							gint _tmp21_;
							gchar* _tmp22_;
							_tmp21_ = dpi;
							_tmp22_ = g_strdup_printf (_ ("%d dpi"), _tmp21_);
							_g_free0 (label);
							label = _tmp22_;
						}
					}
				}
				_tmp23_ = model;
				gtk_list_store_append (_tmp23_, &_tmp24_);
				iter = _tmp24_;
				_tmp25_ = model;
				_tmp26_ = iter;
				_tmp27_ = dpi;
				_tmp28_ = label;
				gtk_list_store_set (_tmp25_, &_tmp26_, 0, _tmp27_, 1, _tmp28_, -1, -1);
				_tmp29_ = dpi;
				_tmp30_ = current_dpi;
				if (_tmp29_ == _tmp30_) {
					GtkComboBox* _tmp31_;
					GtkTreeIter _tmp32_;
					_tmp31_ = combo;
					_tmp32_ = iter;
					gtk_combo_box_set_active_iter (_tmp31_, &_tmp32_);
				}
				_g_free0 (label);
			}
		}
	}
	scan_resolutions = (g_free (scan_resolutions), NULL);
	_g_object_unref0 (model);
	_g_object_unref0 (renderer);
}


static void preferences_dialog_device_combo_changed_cb (PreferencesDialog* self, GtkWidget* widget) {
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->setting_devices;
	if (_tmp0_) {
		return;
	}
	self->priv->user_selected_device = TRUE;
	_tmp1_ = preferences_dialog_get_selected_device (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_ != NULL;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		GSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->settings;
		_tmp5_ = preferences_dialog_get_selected_device (self);
		_tmp6_ = _tmp5_;
		g_settings_set_string (_tmp4_, "selected-device", _tmp6_);
		_g_free0 (_tmp6_);
	}
}


static void _preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
	preferences_dialog_device_combo_changed_cb ((PreferencesDialog*) self, _sender);
}


static void preferences_dialog_class_init (PreferencesDialogClass * klass) {
	gint PreferencesDialog_private_offset;
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PreferencesDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	PreferencesDialog_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_3s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_3s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_5s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_5s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_7s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_7s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_10s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_10s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_15s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_15s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "front_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, front_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, back_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "both_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, both_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preferences_close_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, preferences_close_button));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "device_combo_changed_cb", G_CALLBACK(_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed));
}


static void preferences_dialog_instance_init (PreferencesDialog * self) {
	self->priv = PREFERENCES_DIALOG_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void preferences_dialog_finalize (GObject * obj) {
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->device_combo);
	_g_object_unref0 (self->priv->text_dpi_combo);
	_g_object_unref0 (self->priv->photo_dpi_combo);
	_g_object_unref0 (self->priv->paper_size_combo);
	_g_object_unref0 (self->priv->brightness_scale);
	_g_object_unref0 (self->priv->contrast_scale);
	_g_object_unref0 (self->priv->device_model);
	_g_object_unref0 (self->priv->page_delay_3s_button);
	_g_object_unref0 (self->priv->page_delay_5s_button);
	_g_object_unref0 (self->priv->page_delay_7s_button);
	_g_object_unref0 (self->priv->page_delay_10s_button);
	_g_object_unref0 (self->priv->page_delay_15s_button);
	_g_object_unref0 (self->priv->text_dpi_model);
	_g_object_unref0 (self->priv->photo_dpi_model);
	_g_object_unref0 (self->priv->front_side_button);
	_g_object_unref0 (self->priv->back_side_button);
	_g_object_unref0 (self->priv->both_side_button);
	_g_object_unref0 (self->priv->paper_size_model);
	_g_object_unref0 (self->priv->brightness_adjustment);
	_g_object_unref0 (self->priv->contrast_adjustment);
	_g_object_unref0 (self->priv->preferences_close_button);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}


GType preferences_dialog_get_type (void) {
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}


PageIcon* page_icon_construct (GType object_type, const gchar* text, gdouble r, gdouble g, gdouble b) {
	PageIcon * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	g_return_val_if_fail (text != NULL, NULL);
	self = (PageIcon*) g_object_new (object_type, NULL);
	_tmp0_ = text;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->text);
	self->priv->text = _tmp1_;
	_tmp2_ = r;
	self->priv->r = _tmp2_;
	_tmp3_ = g;
	self->priv->g = _tmp3_;
	_tmp4_ = b;
	self->priv->b = _tmp4_;
	return self;
}


PageIcon* page_icon_new (const gchar* text, gdouble r, gdouble g, gdouble b) {
	return page_icon_construct (TYPE_PAGE_ICON, text, r, g, b);
}


static void page_icon_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width) {
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (PageIcon*) base;
	_vala_natural_width = PAGE_ICON_MINIMUM_WIDTH;
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void page_icon_real_get_preferred_height (GtkWidget* base, gint* minimum_height, gint* natural_height) {
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gdouble _tmp0_;
	self = (PageIcon*) base;
	_tmp0_ = round (PAGE_ICON_MINIMUM_WIDTH * G_SQRT2);
	_vala_natural_height = (gint) _tmp0_;
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void page_icon_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* minimum_height, gint* natural_height) {
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint _tmp0_;
	self = (PageIcon*) base;
	_tmp0_ = width;
	_vala_natural_height = (gint) (_tmp0_ * G_SQRT2);
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void page_icon_real_get_preferred_width_for_height (GtkWidget* base, gint height, gint* minimum_width, gint* natural_width) {
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint _tmp0_;
	self = (PageIcon*) base;
	_tmp0_ = height;
	_vala_natural_width = (gint) (_tmp0_ / G_SQRT2);
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static gboolean page_icon_real_draw (GtkWidget* base, cairo_t* c) {
	PageIcon * self;
	gboolean result = FALSE;
	gint w = 0;
	gint _tmp0_;
	gint h = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_t* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	cairo_t* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_t* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_text_extents_t extents = {0};
	cairo_t* _tmp24_;
	const gchar* _tmp25_;
	cairo_text_extents_t _tmp26_ = {0};
	cairo_t* _tmp27_;
	gint _tmp28_;
	cairo_text_extents_t _tmp29_;
	gdouble _tmp30_;
	gint _tmp31_;
	cairo_text_extents_t _tmp32_;
	gdouble _tmp33_;
	cairo_t* _tmp34_;
	const gchar* _tmp35_;
	self = (PageIcon*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	w = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	h = _tmp1_;
	_tmp2_ = w;
	_tmp3_ = h;
	if ((_tmp2_ * G_SQRT2) > ((gdouble) _tmp3_)) {
		gint _tmp4_;
		gdouble _tmp5_;
		_tmp4_ = h;
		_tmp5_ = round (_tmp4_ / G_SQRT2);
		w = (gint) _tmp5_;
	} else {
		gint _tmp6_;
		gdouble _tmp7_;
		_tmp6_ = w;
		_tmp7_ = round (_tmp6_ * G_SQRT2);
		h = (gint) _tmp7_;
	}
	_tmp8_ = c;
	_tmp9_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp10_ = w;
	_tmp11_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp12_ = h;
	cairo_translate (_tmp8_, (gdouble) ((_tmp9_ - _tmp10_) / 2), (gdouble) ((_tmp11_ - _tmp12_) / 2));
	_tmp13_ = c;
	_tmp14_ = w;
	_tmp15_ = h;
	cairo_rectangle (_tmp13_, 0.5, 0.5, (gdouble) (_tmp14_ - 1), (gdouble) (_tmp15_ - 1));
	_tmp16_ = c;
	_tmp17_ = self->priv->r;
	_tmp18_ = self->priv->g;
	_tmp19_ = self->priv->b;
	cairo_set_source_rgb (_tmp16_, _tmp17_, _tmp18_, _tmp19_);
	_tmp20_ = c;
	cairo_fill_preserve (_tmp20_);
	_tmp21_ = c;
	cairo_set_line_width (_tmp21_, 1.0);
	_tmp22_ = c;
	cairo_set_source_rgb (_tmp22_, 0.0, 0.0, 0.0);
	_tmp23_ = c;
	cairo_stroke (_tmp23_);
	_tmp24_ = c;
	_tmp25_ = self->priv->text;
	cairo_text_extents (_tmp24_, _tmp25_, &_tmp26_);
	extents = _tmp26_;
	_tmp27_ = c;
	_tmp28_ = w;
	_tmp29_ = extents;
	_tmp30_ = _tmp29_.width;
	_tmp31_ = h;
	_tmp32_ = extents;
	_tmp33_ = _tmp32_.height;
	cairo_translate (_tmp27_, ((_tmp28_ - _tmp30_) * 0.5) - 0.5, ((_tmp31_ + _tmp33_) * 0.5) - 0.5);
	_tmp34_ = c;
	_tmp35_ = self->priv->text;
	cairo_show_text (_tmp34_, _tmp35_);
	result = TRUE;
	return result;
}


static void page_icon_class_init (PageIconClass * klass) {
	page_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PageIconPrivate));
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) page_icon_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget *, gint*, gint*)) page_icon_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget *, gint, gint*, gint*)) page_icon_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget *, gint, gint*, gint*)) page_icon_real_get_preferred_width_for_height;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) page_icon_real_draw;
	G_OBJECT_CLASS (klass)->finalize = page_icon_finalize;
}


static void page_icon_instance_init (PageIcon * self) {
	self->priv = PAGE_ICON_GET_PRIVATE (self);
}


static void page_icon_finalize (GObject * obj) {
	PageIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_ICON, PageIcon);
	_g_free0 (self->priv->text);
	G_OBJECT_CLASS (page_icon_parent_class)->finalize (obj);
}


GType page_icon_get_type (void) {
	static volatile gsize page_icon_type_id__volatile = 0;
	if (g_once_init_enter (&page_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageIcon), 0, (GInstanceInitFunc) page_icon_instance_init, NULL };
		GType page_icon_type_id;
		page_icon_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PageIcon", &g_define_type_info, 0);
		g_once_init_leave (&page_icon_type_id__volatile, page_icon_type_id);
	}
	return page_icon_type_id__volatile;
}



